*RealFormat "%.6g"
*IntFormat "%7i"
problem type *GenData(Problem_type)
analysis_type *GenData(Analysis_Type)
*if(strcmp(GenData(Analysis_Type),"Linear_Dynamic")==0)
*#****************LINEAR DYNAMIC ANALYSIS
dynamic_analysis_type *GenData(Dynamic_Analysis_Type)
*# Modal Analysis data
*if(strcmp(GenData(Dynamic_Analysis_Type),"Modal_Analysis")==0)
number_of_modes *GenData(Number_of_Modes)
eigen_max_iter *GenData(Eigensolver_max_iterations)
deltat *GenData(DeltaT)
number_of_steps *GenData(Number_of_steps)
matrix_storage *GenData(Matrix_storage)
damping_type *GenData(Damping_Type)
*if(strcmp(GenData(Damping_Type),"Rayleigh_Damping")==0)
alpha_m *GenData(Alpha_M)
*if((strcmp(GenData(Alpha_K),"0")!=0) && (strcmp(GenData(Matrix_storage),"Lumped")==0))
alpha_k 0.0
*else
alpha_k *GenData(Alpha_K)
*endif
*endif
*if(strcmp(GenData(Damping_Type),"Modal_Damping")==0)
damping_ratio *GenData(Damping_ratio)
*endif
output_step *GenData(Output_Step)
intial_conditions *GenData(Initial_Conditions:)
*if((strcmp(GenData(Write_Displacements),"no")==0) && (strcmp(GenData(Write_Rotations),"no")==0) && (strcmp(GenData(Write_Velocities),"no")==0) && (strcmp(GenData(Write_Accelerations),"no")==0) )
*if((strcmp(GenData(Write_Strengths),"no")==0)  && (strcmp(GenData(Write_Reactions),"no")==0) )
*MessageBox error: It is necesary to write one dynamic result at least.
*endif
*endif
write_displacements *Gendata(Write_Displacements)
write_rotations *Gendata(Write_Rotations)
write_velocities *Gendata(Write_Velocities)
write_accelerations *Gendata(Write_Accelerations)
write_strengths *Gendata(Write_Strengths)
write_reactions *Gendata(Write_Reactions)
*endif
*# Direct integration data
*if(strcmp(GenData(Dynamic_Analysis_Type),"Direct_Integration")==0)
deltat *GenData(DeltaT)
number_of_steps *GenData(Number_of_steps)
gamma *GenData(Gamma)
beta  *GenData(Beta)
matrix_storage *GenData(Matrix_storage)
damping_type *GenData(Damping_Type)
*if(strcmp(GenData(Damping_Type),"Rayleigh_Damping")==0)
alpha_m *GenData(Alpha_M)
*if((strcmp(GenData(Alpha_K),"0")!=0) && (strcmp(GenData(Matrix_storage),"Lumped")==0))
alpha_k 0.0
*else
alpha_k *GenData(Alpha_K)
*endif
*endif
*if(strcmp(GenData(Damping_Type),"Modal_Damping")==0)
*MessageBox error: Only Rayleigh Damping is allowed for Direct Integration.
*endif
output_step *GenData(Output_Step)
intial_conditions *GenData(Initial_Conditions:)
*if((strcmp(GenData(Write_Displacements),"no")==0) && strcmp(GenData(Write_Rotations),"no")==0) && (strcmp(GenData(Write_Velocities),"no")==0) && (strcmp(GenData(Write_Accelerations),"no")==0) )
*if((strcmp(GenData(Write_Strengths),"no")==0)  && (strcmp(GenData(Write_Reactions),"no")==0) )
*MessageBox error: It is necesary to write one dynamic result at least.
*endif
*endif
write_displacements *Gendata(Write_Displacements)
write_rotations *Gendata(Write_Rotations)
write_velocities *Gendata(Write_Velocities)
write_accelerations *Gendata(Write_Accelerations)
write_strengths *Gendata(Write_Strengths)
write_reactions *Gendata(Write_Reactions)
*endif
*# Spectrum Analysis data
*if(strcmp(GenData(Dynamic_Analysis_Type),"Spectrum_Analysis")==0)
number_of_modes *GenData(Number_of_Modes)
eigen_max_iter *GenData(Eigensolver_max_iterations)
matrix_storage *GenData(Matrix_storage)
damping_type *GenData(Damping_Type)
damping_ratio *GenData(Damping_ratio)
spectrum_analysis_type *GenData(Spectrum_Analysis_type)
*if(strcmp(GenData(Spectrum_Analysis_type),"User_defined_spectrum")==0)
*set var n=GenData(Spectrum_Table,INT)
*if(*n>2)
begin_spectral_table
*for(i=1;i<=n/2;i=i+1)
*set var col1=(i-1)*2+1
*set var col2=(i-1)*2+2
*set var col1new=i*2+1
*if(i<n/2)
*set var t=GenData(Spectrum_Table,*col1,real)
*set var tnew=GenData(Spectrum_Table,*col1new,real)
*if(t(real)>=tnew(real))
*MessageBox error: The periods in the spectrum table must be give in ascending order.
*endif
*endif
*GenData(Spectrum_Table,*col1) *GenData(Spectrum_Table,*col2)
*endfor
end_table
jx *GenData(Spectrum_direction_nx)
jy *GenData(Spectrum_direction_ny)
jz *GenData(Spectrum_direction_nz)
*else
*MessageBox error: The spectrum table must have two rows at least.
*endif
*elseif(strcmp(GenData(Spectrum_Analysis_type),"Seismic_codes")==0)
*if(strcmp(GenData(Code_type),"NCSE-94_Spain_Code")==0)
code_type NCSE-94
design_acceleration *GenData(Design_Seismic_Acceleration)
jx *GenData(Seismic_direction_nx)
jy *GenData(Seismic_direction_ny)
jz *GenData(Seismic_direction_nz)
c *GenData(Soil_coefficient)
k *GenData(Contribution_coefficient)
ductility *GenData(Ductility)
*else
*MessageBox error: Other codes are not still availables.
*endif
*endif
*endif
*elseif(strcmp(GenData(Analysis_Type),"Non-Linear_Static")==0)
*#****************NON LINEAR STATIC ANALYSIS
factor_incremental *GenData(Delta_Fac)
number_increments *GenData(Num_inc)
automatic_increment *GenData(Automatic_inc)
*if(strcmp(GenData(Automatic_inc),"Yes")==0)
number_iteration_desider  *GenData(Num_Iter_d)
maxim_load_increment  *GenData(DeltaP_max)
minim_load_increment  *GenData(DeltaP_min)
*endif
control_type *GenData(Control)
*if(strcmp(GenData(Control),"Arc-lenght_Control")==0)
desired_length_inc *GenData(DeltaL_d)
max_lenght_inc *GenData(DeltaL_max)
min_length_inc *GenData(DeltaL_min)
*endif
convergence_tolerance_fact *GenData(Conv._tolerance_static)
iteration_type *GenData(Iteration_type)
maximun_iter_number *GenData(Max_iter)
line_search *GenData(Line-Search)
*if(strcmp(GenData(Line-Search),"Yes")==0)
max_num_ls_loops *GenData(LS-loops)
tolerance_ls *GenData(LS-toler)
min_step_length *GenData(LS-min)
max_step_length *GenData(LS-max)
max_amplitude *GenData(Amp-max)
*endif
auto_arc_switch *GenData(Auto-ARC-switch)
*if(strcmp(GenData(Auto-ARC-switch),"Yes")==0)
desired_current_stiffness *GenData(C_Stif)
*endif
*elseif(strcmp(GenData(Analysis_Type),"Non-Linear_Dynamic")==0)
*#****************NON LINEAR DYNAMIC ANALYSIS
*if(strcmp(GenData(Integration_method),"Implicit")==0)
integration_method implicit
t_0 *GenData(T_0)
*set var numfil(int)=GenData(DeltaT_variation:,int)/2
*if(numfil==0)
*MessageBox error: At least must be one datum
*endif
*set var Totnumbstep(int)=0
*for(ifil=1;ifil<=numfil;ifil=ifil+1)
*set var col1=(ifil-1)*2+1
*set var col2=(ifil-1)*2+2
*set var Totnumbstep=Totnumbstep+GenData(DeltaT_variation:,*col1,int)
*end for
deltat_groups *numfil
*for(ifil=1;ifil<=numfil;ifil=ifil+1)
*set var col1=(ifil-1)*2+1
*set var col2=(ifil-1)*2+2
*set var NUMSTEP=GenData(DeltaT_variation:,*col1,int)
*set var DELTAT=GenData(DeltaT_variation:,*col2,real)
   *NUMSTEP *DELTAT  
*end for
number_of_steps *Totnumbstep
gamma *GenData(Gamma:)
beta  *GenData(Beta:)
matrix_storage *GenData(Matrix-storage)
intial_conditions *GenData(Initial_Conditions)
*if(strcmp(GenData(Initial_Conditions),"Comb._Load_1")==0)
Comb_Load_1_data *GenData(Comb._Load_1_data)
*endif
alpha_m *GenData(Alpha_M:)
alpha_k *GenData(Alpha_K:)
convergence_tolerance_fact *GenData(Conv._tolerance_dynamic)
iteration_type *GenData(Iteration-type)
maximun_iter_number *GenData(Max-iter)
output_step *GenData(Output_Step)
*if((strcmp(GenData(Write_Displacements),"no")==0) && (strcmp(GenData(Write_Rotations),"no")==0) && (strcmp(GenData(Write_Velocities),"no")==0) && (strcmp(GenData(Write_Accelerations),"no")==0) )
*if((strcmp(GenData(Write_Strengths),"no")==0)  && (strcmp(GenData(Write_Reactions),"no")==0) )
*MessageBox error: It is necesary to write one dynamic result at least.
*endif
*endif
write_displacements *Gendata(Write_Displacements)
write_rotations *Gendata(Write_Rotations)
write_velocities *Gendata(Write_Velocities)
write_accelerations *Gendata(Write_Accelerations)
write_strengths *Gendata(Write_Strengths)
write_reactions *Gendata(Write_Reactions)
write_elemdamage *Gendata(Write_ElemDamage)
*elseif(strcmp(GenData(Integration_method),"Explicit")==0)
integration_method explicit
t_0 *GenData(T_0)
deltat *GenData(Delta_T)
number_of_steps *GenData(Number-of-steps)
matrix_storage lumped
intial_conditions *GenData(Initial_Conditions)
*if(strcmp(GenData(Initial_Conditions),"Comb._Load_1")==0)
Comb_Load_1_data *GenData(Comb._Load_1_data)
*endif
alpha_m *GenData(Alpha_M:)
alpha_k 0.0
output_step *GenData(Output_Step)
*if((strcmp(GenData(Write_Displacements),"no")==0) && (strcmp(GenData(Write_Rotations),"no")==0) && (strcmp(GenData(Write_Velocities),"no")==0) && (strcmp(GenData(Write_Accelerations),"no")==0) )
*if((strcmp(GenData(Write_Strengths),"no")==0)  && (strcmp(GenData(Write_Reactions),"no")==0) )
*MessageBox error: It is necesary to write one dynamic result at least.
*endif
*endif
write_displacements *Gendata(Write_Displacements)
write_rotations *Gendata(Write_Rotations)
write_velocities *Gendata(Write_Velocities)
write_accelerations *Gendata(Write_Accelerations)
write_strengths *Gendata(Write_Strengths)
write_reactions *Gendata(Write_Reactions)
write_elemdamage *Gendata(Write_ElemDamage)
*endif
*endif
*#Naval settings
*if(strcmp(GenData(Ship_balance),"yes")==0)
ship_equilibration
perturbation *GenData(Perturbation)
num_iter_equib *GenData(Num_iter_equib)
Toler_equib *GenData(Toler_equib)
*endif

*set var dim=3
# meassure(SI) = fac** meassure(User defined)
units_names
N-m-kg        N    m  Pa       Kg     1.0       1.0      1.0      1.0
N-cm-kg       N   cm  N/cm2    Kg     1.0       1.0e-2   1.0e4    1.0
N-mm-kg       N   mm  N/mm2    Kg     1.0       1.0e-3   1.0e6    1.0
Kp-cm-utm     Kp  cm  Kp/cm2   utm    1.0e1     1.0e-2   1.0e5    1.0e1
kN-m-MPa-ton  kN   m  Mpa      ton    1.0e3     1.0      1.0e6    1.0e3
end units_names
units_mesh *GenData(Mesh_units)
units_res *GenData(Results_units)

combined_load_cases
*if(strcmp(GenData(Activate_Load_Cases),"none")==0)
inactive
*else
active
*endif
*for(i=1;i<=GenData(Combined_load_cases,INT);i=i+3)
*set var im1=i+1
*set var im2=i+2
combined_load *\
name=*GenData(Combined_load_cases,*i) type=*\
*if(GenData(Combined_load_cases,*im1,INT)==1)
strengths
*else
deformation
*endif
*GenData(Combined_load_cases,*im2)
end combined_load
*endfor
end combined_load_cases

GravityDirection=*GenData(Gravity_X) *GenData(Gravity_Y) *GenData(Gravity_Z)
NumOfDivisions=*GenData(Beam_Res_granularity)
*if(strcmp(Gendata(Shell_Internal_6-noded_elem),"yes")==0)
ConvertTo6Nodes
*endif
*if(strcmp(Gendata(Shell_Res_axes),"Both")==0)
MainAndLocalStresses
*elseif(strcmp(Gendata(Shell_Res_axes),"Main_axes")==0)
MainStresses
*endif
*if(strcmp(Gendata(Output_shell_stresses),"yes")==0)
GiveResultsStresses
*endif
OutputBeamsMaximums *Gendata(Output_beams_maximums)
*if(strcmp(Gendata(Solver_type),"Automatic")==0)
*if(strcmp(GenData(Analysis),"Dynamic")==0 && strcmp(GenData(Dynamic_Analysis_Type),"Direct_Integration")!=0)
solver=SkyLine
*else
solver=Automatic
*endif
*elseif(strcmp(Gendata(Solver_type),"SkyLine")==0)
solver=SkyLine
*elseif(strcmp(Gendata(Solver_type),"Sparse")==0)
*if(strcmp(GenData(Analysis),"Dynamic")==0 && strcmp(GenData(Dynamic_Analysis_Type),"Direct_Integration")!=0)
*MessageBox error: For Modal or Spectrum Analysis only SkyLine is solved.
*endif
solver=SparseToni *GenData(Solver_tolerance) *GenData(Solver_tolerance_minimum) *\
*GenData(Solver_max_iterations)
*elseif(strcmp(Gendata(Solver_type),"Sparse_Toni")==0)
*if(strcmp(GenData(Analysis),"Dynamic")==0 && strcmp(GenData(Dynamic_Analysis_Type),"Direct_Integration")!=0)
*MessageBox error: For Modal or Spectrum Analysis only SkyLine is solved.
*endif
solver=SparseToni *GenData(Solver_tolerance) *GenData(Solver_tolerance_minimum) *\
*GenData(Solver_max_iterations)
*endif
*if(strcmp(Gendata(Shell_Smooth_Res),"yes")==0)
*# 20 degrees
DoSmoothing 0.35
*endif
NewPostProcessFormat 1
CoplanarityAngle=5e-3
*if(GenData(Consider_beam_P-Delta,INT)==1)
ConsiderPDelta
*endif
*tcl(SteelSections::OutputCustomSteelSectionsTable)
*#--------------------------------------------------------------------------------
*#    Check elements
*#--------------------------------------------------------------------------------
*if(nelem(Hexahedra))
*MessageBox error: Hexahedra elements are not permitted.
*endif
*set cond Steel_section *elems
*set var numbars(int)=CondNumEntities
*set cond Concrete_rec_section *elems
*set var numbars(int)=numbars+CondNumEntities
*set cond Section *elems
*set var numbars(int)=numbars+CondNumEntities
*set cond Rectangular_Section *elems
*set var numbars(int)=numbars+CondNumEntities
*set cond Naval_Stiffeners *elems
*set var numbars(int)=numbars+CondNumEntities
*set cond Top_Laminate *elems
*set var numbars(int)=numbars+CondNumEntities
*if(numbars>nelem(Linear) && nelem(Linear)==0)
*MessageBox error: There are no beam elements but conditions Section,Rectangular_Section, Steel_section, Concrete_rec_section or Naval_Stiffeners have been used. Use command 'Data->Verify assigned properties'
*elseif(numbars>nelem(Linear))
Total number of assigned conditions=*numbars
Beam elements=*nelem(Linear)
*MessageBox error: Some beams elements have repeated properties condition. Probably have condition 'Section' and/or condition 'Rectangular section' and/or Steel_Section and/or Concrete_rec_section and/or Naval_Stiffeners applied to them. Check file .dat for more information. Use command 'Data->Verify assigned properties'
*elseif(numbars<nelem(Linear))
Total number of assigned conditions=*numbars
Beam elements=*nelem(Linear)
*MessageBox error: Some beams do not have properties condition assigned. Check file .dat for more information. Use command 'Data->Verify assigned properties'
*endif
*set var AreCoordsWritten(int)=0
*#--------------------------------------------------------------------------------
*#    laminate  materials
*#--------------------------------------------------------------------------------
*set cond Laminate_Shell *elems
*if(CondNumEntities>0)
materials
*loop materials *NotUsed
*if(strcmp(matprop(type),"laminate")==0)
*format "%3d"
*matnum Units=*matprop(Units) laminate *matprop(laminate_properties)
*endif
*end materials
end material
*endif

*#--------------------------------------------------------------------------------
*#    plasticity shell materials
*#--------------------------------------------------------------------------------
*set var NumPlasticShell(int)=0
*set cond Shell *elems
*loop elems *OnlyInCond
*if(strcmp(Cond(Constitutive_Model),"Plasticity")==0)
*set var NumPlasticShell(int)=NumPlasticShell+1
*endif
*end
*if(NumPlasticShell>0)
materials
*loop materials *NotUsed
*if(strcmp(matprop(type),"plasticity")==0)
*format "%3d"
*matnum Units=*matprop(Units) plasticity_shell *matprop(Elastic_limit) *\
*if(strcmp(matprop(ISOTROPIC_HARDENING:),"LINEAR")==0)
*matprop(Linear_hardening) 0.0 0.0 *\
*elseif(strcmp(matprop(ISOTROPIC_HARDENING:),"EXPONENTIAL")==0)
0.0 *matprop(Saturation_flow_stress) *matprop(Saturation_hardening_law_exponent) *\
*elseif(strcmp(matprop(ISOTROPIC_HARDENING:),"LINEAR+EXPONENTIAL")==0)
*matprop(Linear_hardening) *matprop(Saturation_flow_stress) *matprop(Saturation_hardening_law_exponent) *\
*elseif(strcmp(matprop(ISOTROPIC_HARDENING:),"NONE")==0)
0.0 0.0 0.0 *\
*endif
*if(strcmp(matprop(KINEMATIC_HARDENING:),"LINEAR")==0)
*matprop(Linear_kinematic_hardening)
*elseif(strcmp(matprop(KINEMATIC_HARDENING:),"NONE")==0)
0.0
*endif
*endif
*end materials
end material
*endif
*#--------------------------------------------------------------------------------
*#    full_anisotropic_shell  materials
*#--------------------------------------------------------------------------------
*set cond Full_anisotropic_shell *elems
*if(CondNumEntities>0)
materials
*loop materials *NotUsed
*if(strcmp(matprop(type),"full_anisotropic_shell")==0)
*matnum Units=*matprop(Units) Dm=*\
*for(ivar=1;ivar<=9;ivar=ivar+1)
*matprop(Dm:(COL1,COL2,COL3),*ivar) *\
*endfor
Df=*\
*for(ivar=1;ivar<=9;ivar=ivar+1)
*matprop(Df,*ivar) *\
*endfor
Dmf=*\
*for(ivar=1;ivar<=9;ivar=ivar+1)
*matprop(Dmf,*ivar) *\
*endfor
Dc=*\
*for(ivar=1;ivar<=4;ivar=ivar+1)
*matprop(Dc,*ivar) *\
*endfor
Weight=*matprop(Weight) *\
Ax=*matprop(Ax) Ay=*matprop(Ay) At=*matprop(At) *\
Wx=*matprop(Wx) Wy=*matprop(Wy) Wt=*matprop(Wt) *\
Atx=*matprop(Atx) Aty=*matprop(Aty) maximum_stress=*matprop(maximum_stress)
*endif
*end materials
end material
*endif
*#--------------------------------------------------------------------------------
*#     Stiffened_shell materials
*#--------------------------------------------------------------------------------
*tcl(stiff::WriteDMatrixInBasFile)
*#--------------------------------------------------------------------------------
*#   custom data
*#--------------------------------------------------------------------------------
*set var num=0
*loop intervals
*# *set cond Volume_Custom_Load *elems
*set cond Surface_Custom_Load *elems
*add cond Line_Custom_Load *elems
*set var num=num+CondNumEntities
*set cond Point_Custom_Load *nodes
*set var num=num+CondNumEntities
*end intervals
*if(num>0)
custom_data
*loop materials *NotUsed
*if(strcmp(matprop(type),"custom_data")==0)
*if(strcmp(matprop(tcl_code),"+")!=0)
*matnum units=*matprop(Units) tcl=*matprop(tcl_code) name=*matprop(0)
*endif
*endif
*end materials
end custom_data
*endif
*#--------------------------------------------------------------------------------
*#   Wave_load data
*#--------------------------------------------------------------------------------
*tcl(wave::WriteCustomLoadInBasFile)
*#--------------------------------------------------------------------------------
*#      linear mesh
*#--------------------------------------------------------------------------------
*if(numbars>0)
*if(IsQuadratic)
*MessageBox error: Beam elements cannot be quadratic.
*endif
mesh dimension = *dim elemtype Linear nnode = 2
coordinates
*loop nodes
*NodesNum *NodesCoord(1) *NodesCoord(2) *\
*if(dim==3)
*NodesCoord(3)
*else

*endif
*end
end coordinates
*set var AreCoordsWritten=1
elements
*set cond Section *elems
*if(dim==2)
*loop elems *OnlyInCond
*elemsnum *elemsConec 0 A=*cond(Area) I=*cond(Inertia_z) E=*cond(E)*\
Weight=*cond(Specific_weight)*\
*if(LocalAxesNum)
*format " Euler1=%.15g Euler2=%.15g Euler3=%.15g"
*LocalAxesDef(EulerAngles)
*else

*endif
*end elems
*else
*loop elems *OnlyInCond
*elemsnum *elemsConec 0 Units=*cond(Units) A=*cond(Area) Iy=*cond(Inertia_y) *\
Iz=*cond(Inertia_z) Wy=*cond(W_y) Wz=*cond(W_z) J=*cond(J) G=*cond(G) E=*cond(E) *\
Weight=*cond(Specific_weight) Aty=*cond(Aty) Atz=*cond(Atz) name=*cond(Name) *\
*if(cond(Maximum_stress,real)>0.0)
Maximum_stress=*cond(Maximum_stress) *\
*endif
*if(LocalAxesNum)
*format " Euler1=%.15g Euler2=%.15g Euler3=%.15g"
*LocalAxesDef(EulerAngles)
*else

*endif
*end elems
*endif
*set cond Naval_Stiffeners *elems
*if(dim==2)
*loop elems *OnlyInCond
*set var matID=matnum(cond(Stiffener))
*loop materials *NotUsed
*if(matnum==matID)
*elemsnum *elemsConec 0 A=*matprop(area) I=*matprop(izz) E=*matprop(e)*\
Weight=*matprop(weight)*\
*break
*endif
*end materials
*if(LocalAxesNum)
*format " Euler1=%.15g Euler2=%.15g Euler3=%.15g"
*LocalAxesDef(EulerAngles)
*else

*endif
*end elems
*else
*loop elems *OnlyInCond
*set var matID=matnum(cond(Stiffener))
*loop materials *NotUsed
*if(matnum==matID)
*elemsnum *elemsConec 0 Units=*matprop(units) A=*matprop(area) Iy=*matprop(iyy) *\
Iz=*matprop(izz) J=*matprop(j) G=*matprop(g) E=*matprop(e) Weight=*matprop(weight)*\
*break
*endif
*end materials
*if(LocalAxesNum)
*format " Euler1=%.15g Euler2=%.15g Euler3=%.15g"
*LocalAxesDef(EulerAngles)
*else

*endif
*end elems
*endif
*set cond Top_Laminate *elems
*if(dim==2)
*loop elems *OnlyInCond
*set var matID=matnum(cond(toplaminate))
*loop materials *NotUsed
*if(matnum==matID)
*elemsnum *elemsConec 0 A=*matprop(area) I=*matprop(i) E=*matprop(e)*\
Weight=*matprop(weight)*\
*break
*endif
*end materials
*if(LocalAxesNum)
*format " Euler1=%.15g Euler2=%.15g Euler3=%.15g"
*LocalAxesDef(EulerAngles)
*else

*endif
*end elems
*else
*loop elems *OnlyInCond
*set var matID=matnum(cond(toplaminate))
*loop materials *NotUsed
*if(matnum==matID)
*elemsnum *elemsConec 0 Units=*matprop(units) A=*matprop(area) Iy=*matprop(iyy) *\
Iz=*matprop(izz) J=*matprop(j) G=*matprop(g) E=*matprop(e) Weight=*matprop(weight)*\
*break
*endif
*end materials
*if(LocalAxesNum)
*format " Euler1=%.15g Euler2=%.15g Euler3=%.15g"
*LocalAxesDef(EulerAngles)
*else

*endif
*end elems
*endif
*set cond Rectangular_Section *elems
*if(dim==2)
*loop elems *OnlyInCond
*elemsnum *elemsConec 0 Units=*cond(Units) *\
widthY=*cond(Width_y) widthZ=*cond(Width_Z) *\
E=*cond(E) Weight=*cond(Specific_weight)*\
*if(LocalAxesNum)
*format " Euler1=%.15g Euler2=%.15g Euler3=%.15g"
*LocalAxesDef(EulerAngles)
*else

*endif
*end elems
end elements
*else
*loop elems *OnlyInCond
*elemsnum *elemsConec 0 Units=*cond(Units) *\
widthY=*cond(Width_y) widthZ=*cond(Width_Z) *\
G=*cond(G) E=*cond(E) Weight=*cond(Specific_weight)*\
*if(LocalAxesNum)
*format " Euler1=%.15g Euler2=%.15g Euler3=%.15g"
*LocalAxesDef(EulerAngles)
*else

*endif
*end elems
*endif (dim==2)
*set cond Concrete_rec_section *elems
*loop elems *OnlyInCond
*elemsnum *elemsConec 0 Units=*cond(Units) *\
widthY=*cond(Width_y) widthZ=*cond(Width_z) *\
HA=*cond(Concrete) *\
*if(LocalAxesNum)
*format " Euler1=%.15g Euler2=%.15g Euler3=%.15g"
*LocalAxesDef(EulerAngles)
*else

*endif
*end elems
*set cond Steel_section *elems
*loop elems *OnlyInCond
*elemsnum *elemsConec 0 Section *cond(SteelName) *\
Steel=*cond(SteelType) *\
*if(LocalAxesNum)
*format " Euler1=%.15g Euler2=%.15g Euler3=%.15g"
*LocalAxesDef(EulerAngles) *\
*endif
*if(cond(Z_axe_position,real)!=0.0)
z_axe=*cond(z_axe_position)cm
*else

*endif
*end elems
end elements
*endif  si hi ha barres
*#--------------------------------------------------------------------------------
*#      shell mesh
*#--------------------------------------------------------------------------------
*set cond Anisotropic_Shell *elems
*add cond Full_anisotropic_Shell *elems
*set var NumAnisotropicElems=CondNumEntities
*set cond Concrete_Shell *elems
*set var NumConcreteElems=CondNumEntities
*set cond Steel_Shell *elems
*set var NumSteelElems=CondNumEntities
*set cond Shell *elems
*set var NumIsotropicElems=CondNumEntities
*set cond Laminate_Shell *elems 
*set var LaminateShell=CondNumEntities
*set cond Stiffened_shell *elems
*set var StiffenedShell=CondNumEntities
*if(NumAnisotropicElems+NumIsotropicElems+NumConcreteElems+NumSteelElems+LaminateShell+StiffenedShell>nelem(Triangle)+nelem(Quadrilateral))
---------------------ERROR--------------------
error: Some triangle or quadrilateral elements have repeated properties condition. 
Probably have condition 'Shell' and/or condition 'Anisotropic shell' and/or 
condition 'Concrete shell' and/or condition 'Steel shell' applied to them.
NumElems=*nelem(Triangle)+*nelem(Quadrilateral)
NumIsotropicElems=*NumIsotropicElems
NumAnisotropicElems=*NumAnisotropicElems
NumConcreteElems=*NumConcreteElems
NumSteelElems=*NumSteelElems
*MessageBox error: Some triangle or quadrilateral elements have repeated properties condition. Probably have condition 'Shell' and/or  condition 'Anisotropic shell' and/or condition 'Concrete shell' and/or condition 'Steel shell' applied to them. Use command 'Data->Verify assigned properties'
*elseif(NumAnisotropicElems+NumIsotropicElems+NumConcreteElems+NumSteelElems+LaminateShell+StiffenedShell<nelem(Triangle)+nelem(Quadrilateral))
*MessageBox error: Some triangles or quadrilaterals do not have properties condition assigned. Use command 'Data->Verify assigned properties'
*endif
*if(nelem(Triangle))
*set elems(Triangle)
*if(IsQuadratic)
*set var nnodetri=6
*else
*set var nnodetri=3
*endif
*#--------------------------------------------------------------------------------
*#      triangle shell mesh
*#--------------------------------------------------------------------------------
mesh dimension = 3 elemtype Triangle nnode = *nnodetri
coordinates
*if(AreCoordsWritten==0)
*loop nodes
*NodesNum *NodesCoord(1) *NodesCoord(2) *NodesCoord(3)
*end
*endif
*set var AreCoordsWritten=1
end coordinates
elements
*set cond Shell *elems
*loop elems *OnlyInCond
*elemsnum *elemsConec *\
*if(strcmp(Cond(Constitutive_Model),"Linear_Elastic")==0)
*elemsmat *\
*elseif(strcmp(Cond(Constitutive_Model),"Plasticity")==0)
*if(strcmp(GenData(Analysis_Type),"Non-Linear_Static")==0 || strcmp(GenData(Analysis_Type),"Non-Linear_Dynamic")==0)
*matnum(Cond(Plasticity_type)) *\
*else
*MessageBox error: The analysis type must be Non-Linear_Static or Non-Linear-Dynamic for this type of material
*endif
*endif
Units=*cond(Units) E=*cond(E) nu=*cond(nu) *\
Weight=*cond(Specific_weight) t=*cond(Thickness) *\
*if(strcmp(Cond(Constitutive_Model),"Plasticity")==0)
Num_layer=*Cond(Num_Layer) *\
*if(strcmp(Cond(Plasticity_type),"J2_Plasticity")==0)
cons_type=J2_Plasticity *\
*endif
*endif
*if(LocalAxesNum)
*format " Euler1=%.15g Euler2=%.15g Euler3=%.15g"
*LocalAxesDef(EulerAngles)
*else

*endif
*end elems
*#--------------------------------------------------------------------------------
*#      triangle Anisotropic shell mesh
*#--------------------------------------------------------------------------------
*set cond Anisotropic_Shell *elems
*loop elems *OnlyInCond
*elemsnum *elemsConec 0 *\
Units=*cond(Units) Ex=*cond(Ex) Ey=*cond(Ey) nuXY=*cond(nuXY) *\
nuYX=*cond(nuYX) Gxy=*cond(Gxy) Gxz=*cond(Gxz) Gyz=*cond(Gyz) *\ 
Weight=*cond(Specific_weight) t=*cond(Thickness) *\
*if(LocalAxesNum)
*format " Euler1=%.15g Euler2=%.15g Euler3=%.15g"
*LocalAxesDef(EulerAngles)
*else

*endif
*end elems
*#--------------------------------------------------------------------------------
*#      triangle concrete shell mesh
*#--------------------------------------------------------------------------------
*set cond Concrete_Shell *elems
*loop elems *OnlyInCond
*elemsnum *elemsConec 0 Units=*cond(Units) t=*cond(Thickness) HA=*cond(Concrete) *\
*if(LocalAxesNum)
*format " Euler1=%.15g Euler2=%.15g Euler3=%.15g"
*LocalAxesDef(EulerAngles)
*else

*endif
*end elems
*#--------------------------------------------------------------------------------
*#      triangle steel shell mesh
*#--------------------------------------------------------------------------------
*set cond Steel_Shell *elems
*loop elems *OnlyInCond
*elemsnum *elemsConec  0 *\
Units=*cond(Units) t=*cond(Thickness) Steel=*cond(Steel) *\
*if(LocalAxesNum)
*format " Euler1=%.15g Euler2=%.15g Euler3=%.15g"
*LocalAxesDef(EulerAngles)
*else

*endif
*end elems
*#--------------------------------------------------------------------------------
*#      triangle laminate shell mesh
*#--------------------------------------------------------------------------------
*set cond Laminate_Shell *elems
*loop elems *OnlyInCond
*elemsnum *elemsConec *matnum(cond(Laminate)) *\
*if(LocalAxesNum)
*format " Euler1=%.15g Euler2=%.15g Euler3=%.15g"
*LocalAxesDef(EulerAngles)
*else

*endif
*end elems
*#--------------------------------------------------------------------------------
*#      triangle Full anisotropic shell mesh
*#--------------------------------------------------------------------------------
*set cond Full_anisotropic_Shell *elems
*loop elems *OnlyInCond
*elemsnum *elemsConec *matnum(cond(Material)) *\
*if(LocalAxesNum)
*format " Euler1=%.15g Euler2=%.15g Euler3=%.15g"
*LocalAxesDef(EulerAngles)
*else

*endif
*end elems
*#--------------------------------------------------------------------------------
*#      triangle  Stiffened_shell mesh
*#--------------------------------------------------------------------------------
*tcl(stiff::WriteTrianglesInBasFile)
end elements
*endif si hi ha shell triangle
*#--------------------------------------------------------------------------------
*#      Quads
*#--------------------------------------------------------------------------------
*if(nelem(Quadrilateral))
*if(IsQuadratic==1)
*set var nnodequad=8
*elseif(IsQuadratic==2)
*set var nnodequad=9
*else
*set var nnodequad=4
*endif
*set elems(Quadrilateral)
mesh dimension = 3 elemtype Quadrilateral nnode = *nnodequad
coordinates
*if(AreCoordsWritten==0)
*loop nodes
*NodesNum *NodesCoord(1) *NodesCoord(2) *NodesCoord(3)
*end
*endif
*set var AreCoordsWritten=1
end coordinates
elements
*#--------------------------------------------------------------------------------
*#      Quad shell mesh
*#--------------------------------------------------------------------------------
*set cond Shell *elems
*loop elems *OnlyInCond
*elemsnum *elemsConec *\
*if(strcmp(Cond(Constitutive_Model),"Linear_Elastic")==0)
0 *\
*elseif(strcmp(Cond(Constitutive_Model),"Plasticity")==0)
*if(strcmp(GenData(Analysis_Type),"Non-Linear_Static")==0 || strcmp(GenData(Analysis_Type),"Non-Linear-Dynamic")==0)
*matnum(Cond(Plasticity_type)) *\
*else
*MessageBox error: The analysis type must be Non-Linear_Static or Non-Linear-Dynamic for this type of material
*endif
*endif
Units=*cond(Units) Ex=*cond(E) Ey=*cond(E) nu=*cond(nu) *\
G=*operation(cond(E,REAL)/(2.0*(1.0+cond(nu,REAL)))) *\
Weight=*cond(Specific_weight) t=*cond(Thickness) *\
*if(strcmp(Cond(Constitutive_Model),"Plasticity")==0)
Num_layer=*Cond(Num_Layer) *\
*if(strcmp(Cond(Plasticity_type),"J2_Plasticity")==0)
cons_type=J2_Plasticity *\
*endif
*endif
*if(LocalAxesNum)
*format " Euler1=%.15g Euler2=%.15g Euler3=%.15g"
*LocalAxesDef(EulerAngles)
*else

*endif
*end elems
*#--------------------------------------------------------------------------------
*#      Quad Anisotropic shell mesh
*#--------------------------------------------------------------------------------
*set cond Anisotropic_Shell *elems
*loop elems *OnlyInCond
*elemsnum *elemsConec *\
*if(strcmp(Cond(Constitutive_Model),"Linear_Elastic")==0)
0 *\
*endif
Units=*cond(Units) Ex=*cond(Ex) Ey=*cond(Ey) nuXY=*cond(nuXY) *\
nuYX=*cond(nuYX) Gxy=*cond(Gxy) Gxz=*cond(Gxz) Gyz=*cond(Gyz) *\ 
Weight=*cond(Specific_weight) t=*cond(Thickness) *\
*if(LocalAxesNum)
*format " Euler1=%.15g Euler2=%.15g Euler3=%.15g"
*LocalAxesDef(EulerAngles)
*else

*endif
*end elems
*#--------------------------------------------------------------------------------
*#      Quad concrete shell mesh
*#--------------------------------------------------------------------------------
*set cond Concrete_Shell *elems
*loop elems *OnlyInCond
*elemsnum *elemsConec 0 Units=*cond(Units) t=*cond(Thickness) HA=*cond(Concrete) *\
*if(LocalAxesNum)
*format " Euler1=%.15g Euler2=%.15g Euler3=%.15g"
*LocalAxesDef(EulerAngles)
*else

*endif
*end elems
*#--------------------------------------------------------------------------------
*#      Quad steel shell mesh
*#--------------------------------------------------------------------------------
*set cond Steel_Shell *elems
*loop elems *OnlyInCond
*elemsnum *elemsConec 0 Units=*cond(Units) t=*cond(Thickness) Steel=*cond(Steel) *\
*if(LocalAxesNum)
*format " Euler1=%.15g Euler2=%.15g Euler3=%.15g"
*LocalAxesDef(EulerAngles)
*else

*endif
*end elems
*#--------------------------------------------------------------------------------
*#      Quad laminate shell mesh
*#--------------------------------------------------------------------------------
*set cond Laminate_Shell *elems
*loop elems *OnlyInCond
*elemsnum *elemsConec *matnum(cond(Laminate)) *\
*if(LocalAxesNum)
*format " Euler1=%.15g Euler2=%.15g Euler3=%.15g"
*LocalAxesDef(EulerAngles)
*else

*endif
*end elems
*#--------------------------------------------------------------------------------
*#      Quad Full anisotropic shell mesh
*#--------------------------------------------------------------------------------
*set cond Full_anisotropic_Shell *elems
*loop elems *OnlyInCond
*elemsnum *elemsConec *matnum(cond(Material)) *\
*if(LocalAxesNum)
*format " Euler1=%.15g Euler2=%.15g Euler3=%.15g"
*LocalAxesDef(EulerAngles)
*else

*endif
*end elems
*#--------------------------------------------------------------------------------
*#      Quad Stiffened_shell mesh
*#--------------------------------------------------------------------------------
*tcl(stiff::WriteQuadsInBasFile)
end elements
*endif si hi ha shell quadrilateral
*#--------------------------------------------------------------------------------
*#  Activating all elements again
*#--------------------------------------------------------------------------------
*set elems(All)
*#--------------------------------------------------------------------------------
*#  constraints
*#--------------------------------------------------------------------------------
constraints
*set cond Surface_Constraints
*add Cond Line_Constraints
*add Cond Point_Constraints
*if(dim==2)
*loop nodes *OnlyInCond
*NodesNum *\
*for(ivar=2;ivar<3;ivar=ivar+1)
*cond(*ivar)*\
*endfor
*cond(7)*\
*format " %g %g %g"
*cond(X_Value,real)*cond(X_Value,real)*cond(Mz_Value,real) *\
units=*cond(Units) *\
*if(LocalAxesNum)
*format " Euler1=%.15g Euler2=%.15g Euler3=%.15g"
*LocalAxesDef(EulerAngles)
*else

*endif
*end
*else
*loop nodes *OnlyInCond
*NodesNum *\
*for(ivar=2;ivar<=7;ivar=ivar+1)
*cond(*ivar)*\
*endfor
*format " %g %g %g %g %g %g"
*cond(9,real)*cond(10,real)*cond(11,real)*cond(12,real)*cond(13,real)*cond(14,real)*\
 units=*cond(Units) *\
*if(LocalAxesNum)
*format " Euler1=%.15g Euler2=%.15g Euler3=%.15g"
*LocalAxesDef(EulerAngles)
*else

*endif
*end
*endif
*set Cond Point_Elastic_Constraints
*loop nodes *OnlyInCond
*NodesNum *\
*for(ivar=2;ivar<=7;ivar=ivar+1)
*if(strcmp(cond(*ivar),"1")==0)
2*\
*else
0*\
*endif
*endfor
*format " %g %g %g %g %g %g"
*cond(9,real)*cond(10,real)*cond(11,real)*cond(12,real)*cond(13,real)*cond(14,real)*\
 units=*cond(Units) *\
*if(LocalAxesNum)
*format " Euler1=%.15g Euler2=%.15g Euler3=%.15g"
*LocalAxesDef(EulerAngles)
*else

*endif
*end
end constraints
*set Cond Point_NL_Elastic_Constraints
*if(CondNumEntities(int)>0)
nl_elastic_constraints
*loop nodes *OnlyInCond
*NodesNum *\
*for(ivar=2;ivar<=7;ivar=ivar+1)
*if(strcmp(cond(*ivar),"None")==0)
0*\
*else
2*\
*endif
*endfor
 *\
*for(ivar=2;ivar<=7;ivar=ivar+1)
*if(strcmp(cond(*ivar),"None")==0)
0*\
*elseif(strcmp(cond(*ivar),"Linear")==0)
1*\
*elseif(strcmp(cond(*ivar),"Comp_only")==0)
2*\
*elseif(strcmp(cond(*ivar),"Tensile_only")==0)
3*\
*elseif(strcmp(cond(*ivar),"Table")==0)
4*\
*endif
*endfor
*if(strcmp(cond(X_Constraint),"None")==0)
 0*\
*elseif(strcmp(cond(X_Constraint),"Table")==0)
*set var matID=matnum(cond(X_Table))
*set var tablenum=0
*loop materials *NotUsed
*if(strcmp(matprop(type),"table")==0)
*set var tablenum=tablenum+1
*if(matnum==matID)
*break
*endif
*endif
*end materials
 *tablenum(real)*\
*else
 *cond(X_Value,real)*\
*endif
*if(strcmp(cond(Y_Constraint),"None")==0)
 0*\
*elseif(strcmp(cond(X_Constraint),"Table")==0)
*set var matID=matnum(cond(Y_Table))
*set var tablenum=0
*loop materials *NotUsed
*if(strcmp(matprop(type),"table")==0)
*set var tablenum=tablenum+1
*if(matnum==matID)
*break
*endif
*endif
*end materials
 *tablenum(real)*\
*else
 *cond(Y_Value,real)*\
*endif
*if(strcmp(cond(Z_Constraint),"None")==0)
 0*\
*elseif(strcmp(cond(Z_Constraint),"Table")==0)
*set var matID=matnum(cond(Z_Table))
*set var tablenum=0
*loop materials *NotUsed
*if(strcmp(matprop(type),"table")==0)
*set var tablenum=tablenum+1
*if(matnum==matID)
*break
*endif
*endif
*end materials
 *tablenum(real)*\
*else
 *cond(Z_Value,real)*\
*endif
*if(strcmp(cond(theta_x_Constraint),"None")==0)
 0*\
*elseif(strcmp(cond(theta_x_Constraint),"Table")==0)
*set var matID=matnum(cond(theta_x_Table))
*set var tablenum=0
*loop materials *NotUsed
*if(strcmp(matprop(type),"table")==0)
*set var tablenum=tablenum+1
*if(matnum==matID)
*break
*endif
*endif
*end materials
 *tablenum(real)*\
*else
 *cond(theta_x_Value,real)*\
*endif
*if(strcmp(cond(theta_y_Constraint),"None")==0)
 0*\
*elseif(strcmp(cond(theta_y_Constraint),"Table")==0)
*set var matID=matnum(cond(theta_y_Table))
*set var tablenum=0
*loop materials *NotUsed
*if(strcmp(matprop(type),"table")==0)
*set var tablenum=tablenum+1
*if(matnum==matID)
*break
*endif
*endif
*end materials
 *tablenum(real)*\
*else
 *cond(theta_y_Value,real)*\
*endif
*if(strcmp(cond(theta_z_Constraint),"None")==0)
 0*\
*elseif(strcmp(cond(theta_z_Constraint),"Table")==0)
*set var matID=matnum(cond(theta_z_Table))
*set var tablenum=0
*loop materials *NotUsed
*if(strcmp(matprop(type),"table")==0)
*set var tablenum=tablenum+1
*if(matnum==matID)
*break
*endif
*endif
*end materials
 *tablenum(real)*\
*else
 *cond(theta_z_Value,real)*\
*endif
 units=*cond(Units) *\
*if(LocalAxesNum)
*format " Euler1=%.15g Euler2=%.15g Euler3=%.15g"
*LocalAxesDef(EulerAngles)
*else

*endif
*end
end nl_elastic_constraints
*endif
*set Cond Surface_Elastic_Constraints
*if(CondNumEntities(int)>0)
elem_constraints
*loop elems *OnlyInCond
*ElemsNum *\
*for(ivar=2;ivar<=7;ivar=ivar+1)
*if(strcmp(cond(*ivar),"1")==0)
2*\
*else
0*\
*endif
*endfor
*format " %g %g %g %g %g %g"
*cond(9,real)*cond(10,real)*cond(11,real)*cond(12,real)*cond(13,real)*cond(14,real)*\
 units=*cond(Units) *\
*if(LocalAxesNum)
*format " Euler1=%.15g Euler2=%.15g Euler3=%.15g"
*LocalAxesDef(EulerAngles)
*else

*endif
*end
end elem_constraints
*endif
*set Cond Surface_NL_Elastic_Constraints
*if(CondNumEntities(int)>0)
elem_nl_elastic_constraints
*loop elems *OnlyInCond
*ElemsNum *\
*for(ivar=2;ivar<=7;ivar=ivar+1)
*if(strcmp(cond(*ivar),"None")==0)
0*\
*else
2*\
*endif
*endfor
 *\
*for(ivar=2;ivar<=7;ivar=ivar+1)
*if(strcmp(cond(*ivar),"None")==0)
0*\
*elseif(strcmp(cond(*ivar),"Linear")==0)
1*\
*elseif(strcmp(cond(*ivar),"Comp_only")==0)
2*\
*elseif(strcmp(cond(*ivar),"Tensile_only")==0)
3*\
*elseif(strcmp(cond(*ivar),"Table")==0)
4*\
*endif
*endfor
*if(strcmp(cond(X_Constraint),"None")==0)
 0*\
*elseif(strcmp(cond(X_Constraint),"Table")==0)
*set var matID=matnum(cond(X_Table))
*set var tablenum=0
*loop materials *NotUsed
*if(strcmp(matprop(type),"table")==0)
*set var tablenum=tablenum+1
*if(matnum==matID)
*break
*endif
*endif
*end materials
 *tablenum(real)*\
*else
 *cond(X_Value,real)*\
*endif
*if(strcmp(cond(Y_Constraint),"None")==0)
 0*\
*elseif(strcmp(cond(X_Constraint),"Table")==0)
*set var matID=matnum(cond(Y_Table))
*set var tablenum=0
*loop materials *NotUsed
*if(strcmp(matprop(type),"table")==0)
*set var tablenum=tablenum+1
*if(matnum==matID)
*break
*endif
*endif
*end materials
 *tablenum(real)*\
*else
 *cond(Y_Value,real)*\
*endif
*if(strcmp(cond(Z_Constraint),"None")==0)
 0*\
*elseif(strcmp(cond(Z_Constraint),"Table")==0)
*set var matID=matnum(cond(Z_Table))
*set var tablenum=0
*loop materials *NotUsed
*if(strcmp(matprop(type),"table")==0)
*set var tablenum=tablenum+1
*if(matnum==matID)
*break
*endif
*endif
*end materials
 *tablenum(real)*\
*else
 *cond(Z_Value,real)*\
*endif
*if(strcmp(cond(theta_x_Constraint),"None")==0)
 0*\
*elseif(strcmp(cond(theta_x_Constraint),"Table")==0)
*set var matID=matnum(cond(theta_x_Table))
*set var tablenum=0
*loop materials *NotUsed
*if(strcmp(matprop(type),"table")==0)
*set var tablenum=tablenum+1
*if(matnum==matID)
*break
*endif
*endif
*end materials
 *tablenum(real)*\
*else
 *cond(theta_x_Value,real)*\
*endif
*if(strcmp(cond(theta_y_Constraint),"None")==0)
 0*\
*elseif(strcmp(cond(theta_y_Constraint),"Table")==0)
*set var matID=matnum(cond(theta_y_Table))
*set var tablenum=0
*loop materials *NotUsed
*if(strcmp(matprop(type),"table")==0)
*set var tablenum=tablenum+1
*if(matnum==matID)
*break
*endif
*endif
*end materials
 *tablenum(real)*\
*else
 *cond(theta_y_Value,real)*\
*endif
*if(strcmp(cond(theta_z_Constraint),"None")==0)
 0*\
*elseif(strcmp(cond(theta_z_Constraint),"Table")==0)
*set var matID=matnum(cond(theta_z_Table))
*set var tablenum=0
*loop materials *NotUsed
*if(strcmp(matprop(type),"table")==0)
*set var tablenum=tablenum+1
*if(matnum==matID)
*break
*endif
*endif
*end materials
 *tablenum(real)*\
*else
 *cond(theta_z_Value,real)*\
*endif
 units=*cond(Units) *\
*if(LocalAxesNum)
*format " Euler1=%.15g Euler2=%.15g Euler3=%.15g"
*LocalAxesDef(EulerAngles)
*else

*endif
*end
end elem_nl_elastic_constraints
*endif
*set Cond Line_Elastic_Constraints
*if(CondNumEntities(int)>0)
elem_constraints
*loop elems *OnlyInCond
*ElemsNum *\
*if(ElemsType!=1)
*Operation(LocalNodes(1)-1) *\
*endif
*for(ivar=2;ivar<=7;ivar=ivar+1)
*if(strcmp(cond(*ivar),"1")==0)
2*\
*else
0*\
*endif
*endfor
*format " %g %g %g %g %g %g"
*cond(9,real)*cond(10,real)*cond(11,real)*cond(12,real)*cond(13,real)*cond(14,real)*\
 units=*cond(Units) *\
*if(LocalAxesNum)
*format " Euler1=%.15g Euler2=%.15g Euler3=%.15g"
*LocalAxesDef(EulerAngles)
*else

*endif
*end
end elem_constraints
*endif
*set Cond Line_NL_Elastic_Constraints
*if(CondNumEntities(int)>0)
elem_nl_elastic_constraints
*loop elems *OnlyInCond
*ElemsNum *\
*if(ElemsType!=1)
*Operation(LocalNodes(1)-1) *\
*endif
*for(ivar=2;ivar<=7;ivar=ivar+1)
*if(strcmp(cond(*ivar),"None")==0)
0*\
*else
2*\
*endif
*endfor
 *\
*for(ivar=2;ivar<=7;ivar=ivar+1)
*if(strcmp(cond(*ivar),"None")==0)
0*\
*elseif(strcmp(cond(*ivar),"Linear")==0)
1*\
*elseif(strcmp(cond(*ivar),"Comp_only")==0)
2*\
*elseif(strcmp(cond(*ivar),"Tensile_only")==0)
3*\
*elseif(strcmp(cond(*ivar),"Table")==0)
4*\
*endif
*endfor
*if(strcmp(cond(X_Constraint),"None")==0)
 0*\
*elseif(strcmp(cond(X_Constraint),"Table")==0)
*set var matID=matnum(cond(X_Table))
*set var tablenum=0
*loop materials *NotUsed
*if(strcmp(matprop(type),"table")==0)
*set var tablenum=tablenum+1
*if(matnum==matID)
*break
*endif
*endif
*end materials
 *tablenum(real)*\
*else
 *cond(X_Value,real)*\
*endif
*if(strcmp(cond(Y_Constraint),"None")==0)
 0*\
*elseif(strcmp(cond(X_Constraint),"Table")==0)
*set var matID=matnum(cond(Y_Table))
*set var tablenum=0
*loop materials *NotUsed
*if(strcmp(matprop(type),"table")==0)
*set var tablenum=tablenum+1
*if(matnum==matID)
*break
*endif
*endif
*end materials
 *tablenum(real)*\
*else
 *cond(Y_Value,real)*\
*endif
*if(strcmp(cond(Z_Constraint),"None")==0)
 0*\
*elseif(strcmp(cond(Z_Constraint),"Table")==0)
*set var matID=matnum(cond(Z_Table))
*set var tablenum=0
*loop materials *NotUsed
*if(strcmp(matprop(type),"table")==0)
*set var tablenum=tablenum+1
*if(matnum==matID)
*break
*endif
*endif
*end materials
 *tablenum(real)*\
*else
 *cond(Z_Value,real)*\
*endif
*if(strcmp(cond(theta_x_Constraint),"None")==0)
 0*\
*elseif(strcmp(cond(theta_x_Constraint),"Table")==0)
*set var matID=matnum(cond(theta_x_Table))
*set var tablenum=0
*loop materials *NotUsed
*if(strcmp(matprop(type),"table")==0)
*set var tablenum=tablenum+1
*if(matnum==matID)
*break
*endif
*endif
*end materials
 *tablenum(real)*\
*else
 *cond(theta_x_Value,real)*\
*endif
*if(strcmp(cond(theta_y_Constraint),"None")==0)
 0*\
*elseif(strcmp(cond(theta_y_Constraint),"Table")==0)
*set var matID=matnum(cond(theta_y_Table))
*set var tablenum=0
*loop materials *NotUsed
*if(strcmp(matprop(type),"table")==0)
*set var tablenum=tablenum+1
*if(matnum==matID)
*break
*endif
*endif
*end materials
 *tablenum(real)*\
*else
 *cond(theta_y_Value,real)*\
*endif
*if(strcmp(cond(theta_z_Constraint),"None")==0)
 0*\
*elseif(strcmp(cond(theta_z_Constraint),"Table")==0)
*set var matID=matnum(cond(theta_z_Table))
*set var tablenum=0
*loop materials *NotUsed
*if(strcmp(matprop(type),"table")==0)
*set var tablenum=tablenum+1
*if(matnum==matID)
*break
*endif
*endif
*end materials
 *tablenum(real)*\
*else
 *cond(theta_z_Value,real)*\
*endif
 units=*cond(Units) *\
*if(LocalAxesNum)
*format " Euler1=%.15g Euler2=%.15g Euler3=%.15g"
*LocalAxesDef(EulerAngles)
*else

*endif
*end
end elem_nl_elastic_constraints
*endif
*#--------------------------------------------------------------------------------
*#  rotules and disconnecting degrees
*#--------------------------------------------------------------------------------
*Set Cond Rotules
*if(CondNumEntities(int)>0)
rotules
*loop nodes *OnlyInCond
*NodesNum
*end
end rotules
*endif
*Set Cond Beam_Rotules
*if(CondNumEntities(int)>0)
# Remember that 0 means rotule and that 1 means rigid
elem_rotules
*loop elems *OnlyInCond
*ElemsNum *\
*if(strcmp(cond(Initial_rotule),"YES")==0 && strcmp(cond(End_rotule),"YES")==0)
00
*elseif(strcmp(cond(Initial_rotule),"YES")==0 && strcmp(cond(End_rotule),"NO")==0)
01
*elseif(strcmp(cond(Initial_rotule),"NO")==0 && strcmp(cond(End_rotule),"YES")==0)
10
*else
11
*endif
*end
end elem_rotules
*endif
*set cond Line_disconnect_degrees *nodes *CanRepeat
*add cond Point_disconnect_degrees *nodes *CanRepeat
*if(CondNumEntities(int)>0)
rotules
*loop nodes *OnlyInCond
*NodesNum *Cond(Disconnect_x_displacement)*Cond(Disconnect_y_displacement)*\
*Cond(Disconnect_z_displacement)*Cond(Disconnect_x_rotation)*Cond(Disconnect_y_rotation)*\
*Cond(Disconnect_z_rotation) name=*cond(Identifier) *\
*if(LocalAxesNum)
*format " Euler1=%.15g Euler2=%.15g Euler3=%.15g"
*LocalAxesDef(EulerAngles)
*else

*endif
*end
end rotules
*endif
*Set Cond Surface_disconnect_Id *elems *CanRepeat
*Add Cond Line_disconnect_Id *elems *CanRepeat
*if(CondNumEntities(int)>0)
elem_rotules
*loop elems *OnlyInCond
*ElemsNum name=*cond(Identifier)
*end
end elem_rotules
*endif
*#--------------------------------------------------------------------------------
*#  masses
*#--------------------------------------------------------------------------------
*Set Cond Point-Mass *nodes
*if(CondNumEntities(int)>0)
nodal_point_mass
*loop nodes *OnlyInCond
*NodesNum *cond(Mass_x) *cond(Mass_y) *cond(Mass_z) *\
*cond(Mom_iner_x) *cond(Mom_iner_y) *cond(Mom_iner_x) *\
Units=*cond(Units)
*end
end nodal_point_mass
*endif
*Set var NumElemMass=0
*Set Cond Beam-Mass *elems
*Set var NumElemMass=NumElemMass+CondNumEntities(int)
*Set Cond Face-Shell-Mass *elems
*Set var NumElemMass=NumElemMass+CondNumEntities(int)
*Set Cond Surface-Shell-Mass *elems
*Set var NumElemMass=NumElemMass+CondNumEntities(int)
*if(NumElemMass(int)>0)
element_mass
*Set Cond Beam-Mass *elems
*if(CondNumEntities(int)>0)
beam_mass
*loop elems *OnlyInCond
*elemsnum *cond(Trasl_Mass) *cond(Mom_iner_x) *cond(Mom_iner_y)  *\
*cond(Mom_iner_z) Units=*cond(Units)
*end
end beam_mass
*endif
*Set Cond Face-Shell-Mass *elems *CanRepeat
*if(CondNumEntities(int)>0)
face_shell_mass
*loop elems *OnlyInCond
*elemsnum *Operation(LocalNodes(1)-1) *cond(Trasl_Mass) *cond(Trasl_Mass) *cond(Trasl_Mass) *\
*cond(Mom_iner_x) *cond(Mom_iner_y) *cond(Mom_iner_x) *\
Units=*cond(Units)
*end
end face_shell_mass
*endif
*Set Cond Surface-Shell-Mass *elems
*if(CondNumEntities(int)>0)
surface_shell_mass
*loop elems *OnlyInCond
*elemsnum *cond(Surface_mass)  *\
Units=*cond(Units)
*end
end surface_shell_mass
*endif
end element_mass
*endif
*#--------------------------------------------------------------------------------
*#  static loads
*#--------------------------------------------------------------------------------
*loop intervals
*Set Cond Global_Beam_Load *elems
*Add Cond Global_Shell_Load *elems
*if(CondNumEntities(int)>0)
static_load
global_pressure_loads
*if(dim==2)
*loop elems *OnlyInCond
*elemsnum *cond(X_Pressure) *cond(Y_Pressure) *\
Units=*cond(Units) name=*IntvData(Interval_name)
*end
*else
*loop elems *OnlyInCond
*elemsnum *cond(X_Pressure) *cond(Y_Pressure) *cond(Z_Pressure) *\
Units=*cond(Units) name=*IntvData(Interval_name)
*end
*endif
end global_pressure_loads
end static_load
*endif
*Set Cond Global_Projected_Shell_Load *elems
*if(CondNumEntities(int)>0)        
static_load        
global_projected_pressure_loads
*loop elems *OnlyInCond
*elemsnum *cond(X_Pressure) *cond(Y_Pressure) *cond(Z_Pressure) *\
Units=*cond(Units) name=*IntvData(Interval_name)
*end
end global_projected_pressure_loads
end static_load
*endif
*Set Cond Shell_Face_Load *elems *CanRepeat
*if(CondNumEntities(int)>0)
static_load
face_loads
*loop elems *OnlyInCond
*elemsnum *Operation(LocalNodes(1)-1) *cond(X_Pressure) *cond(Y_Pressure) *\
*cond(Z_Pressure) *\
Units=*cond(Units) name=*IntvData(Interval_name) *\
*if(LocalAxesNum)
*format " Euler1=%.15g Euler2=%.15g Euler3=%.15g"
*LocalAxesDef(EulerAngles)
*else

*endif
*end
end face_loads
end static_load
*endif
*Set Cond Global_Projected_Beam_Load *elems
*if(CondNumEntities(int)>0)
static_load
global_projected_pressure_loads
*if(dim==2)
*loop elems *OnlyInCond
*elemsnum *cond(X_Pressure) *cond(Y_Pressure) *\
Units=*cond(Units) name=*IntvData(Interval_name)
*end
*else
*loop elems *OnlyInCond
*elemsnum *cond(X_Pressure) *cond(Y_Pressure) *cond(Z_Pressure) *\
Units=*cond(Units) name=*IntvData(Interval_name)
*end
*endif
end global_projected_pressure_loads
end static_load
*endif
*Set Cond Local_Beam_Load *elems
*if(CondNumEntities(int)>0)
static_load
local_pressure_loads
*if(dim==2)
*loop elems *OnlyInCond
*elemsnum *cond(Local_X_Pressure) *cond(Local_Y_Pressure)         *\
Units=*cond(Units) name=*IntvData(Interval_name)
*end
*else
*loop elems *OnlyInCond
*elemsnum *cond(Local_X_Pressure) *cond(Local_Y_Pressure) *\
*cond(Local_Z_Pressure) *cond(Local_Mx_Pressure) *\
Units=*cond(Units) name=*IntvData(Interval_name)
*end
*endif
end local_pressure_loads
end static_load
*endif
*Set Cond Local_Shell_Load *elems
*if(CondNumEntities(int)>0)
static_load
local_pressure_loads
*loop elems *OnlyInCond
*elemsnum *cond(Local_X_Pressure) *cond(Local_Y_Pressure) *\
*cond(Local_Z_Pressure) *\
Units=*cond(Units) name=*IntvData(Interval_name)
*end
end local_pressure_loads
end static_load
*endif
*Set Cond Punctual_Load
*if(CondNumEntities(int)>0)
static_load
nodal_point_loads
*if(dim==2)
*loop nodes *OnlyInCond
*NodesNum *cond(X_Force) *cond(Y_Force) *cond(Mz_Force) *\
Units=*cond(Units) name=*IntvData(Interval_name)
*end
*else
*loop nodes *OnlyInCond
*NodesNum *cond(X_Force) *cond(Y_Force) *cond(Z_Force) *\
*cond(Mx_Force) *cond(My_Force) *cond(Mz_Force) *\
Units=*cond(Units) name=*IntvData(Interval_name)
*end
*endif
end nodal_point_loads
end static_load
*endif
*Set Cond Beam_Temperature *elems
*if(CondNumEntities(int)>0)
static_load
temperature_loads
*loop elems *OnlyInCond
*elemsnum *cond(\u03B1) *cond(\u0394T) name=*IntvData(Interval_name)
*end
end temperature_loads
end static_load
*endif
*Set Cond Surface_Temperature *elems
*if(CondNumEntities(int)>0)
static_load
temperature_loads
*loop elems *OnlyInCond
*elemsnum *cond(\u03B1x) *cond(\u03B1y) *cond(\u0394T) name=*IntvData(Interval_name)
*end
end temperature_loads
end static_load
*endif
*Set Cond Self_weight_Beam
*Add cond Self_weight_shell
*if(CondNumEntities(int)>0)
static_load
self_weight_loads
*loop elems *OnlyInCond
*elemsnum name=*IntvData(Interval_name)
*end
end self_weight_loads
end static_load
*endif
*Set Cond Shell_triangular_face_Load *elems
*if(CondNumEntities(int)>0)
static_load
triangular_face_loads
*loop elems *OnlyInCond
*elemsnum *Operation(LocalNodes(1)-1) *cond(X_pressure_1) *cond(Y_pressure_1) *\
*cond(Z_pressure_1) *cond(X_pressure_2) *cond(Y_pressure_2) *cond(Z_pressure_2) *\
p *cond(X_point_1) *cond(Y_point_1) *cond(Z_point_1) *cond(X_point_2) *cond(Y_point_2) *\
*cond(Z_point_2) *\
Units=*cond(Units) name=*IntvData(Interval_name) *\
*if(LocalAxesNum)
*format " Euler1=%.15g Euler2=%.15g Euler3=%.15g"
*LocalAxesDef(EulerAngles)
*else

*endif
*end
end triangular_face_loads
end static_load
*endif
*Set Cond Shell_triangular_Load *elems
*if(CondNumEntities(int)>0)
static_load
triangular_global_loads
*loop elems *OnlyInCond
*elemsnum *cond(X_pressure_1) *cond(Y_pressure_1) *\
*cond(Z_pressure_1) *cond(X_pressure_2) *cond(Y_pressure_2) *cond(Z_pressure_2) *\
p *cond(X_point_1) *cond(Y_point_1) *cond(Z_point_1) *cond(X_point_2) *cond(Y_point_2) *\
*cond(Z_point_2) *\
Units=*cond(Units) name=*IntvData(Interval_name) *\
*if(LocalAxesNum)
*format " Euler1=%.15g Euler2=%.15g Euler3=%.15g"
*LocalAxesDef(EulerAngles)
*else

*endif
*end
end triangular_global_loads
end static_load
*endif
*Set Cond Shell_hydrostatic_face_Load *elems
*if(CondNumEntities(int)>0)
static_load
hydrostatic_loads
*loop elems *OnlyInCond
*elemsnum *Operation(LocalNodes(1)-1) *cond(Reference_coordinate) *cond(Self_weight_water) *\
Units=*cond(Units) name=*IntvData(Interval_name)
*end
end hydrostatic_loads
end static_load
*endif
*Set Cond Shell_hydrostatic_Load *elems
*if(CondNumEntities(int)>0)
static_load
hydrostatic_loads
*loop elems *OnlyInCond
*elemsnum *cond(Reference_coordinate) *cond(Self_weight_water) *\
Units=*cond(Units) name=*IntvData(Interval_name)
*end
end hydrostatic_loads
end static_load
*endif
*# *Set Cond Volume_Custom_Load *elems
*Add Cond Surface_Custom_Load *elems
*Add Cond Line_Custom_Load *elems
*if(CondNumEntities(int)>0)
static_load
custom_data_elems
*loop elems *OnlyInCond
*ElemsNum *\
*if(ElemIsFace)
*Operation(LocalNodes(1)-1) *\
*endif
*matnum(cond(Material)) name=*IntvData(Interval_name)
*end
end custom_data_elems
end static_load
*endif
*tcl(wave::WriteInBasFile *LoopVar)
*Set Cond Point_Custom_Load *nodes
*if(CondNumEntities(int)>0)
custom_data_nodes
*loop elems *OnlyInCond
*nodesnum *matnum(cond(Material)) name=*IntvData(Interval_name)
*end
end custom_data_nodes
*endif
*end intervals
*#--------------------------------------------------------------------------------
*#  dynamic loads
*#--------------------------------------------------------------------------------
*loop intervals
*Set Cond Dynamic-Point-Load
*if(CondNumEntities(int)>0)
dynamic_loads
dynamic_nodal_point_loads
*loop nodes *OnlyInCond
*if(dim==2)
*NodesNum *cond(X_Force) *cond(Y_Force) *cond(Mz_Force) *\
*else
*NodesNum *cond(X_Force) *cond(Y_Force) *cond(Z_Force) *\
*cond(Mx_Force) *cond(My_Force) *cond(Mz_Force) *\
*endif
Units=*cond(Units) name=*IntvData(Interval_name) *\
*if(strcmp(cond(Function),"Sine/Cosine_Load")==0 )
function=Armonic *\
freq=*cond(Circular_Freq) *\
phi=*cond(Phase_angle) *\
ti=*cond(Initial_Time) *\
tf=*cond(Final_Time)
*else
function=Table *\
tablename=*cond(Load_Table) *\
*set var matID=matnum(cond(Load_Table))
*set var tablenum=0
*loop materials *NotUsed
*if(strcmp(matprop(type),"table")==0)
*set var tablenum=tablenum+1
*if(matnum==matID)
*break
*endif
*endif
*end materials
*format "%3d"
tablenum=*tablenum
*endif
*end
end dynamic_nodal_point_loads
end dynamic_loads
*endif
*Set Cond Dyn._Global_Beam_Load *elems
*Add Cond Dyn._Global_Shell_Load *elems
*if(CondNumEntities(int)>0)
dynamic_loads
dynamic_global_pressure_loads
*loop elems *OnlyInCond
*if(dim==2)
*elemsnum *cond(X_Pressure) *cond(Y_Pressure) *\
*else
*elemsnum *cond(X_Pressure) *cond(Y_Pressure) *cond(Z_Pressure) *\
*endif
Units=*cond(Units) name=*IntvData(Interval_name) *\
*if(strcmp(cond(Function),"Sine/Cosine_Load")==0 )
function=Armonic *\
freq=*cond(Circular_Freq) *\
phi=*cond(Phase_angle) *\
ti=*cond(Initial_Time) *\
tf=*cond(Final_Time)
*else
function=Table *\
tablename=*cond(Load_Table) *\
*set var matID=matnum(cond(Load_Table))
*set var tablenum=0
*loop materials *NotUsed
*if(strcmp(matprop(type),"table")==0)
*set var tablenum=tablenum+1
*if(matnum==matID)
*break
*endif
*endif
*end materials
*format "%3d"
tablenum=*tablenum
*endif
*end
end dynamic_global_pressure_loads
end dynamic_loads
*endif
*Set Cond Dyn._Shell_Face_Load *elems *CanRepeat
*if(CondNumEntities(int)>0)
dynamic_loads
dynamic_face_loads
*loop elems *OnlyInCond
*elemsnum *Operation(LocalNodes(1)-1) *cond(X_Pressure) *cond(Y_Pressure) *\
*cond(Z_Pressure) *\
Units=*cond(Units) name=*IntvData(Interval_name) *\
*if(LocalAxesNum)
*format " Euler1=%.15g Euler2=%.15g Euler3=%.15g"
*LocalAxesDef(EulerAngles) *\
*else
*endif
*if(strcmp(cond(Function),"Sine/Cosine_Load")==0 )
function=Armonic *\
freq=*cond(Circular_Freq) *\
phi=*cond(Phase_angle) *\
ti=*cond(Initial_Time) *\
tf=*cond(Final_Time)
*else
function=Table *\
tablename=*cond(Load_Table) *\
*set var matID=matnum(cond(Load_Table))
*set var tablenum=0
*loop materials *NotUsed
*if(strcmp(matprop(type),"table")==0)
*set var tablenum=tablenum+1
*if(matnum==matID)
*break
*endif
*endif
*end materials
*format "%3d"
tablenum=*tablenum
*endif
*end
end dynamic_face_loads
end dynamic_loads
*endif
*Set Cond Dyn._Blast_Shell_Load *elems *CanRepeat
*if(CondNumEntities(int)>0)
dynamic_loads
dynamic_blast_load
*loop elems *OnlyInCond
*elemsnum *cond(X_bomb) *cond(Y_bomb) *cond(Z_bomb) *\
*cond(Weigth_bomb) *\
Units=*cond(Units) name=*IntvData(Interval_name)
*end
end dynamic_blast_load
end dynamic_loads
*endif
*Set Cond Dyn._Local_Beam_Load *elems
*if(CondNumEntities(int)>0)
dynamic_loads
dynamic_local_pressure_loads
*loop elems *OnlyInCond
*if(dim==2)
*elemsnum *cond(Local_X_Pressure) *cond(Local_Y_Pressure)  *\
*else
*elemsnum *cond(Local_X_Pressure) *cond(Local_Y_Pressure) *\
*cond(Local_Z_Pressure) *cond(Local_Mx_Pressure) *\
*endif
Units=*cond(Units) name=*IntvData(Interval_name)
*if(strcmp(cond(Function),"Sine/Cosine_Load")==0 )
function=Armonic *\
freq=*cond(Circular_Freq) *\
phi=*cond(Phase_angle) *\
ti=*cond(Initial_Time) *\
tf=*cond(Final_Time)
*else
function=Table *\
tablename=*cond(Load_Table) *\
*set var matID=matnum(cond(Load_Table))
*set var tablenum=0
*loop materials *NotUsed
*if(strcmp(matprop(type),"table")==0)
*set var tablenum=tablenum+1
*if(matnum==matID)
*break
*endif
*endif
*end materials
*format "%3d"
tablenum=*tablenum
*endif
*end
end dynamic_local_pressure_loads
end dynamic_loads
*endif
*Set Cond Dyn._Local_Shell_Load *elems
*if(CondNumEntities(int)>0)
dynamic_loads
dynamic_local_pressure_loads
*loop elems *OnlyInCond
*elemsnum *cond(Local_X_Pressure) *cond(Local_Y_Pressure) *\
*cond(Local_Z_Pressure) *\
Units=*cond(Units) name=*IntvData(Interval_name) *\
*if(strcmp(cond(Function),"Sine/Cosine_Load")==0 )
function=Armonic *\
freq=*cond(Circular_Freq) *\
phi=*cond(Phase_angle) *\
ti=*cond(Initial_Time) *\
tf=*cond(Final_Time)
*else
function=Table *\
tablename=*cond(Load_Table) *\
*set var matID=matnum(cond(Load_Table))
*set var tablenum=0
*loop materials *NotUsed
*if(strcmp(matprop(type),"table")==0)
*set var tablenum=tablenum+1
*if(matnum==matID)
*break
*endif
*endif
*end materials
*format "%3d"
tablenum=*tablenum
*endif
*end
end dynamic_local_pressure_loads
end dynamic_loads
*endif
*end intervals
*#--------------------------------------------------------------------------------
*#    Initial Conditions
*#--------------------------------------------------------------------------------
*Set Cond Surfaces_Initial_Conditions
*Add Cond Lines_Initial_Conditions
*Add Cond Points_Initial_Conditions
*if(CondNumEntities(int)>0)
*if(strcmp(GenData(Analysis),"Linear_Static")==0  || strcmp(GenData(Analysis),"Non-Linear_Static")==0 )
*MessageBox error: The initial conditions are conditions only for dynamic analysis
*endif
*if(strcmp(GenData(Analysis),"Linear_Dynamic")==0)
*if(strcmp(GenData(Dynamic_Analysis_Type),"Spectrum_Analysis")==0)
*MessageBox error: The initial conditions are conditions only for Modal Analysis or Direct Integration.
*endif
*if(strcmp(GenData(Initial_Conditions:),"None")==0 || strcmp(GenData(Initial_Conditions:),"Comb._Load_1")==0)
*MessageBox error: For assign Initial_conditions to any entities the question Initial_Conditions: in Problem Data must be set to User_Defined.
*endif
*elseif(strcmp(GenData(Analysis),"Non-Linear_Dynamic")==0)
*if(strcmp(GenData(Initial_Conditions),"None")==0 || strcmp(GenData(Initial_Conditions),"Comb._Load_1")==0)
*MessageBox error: For assign Initial_conditions to any entities the question Initial_Conditions in Problem Data must be set to User_Defined.
*endif
*endif
initial_conditions
*loop nodes *OnlyInCond
*NodesNum *cond(Disp_x) *cond(Disp_y) *cond(Disp_z) *cond(Vel_x) *cond(Vel_y) *cond(Vel_z) Units=*cond(Units)
*end
end initial_conditions
*else
*if(strcmp(GenData(Analysis),"Linear_Dynamic")==0 || strcmp(GenData(Analysis),"Non-Linear_Dynamic")==0)
*if(strcmp(GenData(Initial_Conditions:),"User_Defined")==0 || strcmp(GenData(Initial_Conditions:),"User_Defined")==0)
*MessageBox error: Are not assign then Initial_conditions to any entities
*endif
*endif
*endif
*#--------------------------------------------------------------------------------
*#    Detailed results
*#--------------------------------------------------------------------------------
*set cond Point_Detailed_results
*add Cond Line_Detailed_results
*if(CondNumEntities>0)
detailed_results
*loop nodes *OnlyInCond
*NodesNum *cond(Id)
*end
end detailed_results
*endif
*if(GenData(Shell_integration_sections,int)>=7)
detailed_results
*for(i=1;i<=GenData(Shell_integration_sections,int)/7;i=i+1)
*set var ipos1=(i-1)*7+1
*set var ipos2=ipos1+1
*set var ipos3=ipos1+2
*set var ipos4=ipos1+3
*set var ipos5=ipos1+4
*set var ipos6=ipos1+5
*set var ipos7=ipos1+6
shell_section *GenData(Shell_integration_sections,*ipos1) *\
*GenData(Shell_integration_sections,*ipos2),*\
*GenData(Shell_integration_sections,*ipos3),*\
*GenData(Shell_integration_sections,*ipos4) *\
*GenData(Shell_integration_sections,*ipos5),*\
*GenData(Shell_integration_sections,*ipos6),*\
*GenData(Shell_integration_sections,*ipos7)
*end for
end detailed_results
*endif
*#---------------------------------------------------------------------------------------
*# Tablas
*#---------------------------------------------------------------------------------------
*set var AreThereTables=0
*loop materials *NotUsed
*if(strcmp(matprop(type),"table")==0)
*if(strcmp(matprop(Table),"1")==0)
*set var nreg=matprop(Table_Interpolation_Values,int)/2
*if(nreg!=0)
*set var AreThereTables=AreThereTables+1
*endif
*endif
*endif
*end materials
*loop materials *NotUsed
*if(strcmp(matprop(type),"table")==0)
*if(strcmp(matprop(Table),"1")==0 && AreThereTables!=0)
*set var nreg=matprop(Table_Interpolation_Values,int)/2
*if(nreg>0)
table
tablename=*matprop(0) *\
*format "%3d"
nregistros=*nreg
*for(i=1;i<=nreg;i=i+1)
*if(strcmp(matprop(Table_Interpolation_Values,*i),"none")!=0)
*set var regt=(i-1)*2+1
*set var regf=regt+1
*matprop(Table_Interpolation_Values,*regt,real) *matprop(Table_Interpolation_Values,*regf,real)
*endif
*end for
end table
*endif
*endif
*endif
*end materials

