# rambshell.tcl  -*- TCL -*-
#         $Id: rambshell.tcl,v 1.91 2006/09/20 15:46:22 ramseriescvs Exp $        
#---------------------------------------------------------------------------
#This file is written in TCL lenguage 
#For more information about TCL look at: http://www.tcl.tk
#
#At least two procs must be in this file:
#
#    InitGIDProject dir - Will be called whenever a project is begun to be used.
#           where dir is the project's directory
#    EndGIDProject - Will be called whenever a project ends to be used.
#
#For more information about GID internals, check the program scripts.
#---------------------------------------------------------------------------

package require base64

set ::debug 0
if { $::debug } {
    lappend ::auto_path ~/mytcltk
}

global GidPriv

if { ![ info exist GidPriv(VerifImage)]} {
    #set GidPriv(VerifImage) [ image create photo -file $GIDDEFAULT/bitmaps/verif.gif]
    set GidPriv(VerifImage) [ image create photo -data {
	R0lGODlhEAAQAKUAANqwAKWFAO/BAP/OAPLCAOO3AOK1APzPAM6lAP7QAOW4AN+zAP//AP/2
	ALyXAPnJAPvLAFxKAMihAP/fAP/4AKuKAO/AAP/RANasAH1kANetAP/eAP/3AJZ4AP/QAP3L
	AHtjANesAP/hANitANWrAIVqANmuAP/gAPfGAPPDAIBnAP/PAP7OANGnAIFoANarAP7ZAPLD
	AHJcAK6MAJx9AP///////////////////////////////////////////yH5BAEKAD8ALAAA
	AAAQABAAAAZYwJ9wSCwaj8jkD6AkBgTN4SAqJBSohgMVkVAQFz9Gg+h4QIgRyYTBoAgrlgum
	mNFs2JxOwfM5gkIibCMfFyRIJSYnDCgeKUoqJiIrLC1NLi8wMVQyMzRHQQA7
    }
    ]
}
if { ![ info exist GidPriv(VerifNoImage)]} {
    #set GidPriv(VerifNoImage) [ image create photo -file $GIDDEFAULT/bitmaps/verif_no.gif]
    set GidPriv(VerifNoImage) [ image create photo -data {
	R0lGODlhEAAQAIAAAP///////yH5BAEKAAEALAAAAAAQABAAAAIOjI+py+0Po5y02ouzPgUA
	Ow==
    }
    ]
}

proc MyBitmaps { dir { type "DEFAULT INSIDELEFT"} } {
    global MyBitmapsNames MyBitmapsCommands MyBitmapsHelp ProblemTypePriv ProgramName


    set MyBitmapsNames(0) "images/constraints.gif images/connections.gif images/l1.gif \
	    images/loads.gif images/section.gif images/section-steel.gif images/concrete.gif \
	    images/laminate.gif images/prdata.gif --- images/drawconstraints.gif \
	    images/drawloads.gif images/drawproperties.gif --- images/mesh.gif \
	    images/calc.gif images/info.gif images/stop.gif"
    set MyBitmapsCommands(0) [list [list -np- GidOpenConditions Constraints] \
	    [list -np- GidOpenConditions Connections] \
	    {} [list -np- GidOpenConditions "Static Loads"] \
	    [list -np- GidOpenConditions "General properties"] \
	    [list -np- GidOpenConditions "Steel properties"] \
	    [list -np- GidOpenConditions "Concrete properties"] \
	    [list -np- GidOpenConditions "Laminate"] \
	    [list -np- GidOpenProblemData "Problem data"] \
	    {} [list -np- LoadCasesDraw constraints] \
	    [list -np- LoadCasesDraw loads] \
	    [list -np- LoadCasesDraw properties] \
	    {} "Meshing generate" \
	    "Utilities Calculate" "-np- PWViewOutput" \
	    [list Utilities CancelProcess]]

    set MyBitmapsHelp(0) [list [= "Assign constraints"] [= "Assign inter-element connections"] {} \
		              [= "Assign static loads"] \
		              [= "Assign section/material Properties"] \
		              [= "Assign section/material Properties for steel sections"] \
		              [= "Assign section/material Properties for concrete sections"] \
		              [= "Assign section/material Properties for laminates"] \
		              [= "Problem data" "" "Draw constraints and connections " "Draw loads"] \
		              [= "Draw properties"] \
		              "" [= "Generate mesh"] [= "Calculate"] \
		              [= "View process info"] \
	    [= {Cancel calculation process}]]
    
    set MyBitmapsNames(0,2) ""
    set MyBitmapsCommands(0,2) ""

    # prefix values:
    #          Pre        Only active in the preprocessor
    #          Post       Only active in the postprocessor
    #          PrePost    Active Always

    set prefix Pre
    set - [= "Rambshell bar"] ;# only for translations, to pick the sentence
    set - [= "Ramsolid bar"]

    set ProblemTypePriv(toolbarwin) [CreateOtherBitmaps RamSeriesBar "My toolbar" \
	    MyBitmapsNames MyBitmapsCommands \
	    MyBitmapsHelp $dir "MyBitmaps [list $dir]" $type $prefix]
    AddNewToolbar "$ProgramName bar" ${prefix}RamSeriesBarWindowGeom \
	"MyBitmaps [list $dir]" [= "$ProgramName bar"]

    # button number 3
    set ProblemTypePriv(loadcasewin) $ProblemTypePriv(toolbarwin).2

    if { [info exists ProblemTypePriv(loadcaseimg1)] } {
	ChangeToLoadCase 1
    }

}

proc EndMyBitmaps {} {
    global ProblemTypePriv ProgramName
    
    ReleaseToolbar "$ProgramName bar"
    rename MyBitmaps ""
    
    catch { destroy $ProblemTypePriv(toolbarwin) }
}

############################################################################
#   Changed Language
############################################################################
proc ChangedLanguage { language } {
    global ProblemTypePriv
    # Update Menus
    UpdateMenusRamseries 
    # Update Tool Bar
    MyBitmaps $ProblemTypePriv(problemtypedir)
}

proc UpdateMenusRamseries {  } {
    global MenuNames MenuEntries MenuCommands MenuAcceler
    global MenuNamesP MenuEntriesP MenuCommandsP MenuAccelerP
    global ProgramName VersionNumber ProblemTypePriv

    set dir $ProblemTypePriv(problemtypedir)

### comprobacin versin (carpeta con aplicaciones "extra")    ###
    set flag 0
    set module [file join $dir modules]
    set prueba [file join $module SHIPEX]

    if {[file exists $prueba]} {
	set flag 1
    }

    set num [lsearch $MenuNamesP [_ "View results"]]
    if { $num == -1 } {
	WarnWin [= "RamSeries is not compatible with this GiD version"]
	return
    }
    
    catch {
	#Splash $dir
    }
    
    foreach i [array names MenuEntriesP $num,*] { unset MenuEntriesP($i) }
    foreach i [array names MenuCommandsP $num,*] { unset MenuCommandsP($i) }
    set MenuEntriesP($num) ""
    set MenuCommandsP($num) "-np- CreatePostProcessMenu %W"
    
    set ipos [lsearch $MenuNames [_ Calculate]]
    if { $ipos != -1 } {
	lappend MenuEntries($ipos) --- [= "Cancel results"]
	lappend MenuCommands($ipos) "" [list -np- RamSeriesCancelResults]
	lappend MenuAcceler($ipos) "" ""
    }
    
    set ipos [lsearch $MenuNames [_ Help]]
    
    if { $ipos != -1 && [lsearch $MenuEntries($ipos) [= "RAM Series tutorials"]] == -1 } {
	set MenuEntries($ipos) [linsert $MenuEntries($ipos) 0 [= "RAM Series tutorials"] \
		[= "RAM Series help"] --- ]
	
	set MenuCommands($ipos) [linsert $MenuCommands($ipos) 0 \
		[list -np- HelpWindow "CUSTOM_HELP_FILE" \
		    [file join $dir ../info_ramseries ramseries_tutorials.html]] \
		[list -np- HelpWindow "CUSTOM_HELP_REFERENCE" \
		    [file join $dir ../info_ramseries ramseries_toc.html] \
		    [file join $dir ../info_ramseries title.html]] ""]
	set MenuAcceler($ipos) [linsert $MenuAcceler($ipos) 0 "" "" ""]
	
	lappend MenuEntries($ipos) [= "About RAM Series"]
	lappend MenuCommands($ipos) [list -np- Splash $dir 0]
	lappend MenuAcceler($ipos) ""
    }
    
    set ipos [lsearch $MenuNamesP [_ Help]]
    
    if { $ipos != -1 && [lsearch $MenuEntriesP($ipos) [= "RAM Series tutorials"]] == -1 } {
	set MenuEntriesP($ipos) [linsert $MenuEntriesP($ipos) 0 [= "RAM Series tutorials"] \
		[= "RAM Series help"] --- ]
	
	set MenuCommandsP($ipos) [linsert $MenuCommandsP($ipos) 0 \
		[list -np- HelpWindow "CUSTOM_HELP_FILE" \
		    [file join $dir ../info_ramseries ramseries_tutorials.html]] \
		[list -np- HelpWindow "CUSTOM_HELP_REFERENCE" \
		    [file join $dir ../info ramseries_toc.html] \
		    [file join $dir ../info_ramseries title.html]] ""]
	set MenuAccelerP($ipos) [linsert $MenuAccelerP($ipos) 0 "" "" ""]
	
	lappend MenuEntriesP($ipos) [= "About RAM Series"]
	lappend MenuCommandsP($ipos) [list -np- Splash $dir 0]
	lappend MenuAccelerP($ipos) ""
    }
    
    set meshname [_ {Meshing}]
    set ipos [lsearch $MenuNames $meshname]
    if { $ipos == -1 } {
	set meshname [_ {Mesh}]
	set ipos [lsearch $MenuNames $meshname]
    }
    if { $ipos != -1 } {
	lappend MenuEntries($ipos) "---"
	lappend MenuCommands($ipos) ""
	lappend MenuAcceler($ipos) ""
	
	lappend MenuEntries($ipos) "[= {Scale assigned sizes}]..."
	lappend MenuCommands($ipos) [list -np- ScaleMeshSizes]
	lappend MenuAcceler($ipos) ""
    }
    
    GidChangeDataLabel  "Data units" ""
    GidChangeDataLabel  "Interval" ""
    GidChangeDataLabel  "Conditions" ""
    GidChangeDataLabel  "Materials" ""
    GidChangeDataLabel  "Interval Data" ""
    GidChangeDataLabel  "Problem Data" ""
    
    GidAddUserDataOptions [= "Constraints"] "GidOpenConditions Constraints " 2
    GidAddUserDataOptions [= "Connections"] "GidOpenConditions Connections " 3
    GidAddUserDataOptions "---" "" 4
    GidAddUserDataOptions [= "Masses"] "GidOpenConditions Masses" 5
    GidAddUserDataOptions [= "Initial_Conditions"] "GidOpenConditions Initial_Conditions" 6
    GidAddUserDataOptions "---" "" 7
    GidAddUserDataOptions [= "Load cases"] "LoadCaseWindow" 8
    GidAddUserDataOptions [= "Static loads"] "GidOpenConditions {Static Loads}" 9
    GidAddUserDataOptions [= "Dynamic loads"] "GidOpenConditions {Dynamic Loads}" 10
    GidAddUserDataOptions [= "Wave loads"] "GidOpenConditions {Wave loads}" 11
    GidAddUserDataOptions "---" "" 12
    GidAddUserDataOptions [= "General properties"] "GidOpenConditions {General properties}" 13
    GidAddUserDataOptions [= "Steel properties"] "GidOpenConditions {Steel properties}" 14
    GidAddUserDataOptions [= "Concrete properties"] "GidOpenConditions {Concrete properties}" 15
    GidAddUserDataOptions [= "Laminate properties"] "GidOpenConditions {Laminate}" 16
    GidAddUserDataOptions [= "Stiffened shells"] "GidOpenConditions {Stiffeners}" 17
    
    GidAddUserDataOptions "---" "" 18
    GidAddUserDataOptions [= "Problem data"] "GidOpenProblemData {Problem data}" 19
    GidAddUserDataOptions "---" "" 20
    GidAddUserDataOptionsMenu [= "Advanced..."] [list CreateAdvancedMenu %W $dir] 21
    GidAddUserDataOptions [= "Entities reports..."] [list RamReports::CreatePre] 22
    GidAddUserDataOptions [= "Verify assigned properties"] VerifyPropertyElements 23
    GidAddUserDataOptions "---" "" 24
    
    if { $flag == 1 } {
	GidAddUserDataOptions [= "Blast load SHIPEX"] "GidOpenConditions {SHIPEX Loads}" 25
    }
    catch {
	GidShowBook materials "" 0
	GidShowBook intvdata "" 0
    }

    if { [lsearch $MenuNamesP "RamSeries"] == -1 } {
	set num [lsearch $MenuNamesP [_ Help]]
	if { $num == -1 } {
	    WarnWin [= "RamSeries is not compatible with this GiD version -a-"]
	    return
	}
	set num_m1 [expr $num+1]
	foreach i [array names MenuEntriesP $num*] {
	    set rest ""
	    regexp {^[0-9]*(.*)$} $i {} rest
	    set MenuEntriesP($num_m1$rest) $MenuEntriesP($i)
	    unset MenuEntriesP($i)
	    set MenuCommandsP($num_m1$rest) $MenuCommandsP($i)
	    unset MenuCommandsP($i)
	    set MenuAccelerP($num_m1$rest) $MenuAccelerP($i)
	    unset MenuAccelerP($i)
	}
	set MenuNamesP [linsert $MenuNamesP $num "RamSeries"]
	
	set MenuEntriesP($num) [list [= "Entities report..."]]
	
	set MenuCommandsP($num) [list [list -np- RamReports::CreatePost]]
	set MenuAccelerP($num) [list ""]
    }
    
    UpdateMenus
#     CreateTopMenus

}

#############################################################################
proc InitGIDProject { dir } {
    global MenuNames MenuEntries MenuCommands MenuAcceler
    global MenuNamesP MenuEntriesP MenuCommandsP MenuAccelerP
    global ProgramName VersionNumber ProblemTypePriv

    set ProgramName Rambshell
    set VersionNumber 5.5

### comprobacin versin (carpeta con aplicaciones "extra")    ###
    set flag 0
    set module [file join $dir modules]
    set prueba [file join $module SHIPEX]

    if {[file exists $prueba]} {
	set flag 1
    }

    catch { unset ProblemTypePriv }

    set ProblemTypePriv(problemtypedir) $dir

    lappend ::auto_path [file join $dir scripts] [file join $dir .. exec]
    lappend ::auto_path [file join $dir modules]

    
    source [file join $dir scripts [string tolower $ProgramName]-2.tcl]

    foreach i [list Concrete.tbe rtflib.tbe HelpViewer.tbe pmesh.tbe SteelSections.tbe \
	    supergrid.tbe Reports.tbe concreter.tbe dimensioner.tbe DrawSections.tbe  \
	    composite.tbe ramsections.tbe stiffeners.tbe \
	    PostLaminate.tbe Function.tbe buttontable.tbe tkwidgetwindows.tbe \
	    drawgraph.tbe stiffS.tbe waveS.tbe toplam.tbe tdynutils.tbe] {
	uplevel \#0 [list loadtbefile [file join $dir scripts $i]]
    }
    if { $flag == 1 } {
	foreach i [list shipexplode.tbe] {
	    uplevel \#0 [list loadtbefile [file join $module SHIPEX $i]]
	}
    }
#     if { [info command base64::encode] eq "" } {
#         loadtbefile [file join $dir scripts base64.tbe]
#     }

    if { [catch {
	LoadCasesInit $dir
    }] } {
	WarnWin [= "RamSeries is not compatible with this GiD version -a-"]
	return
    }

    MyBitmaps $dir

    set ProblemTypePriv(PropertyToPost) [.central.s info variables PropertyToPost]
    if { $ProblemTypePriv(PropertyToPost) != "Layer" } {
	.central.s process escape escape escape escape Utilities Variables PropertyToPost \
		Layer escape escape
    }

  
    global GidPriv
    set GidPriv(ProgName) $ProgramName
    ChangeWindowTitle
    
    UpdateMenusRamseries
    UpdateRamSeriesContextualMenu
#     CreateTopMenus

    drawopengl registercond DrawSections::drawSectionCond Rectangular_Section Section \
	Concrete_rec_section Steel_section
    drawopengl registercond DrawSections::drawLoadCond Global_Beam_Load \
	Global_Projected_Beam_Load

    foreach book [list Laminate_shell Naval_Stiffeners Tables \
	    Full_anisotropic_shell Custom_data Top_Laminate] {
	GiD_DataBehaviour materials $book hide [list assign draw unassign]
    }

    set file [file join $dir scripts structurescripts structures.tcl]
    if { [file exists $file] } {
	source [file join $dir scripts structurescripts structures.tcl]
	set dir [file join $dir scripts structurescripts]
	block::InitProject $dir
	set ProblemTypePriv(cajonmode) 1
    } else {
	set ProblemTypePriv(cajonmode) 0
    }

    catch {
	lappend ::auto_path /TclTk
	uplevel #0 [list source [file join $dir scripts sqldata.tcl]]
	bind .gid <Control-x><Control-e> rsdata::write_file
	bind .gid <Control-x><Control-f> [list rsdata::write_file andcalc]
    }

    #set handle [drawopengl register DrawOpenGL]
}

proc UpdateRamSeriesContextualMenu { } {

    catch {
	ContextualEntity::RegisterUserDataCommand RamSeriesAddDataItemsToMenu
    }
}
proc AppendMenuOptionPre { ipos entry { command "" } { acceler "" } { icon "" } } {
    global MenuNames MenuEntries MenuCommands MenuAcceler MenuIcons
    
    lappend MenuEntries($ipos) $entry
    lappend MenuCommands($ipos) $command
    lappend MenuAcceler($ipos) $acceler
    lappend MenuIcons($ipos) $icon
}

proc AppendMenuOptionPost { ipos entry { command "" } { acceler "" } { icon "" } } {
    global MenuNamesP MenuEntriesP MenuCommandsP MenuAccelerP MenuIconsP
    
    lappend MenuEntriesP($ipos) $entry
    lappend MenuCommandsP($ipos) $command
    lappend MenuAccelerP($ipos) $acceler
    lappend MenuIconsP($ipos) $icon
}

proc DrawOpenGL {} {
    set beamcolor [list .8 .8 .8]
    drawopengl draw -color $beamcolor \
	-begin lines  -vertex "0 0 0" -vertex "30 0 0" -vertex "0 0 0" -vertex "0 30 0" -end
    for { set x 0 } { $x <= 100 } { set x [expr {$x+1}] } {
	if { $x%10 == 0 } {
	    set deltay 100
	    set deltaym -1
	} else {
	    set deltay .2
	    set deltaym [expr {-.2}]
	}
	drawopengl draw -color $beamcolor \
	    -begin lines  -vertex "$x $deltaym 0" -vertex "$x $deltay 0" -end
	drawopengl draw -color $beamcolor \
	    -begin lines  -vertex "$deltaym $x 0" -vertex "$deltay $x 0" -end
	if { $x%10 == 0 } {
	    drawopengl draw -color {0 0 0} -rasterpos "$x $deltaym 0"
	    drawopengl drawtext [format %.1f "$x"]
	    if { $x != 0 } {
		drawopengl draw -color {0 0 0} -rasterpos "$deltaym $x 0"
		drawopengl drawtext [format %.1f "$x"]
	    }
	}
    }
}

proc EndGIDProject {} {
    global ProblemTypePriv
    EndMyBitmaps

#      if { [info exists ProblemTypePriv(PropertyToPost)] && \
#              $ProblemTypePriv(PropertyToPost) != "Layer" } {
#          .central.s process escape escape escape escape Utilities Variables PropertyToPost \
#                  $ProblemTypePriv(PropertyToPost) escape escape
#      }

    if { [info exists ProblemTypePriv(condfuns)] } {
	foreach i $ProblemTypePriv(condfuns) {
	    rename $i {}
	    rename $i-base $i
	}
    }
    catch { destroy .gid.loadcases }
#     foreach i [list PostCmdAssignMat DWDrawMaterials DWUnassignMat] {
#         if { [info command RamSeries$i] != "" } {
#             rename $i ""
#             rename RamSeries$i $i
#         }
#     }

    # Borramos el contenido de SelectGIDBatFile
    proc SelectGIDBatFile {} {
    }
    #     global GidPriv
    set GidPriv(ProgName) GiD
    ChangeWindowTitle ""

    catch {
	ContextualEntity::UnRegisterUserDataCommand
    }
}

proc SaveGIDProject { file } {
    global ProblemTypePriv

    if { $ProblemTypePriv(cajonmode) } {
	block::SaveDefaults
	block::Save $file
    }
}

proc LoadGIDProject { file } {
    global ProblemTypePriv

    if { [info exists ProblemTypePriv(cajonmode)] && $ProblemTypePriv(cajonmode) } {
	block::OpenDefaults
	block::Open $file
    }
}

# proc EndGIDCalculation { name local_or_remote error error_file } {
#     global ProblemTypePriv
# 
#     if { $ProblemTypePriv(cajonmode) } {
#         set dir $::ProblemTypePriv(problemtypedir)
#         block::InitWindow [file join $dir scripts structurescripts] 5 1
#     }
# }

proc BeforeRunCalculation { batfilename basename dir problemtypedir gidexe args } {
    global ProblemTypePriv

    if { $ProblemTypePriv(cajonmode) } {
	block::calculate_advanceBar 0
	
	set numLC [expr {[lindex [GidUtils::GetProblemDataValue Combined_load_cases] 1]/3}]
	set totalbytes [expr {1427+360*$numLC}]
	set file [file join $dir $basename.info]
	CalcAdvanceBar $totalbytes $file
    }
}

proc AfterRunCalculation { basename dir problemtypedir where error errorfilename } {
     global ProblemTypePriv

    if { $ProblemTypePriv(cajonmode) } {
	if { $error } {
	    catch { after cancel $::CalcAdvanceBar_after }
	    block::calculate_advanceBar 100
	    return
	}
	set dir $::ProblemTypePriv(problemtypedir)
	block::ReadGidSectionsIntegrals [file join $dir scripts structurescripts]
	catch { after cancel $::CalcAdvanceBar_after }
	block::calculate_advanceBar 100
	block::CalculateReinforcement $dir "calculate"
	#set block::goto 5
	set block::goto 3
	block::InitWindow [file join $dir scripts structurescripts]
	return "nowindow"
    }
}

proc InitGIDPostProcess {} {
    global BarresPriv
    global ProblemTypePriv
    global MenuNamesP MenuEntriesP MenuCommandsP

    set num [lsearch $MenuNamesP [_ "View results"]]
    foreach i [array names MenuEntriesP $num,*] { unset MenuEntriesP($i) }
    foreach i [array names MenuCommandsP $num,*] { unset MenuCommandsP($i) }
    set MenuEntriesP($num) ""
    set MenuCommandsP($num) "-np- CreatePostProcessMenu %W"
    catch { unset BarresPriv(problemtype) }
    set BarresPriv(EnteringPost) 1

    set dir $ProblemTypePriv(problemtypedir)
    #set dir [lindex [.central.s info Project] 1].gid

    set num [lsearch $MenuNamesP "RamSeries"]
    set is_dyn [IsDynamicAnalysis]
    if {$is_dyn == 0 && [lsearch $MenuEntriesP($num) "---"] == -1} {
	lappend MenuEntriesP($num)   --- [= "Dimension concrete"] [= "Steel report"]
	
       lappend MenuCommandsP($num)  {} [list -np- DimensionConcrete $dir] \
		                       [list -np- ViewSteelReport $dir]
       lappend MenuAccelerP($num) "" "" ""
    }

}
proc EndGIDPostprocess {} {
}
proc CreateAdvancedMenu { menu dir } {

    if { [$menu index end] ne "none" } { return }
    $menu add command -label [= "Advanced problem data"] -command \
	[list GidOpenProblemData {Advanced}]
    $menu add separator
    foreach "name book" [list [= "Laminate shell"] Laminate_shell \
	    [= "Naval Stiffeners"] Naval_Stiffeners \
	    [= "Tables"] Tables \
	    [= "Full anysotropic shell"] Full_anisotropic_shell \
	    [= "Custom data"] Custom_data] {
	$menu add command -label $name -command \
	    [list GidOpenMaterials $book]
    }
    $menu add command -label [= "Detailed results"] -command \
	[list GidOpenConditions "Detailed results"]
    $menu add separator
    $menu add command -label [= "Tdyn Pressures"] -command \
	[list Pmesh::Main $dir]

}

proc IsDynamicAnalysis {} {
    set is_dyn 0
    set num_step_total 0
    set alla [.central.s info postprocess get all_analisis]
    foreach i $alla {
      set all_step [.gid.central.s info post get all_steps $i]
      set num_step [llength $all_step]
      set num_step_total [expr $num_step_total+$num_step]             
    }
    if {$num_step_total > [llength $alla]} {
      set is_dyn 1
    }
    return $is_dyn
}

# proc HelpOnRamSeries { dir } {



#     WarnWin [join [list "To obtain help for RAM Series, check in directory: " \
#             "'[file dirname $dir]' for a file called RamSeries.pdf"] ""]

# }


proc Splash { dir { autodestroy 1 } } {
    global GIDDEFAULT VersionNumber ProgramName

    if { [.gid.central.s disable windows] } { return }

    if { [ winfo exist .splash]} {
	destroy .splash
	update
    }

    toplevel .splash
    wm withdraw .splash
	
    set im [image create photo -file [ file join $dir images \
	    [string tolower $ProgramName]-open.gif]]
    set x [expr [winfo screenwidth .splash]/2-[image width $im]/2]
    set y [expr [winfo screenheight .splash]/2-[image height $im]/2]

    wm geom .splash +$x+$y
    wm transient .splash .gid
    wm overrideredirect .splash 1
    pack [label .splash.l -image $im -relief ridge -bd 2]
    
    label .splash.lv -text $VersionNumber -font "times 32"
    place .splash.lv -x 70 -y 150
    bind .splash <1> "destroy .splash"
    bind .splash <KeyPress> "destroy .splash"
    grab .splash
    focus .splash
    update
    wm deiconify .splash
    raise .splash .gid
    update
    if { $autodestroy } {
	after 2000 "if { [ winfo exist .splash] } { 
	    destroy .splash
	}"
    }
}

proc ViewSteelReport { dir } {

    set projdir [ConcretePrefs::GiveProjectDir]
    if { $projdir != "" } {
	set basename [file root [file tail $projdir]]
	set filename [file join $projdir ${basename}_steel.html]
    } else {
	WarnWin [= "There is no report to visualize"]
	return
    }

    if { ![file exists $filename] } {
	WarnWin [= "There is no report to visualize"]
	return
    }
    set top .gid
    set x [expr [winfo x $top]+[winfo width $top]/2-350]
    set y [expr [winfo y $top]+[winfo height $top]/2-300]
    set geom 650x600+${x}+$y
    
    HelpWindowRam -geomhelp $geom -tt -title [= "Steel report"] -win .gid.steelreport $filename
    
}

proc SetVarsForBeams {} {
    global MenuEntriesP MenuCommandsP MenuNamesP

    set curr [.central.s info postprocess get cur_analisis]
    set cstep [.central.s info post get cur_step $curr]

    set restypes [.central.s info postprocess get results_list Contour_Fill $curr $cstep]

    set num [lsearch $MenuNamesP [_ "View results"]]

    foreach i [array names MenuEntriesP $num,*] {
	unset MenuEntriesP($i)
    }
    foreach i [array names MenuCommandsP $num,*] {
	unset MenuCommandsP($i)
    }
    set MenuEntriesP($num) ""
    set MenuCommandsP($num) ""
    
    if { [lsearch $restypes Z'_Momentus*] != -1 } {

	lappend MenuEntriesP($num) [= "Beam Diagrams"]

	lappend MenuCommandsP($num) {}
    }

    if { [lsearch $restypes Displacements*] != -1 } {
	lappend MenuEntriesP($num) [= Deformed]
	lappend MenuCommandsP($num) {-np- DisplayDeformed}
    }
    
    if { [lsearch $restypes BDisplacements*] != -1 } {
	lappend MenuEntriesP($num) [= "Beam displacements"]
	if { [lsearch $restypes BDisplacements_min*] != -1 } {
	   lappend MenuCommandsP($num) {}
	} else {
	   lappend MenuCommandsP($num) {-np- DisplayVectorLineDiagram BDisplacements}
	}
    }

    if { [lsearch $restypes BVelocities*] != -1 } {
	lappend MenuEntriesP($num) [= "Beam velocities"]
	if { [lsearch $restypes BVelocities_min*] != -1 } {
	   lappend MenuCommandsP($num) {}
	} else {
	   lappend MenuCommandsP($num) {-np- DisplayVectorLineDiagram BVelocities}
	}
    }

    if { [lsearch $restypes BAcceler*] != -1 } {
	lappend MenuEntriesP($num) [= "Beam accelerations"]
	if { [lsearch $restypes BAcceler_min*] != -1 } {
	   lappend MenuCommandsP($num) {}
	} else {
	   lappend MenuCommandsP($num) {-np- DisplayVectorLineDiagram BAcceler}
	}
    }


    if { [lsearch $restypes Reactions*] != -1 } {
	lappend MenuEntriesP($num) [= Reactions]
	lappend MenuCommandsP($num) {}
    }

    lappend MenuEntriesP($num) {Local axes}
    lappend MenuCommandsP($num) {-np- DisplayLocalAxes "beam" }


    if { [lsearch $restypes Max_Beam_Stresses*] != -1 } {
	set ip [llength $MenuEntriesP($num)]
	lappend MenuEntriesP($num) [= "Stresses (Max)"]
	lappend MenuCommandsP($num)  ""
	set MenuEntriesP($num,$ip) {Sx Txy Txz}
	foreach j $MenuEntriesP($num,$ip) {
	    lappend MenuCommandsP($num,$ip) "-np- DisplayContourFill Max_Beam_Stresses $j"
	}
    }

    lappend MenuEntriesP($num) --- [= "No results"]
    lappend MenuCommandsP($num) {} {-np- StopResults} 

    if { [lsearch $restypes Resistance_factor] != -1 } {
	set MenuEntriesP($num) [linsert $MenuEntriesP($num) end-2 [= "Steel Resistance factor"]]
	set MenuCommandsP($num) [linsert $MenuCommandsP($num) end-2 ""]
	set idx [expr [llength $MenuCommandsP($num)]-3]
	set MenuEntriesP($num,$idx) [list [= Regions] [= Values]]
	set MenuCommandsP($num,$idx) [list "-np- DisplayContourRanges Resistance_factor \
		   Resistance_factor" "-np- DisplayContourFill Resistance_factor \
		   Resistance_factor"]
    }
    
    set res "Axial_Force Y'_Shear Z'_Shear Torsor Y'_Momentus Z'_Momentus"
    set resp "B_Axial_Force Y'_Shear Z'_Shear Torsor Y'_Momentus Z'_Momentus"

    set ipos [lsearch $MenuEntriesP($num) [= "Beam Diagrams"]]
    if { $ipos != -1  }  {
	if {[lsearch $restypes Z'_Momentus_min*]!= -1 } {
	   set MenuEntriesP($num,$ipos) "$res"
	   set MenuCommandsP($num,$ipos) ""
	   set ic 0
	   foreach i $resp {
	       set MenuEntriesP($num,$ipos,$ic) "Min Max --- Both"
	       set MenuCommandsP($num,$ipos,$ic) [list "-np- DisplayVectorLineDiagram ${i}_min" \
		                               "-np- DisplayVectorLineDiagram ${i}_max" \
		                               {} "-np- DisplayVectorLineDiagram ${i}"]
	       incr ic
	   }
	} else {
	   set MenuEntriesP($num,$ipos) "$res"
	   set MenuCommandsP($num,$ipos) ""
	   foreach i $resp {
	       lappend MenuCommandsP($num,$ipos) "-np- DisplayVectorLineDiagram $i"
	   }
	}
    }

   set ipos [lsearch $MenuEntriesP($num) [= "Beam displacements"]]
   if { $ipos != -1 &&  [lsearch $restypes BDisplacements_min*]!= -1}  {
       set MenuEntriesP($num,$ipos) "[= Min] [= Max] --- [= Both]"
	   set MenuCommandsP($num,$ipos) [list "-np- DisplayVectorLineDiagram BDisplacements_min" \
		                               "-np- DisplayVectorLineDiagram BDisplacements_max" \
		                               {} "-np- DisplayVectorLineDiagram BDisplacements"]
   
   }

    set ipos [lsearch $MenuEntriesP($num) [= "Reactions"]]
    if { $ipos != -1 } {

	set MenuEntriesP($num,$ipos) [list [= Force] [= Momentus] [= Compose] --- [= "Force x"] \
		                          [= "Force y"] [= "Force z"]]
	set MenuCommandsP($num,$ipos) { \
		                            {-np- DisplayVectors Reactions |Reactions|} \
		                            {-np- DisplayVectors M_Reactions "|M_Reactions|"} \
		                            {-np- AddReactionsWindow}  \
		                            {} {-np- DisplayVectors Reactions Px} \
		                            {-np- DisplayVectors Reactions Py} \
		                            {-np- DisplayVectors Reactions Pz} } 
    }
}

proc AddVarsForBeams {} {
    global MenuNamesP MenuEntriesP MenuCommandsP
    
    set curr [.central.s info postprocess get cur_analisis]
    set cstep [.central.s info post get cur_step $curr]

    set restypes [.central.s info postprocess get results_list Contour_Fill $curr $cstep]

    set num [lsearch $MenuNamesP [_ "View results"]]

    lappend MenuEntriesP($num) ---
    lappend MenuCommandsP($num) {}

    if { [lsearch $restypes Z'_Momentus*] != -1 } {
	lappend MenuEntriesP($num) [= {Beam Diagrams}]
	lappend MenuCommandsP($num)  {} 
    }

    if { [lsearch $restypes BDisplacements*] != -1 } {
	lappend MenuEntriesP($num) [= {Beam displacements} ]
	lappend MenuCommandsP($num) {-np- DisplayVectorLineDiagram BDisplacements} 
    }

    if { [lsearch $restypes BVelocities*] != -1 } {
	lappend MenuEntriesP($num) [= {Beam velocities} ]
	lappend MenuCommandsP($num) {-np- DisplayVectorLineDiagram BVelocities} 
    }

    if { [lsearch $restypes BAcceler*] != -1 } {
	lappend MenuEntriesP($num) [= {Beam accelerations} ]
	lappend MenuCommandsP($num) {-np- DisplayVectorLineDiagram BAcceler} 
    }

    lappend MenuEntriesP($num) [= {Beam Local axes}]
    lappend MenuCommandsP($num)  {-np- DisplayLocalAxes "beam"}

    if { [lsearch $restypes Resistance_factor] != -1 } {
	lappend MenuEntriesP($num) [= "Resistance factor"]
	lappend MenuCommandsP($num) "-np- DisplayContourFill \
		   Resistance_factor Resistance_factor"
    }
    if { [lsearch $restypes Max_Beam_Stresses*] != -1 } {
	set ip [llength $MenuEntriesP($num)]
	lappend MenuEntriesP($num) [= "Beam stresses (Max)"]
	lappend MenuCommandsP($num)  ""
	set MenuEntriesP($num,$ip) {Sx Txy Txz}
	foreach j $MenuEntriesP($num,$ip) {
	    lappend MenuCommandsP($num,$ip) "-np- DisplayContourFill Max_Beam_Stresses $j"
	}
    }
    
    set res "Axial_Force Y'_Shear Z'_Shear Torsor Y'_Momentus Z'_Momentus"
    set resp "B_Axial_Force Y'_Shear Z'_Shear Torsor Y'_Momentus Z'_Momentus"
    
    set ipos [lsearch $MenuEntriesP($num) {Beam Diagrams}]

    if { $ipos != -1 } {
	if { [lsearch $restypes Z'_Momentus_min*] == -1 } {
	    set MenuEntriesP($num,$ipos) "$res"
	    set MenuCommandsP($num,$ipos) ""
	    foreach i $resp {
		lappend MenuCommandsP($num,$ipos) "-np- DisplayVectorLineDiagram $i"
	    }
	} else {
	    set MenuEntriesP($num,$ipos) "$res"
	    set MenuCommandsP($num,$ipos) ""
	    set ic 0
	    foreach i $resp {
		set MenuEntriesP($num,$ipos,$ic) "[= Min] [= Max] --- [= Both]"
		set MenuCommandsP($num,$ipos,$ic) [list "-np- DisplayVectorLineDiagram ${i}_min" \
		                                       "-np- DisplayVectorLineDiagram ${i}_max" \
		                                       {} "-np- DisplayVectorLineDiagram ${i}"]
		incr ic
	    }
	}
    }
}

proc AddVibrationModes {} {
    global MenuNamesP MenuEntriesP MenuCommandsP
    
	
    if { [catch {
	set restypes [.central.s info postprocess get results_list Contour_Fill \
		          "_Vibration_modes" 1]
    }] } {
	if { [catch {
	set restypes [.central.s info postprocess get results_list Contour_Fill \
		          "_Vibration_modes" 0]
	}] } {
	return
    }
    }

    set num [lsearch $MenuNamesP [_ "View results"]]

    if { [llength $restypes] } {
	lappend MenuEntriesP($num) --- [= "Vibration modes"]
	lappend MenuCommandsP($num) {} {}

	set ipos [lsearch $MenuEntriesP($num) [= "Vibration modes"]]
	set inum 1
	foreach i $restypes {
	    lappend MenuEntriesP($num,$ipos) $i
	    lappend MenuCommandsP($num,$ipos) "-np- DisplayDeformedVibrationModes $i"
	}
    }
}

proc SetVarsForShellsXY {} {
    global MenuNamesP MenuEntriesP MenuCommandsP

    set num [lsearch $MenuNamesP [_ "View results"]]
    
    foreach i [array names MenuEntriesP $num,*] {
	unset MenuEntriesP($i)
    }
    foreach i [array names MenuCommandsP $num,*] {
	unset MenuCommandsP($i)
    }

    set names0 [list [= Displacements] [= {Axial Force}] [= Momentus] [= Shear] --- \
		                [= Deformed] [= Reactions] [= {Local axes}] [= {No results}] --- \
		                [= {Integrate/graphs}]]
    set res0 [list Displacements {Axial Force} Momentus Shear --- \
		                Deformed Reactions {Local axes} {No results} --- \
		                {Integrate/graphs}]
    set MenuEntriesP($num) $names0

    set MenuCommandsP($num) { {} {} {} {} {} {-np- DisplayDeformed} \
	    {} {-np- DisplayLocalAxes "shell"} \
	    {-np- StopResults} {} {-np- IntegrateWindow} }
   

    set names(0) [list X Y Z [= |Displacements|]]
    set res1(0) [list X Y Z |Displacements|]
    set names(1) { Nx' Ny' Nxy' }
    set res1(1) { Nx' Ny' Nxy' }
    set names(2) { Mx' My' Mxy' }
    set res1(2) { Mx' My' Mxy' }
    set names(3) { Qx' Qy' }
    set res1(3) { Qx' Qy' }

    for {set i 0} {$i<4} {incr i} {
	set MenuEntriesP($num,$i) $names($i)
	foreach j $res1($i) {
	    lappend MenuCommandsP($num,$i) "-np- DisplayContourFill [lindex $res0 $i] $j"
	}
    }

    set MenuEntriesP($num,6) [list [= Force] [= Momentus] [= Compose] --- [= "Force x"] \
		                  [= "Force y"] [= "Force z"]]

    set MenuCommandsP($num,6) { \
	    {-np- DisplayVectors Reactions |Reactions|} \
	    {-np- DisplayVectors M_Reactions "|M_Reactions|"} \
	    {-np- AddReactionsWindow}  \
	    {} {-np- DisplayVectors Reactions Px} \
	    {-np- DisplayVectors Reactions Py} \
	    {-np- DisplayVectors Reactions Pz} } 
}

proc SetVarsForSolids {} {
    global MenuNamesP MenuEntriesP MenuCommandsP

    set curr [.central.s info postprocess get cur_analisis]
    set cstep [.central.s info post get cur_step $curr]

    set restypes [.central.s info postprocess get results_list Contour_Fill $curr $cstep]

    set num [lsearch $MenuNamesP [_ "View results"]]


    foreach i [array names MenuEntriesP $num,*] {
	unset MenuEntriesP($i)
    }
    foreach i [array names MenuCommandsP $num,*] {
	unset MenuCommandsP($i)
    }

    set MenuEntriesP($num) ""
    set MenuCommandsP($num) ""

    set ip 0
    if { [lsearch $restypes Displacements*] != -1 } {
	lappend MenuEntriesP($num) "Displacements" 
	lappend MenuCommandsP($num) ""

	set MenuEntriesP($num,$ip) [list Disp_X Disp_Y Disp_Z [= |Displacements|]]
	set res { Disp_X Disp_Y Disp_Z |Displacements|}
	foreach j $res {
	    lappend MenuCommandsP($num,$ip) "-np- DisplayContourFill Displacements $j"
	}
	incr ip
    }

    if { [lsearch $restypes Velocities*] != -1 } {
	lappend MenuEntriesP($num) "Velocities" 
	lappend MenuCommandsP($num) ""

	set MenuEntriesP($num,$ip) [list Vel_X Vel_Y Vel_Z [= |Velocities|]]
	set res { Vel_X Vel_Y Vel_Z |Velocities|}
	foreach j $res {
	    lappend MenuCommandsP($num,$ip) "-np- DisplayContourFill Velocities $j"
	}
	incr ip
    }

    if { [lsearch $restypes Accelerations*] != -1 } {
	lappend MenuEntriesP($num) "Accelerations" 
	lappend MenuCommandsP($num) ""

	set MenuEntriesP($num,$ip) [list Accel_X Accel_Y Accel_Z [= |Accelerations|]]
	set res { Accel_X Accel_Y Accel_Z |Accelerations|}
	foreach j $MenuEntriesP($num,$ip) {
	    lappend MenuCommandsP($num,$ip) "-np- DisplayContourFill Accelerations $j"
	}
	incr ip
    }


    lappend MenuEntriesP($num) [= Stresses] 

    lappend MenuCommandsP($num) {} 

    
    if { [lsearch $restypes Von_Misses*] != -1 } {
	    lappend MenuEntriesP($num) [= {Von Misses}] 
	    lappend MenuCommandsP($num) {-np- DisplayContourFill Von_Misses Von_Misses}
    } elseif { [lsearch $restypes Rankine*] != -1 } {
	    lappend MenuEntriesP($num) [= {Rankine}] 
	    lappend MenuCommandsP($num) {-np- DisplayContourFill Rankine Rankine}
    }
    
    lappend MenuEntriesP($num)  --- [= Deformed] [= Reactions] --- [= {No results}]

    lappend MenuCommandsP($num) {} {-np- DisplayDeformed} {} {} {-np- StopResults}


    set MenuEntriesP($num,$ip) {Sx Sy Sz Txy Txz Tyz Si-Stresses Sii-Stresses Siii-Stresses}

    foreach j $MenuEntriesP($num,$ip) {
       lappend MenuCommandsP($num,$ip) "-np- DisplayContourFill Stresses $j"
    }

    incr ip 4

    set MenuEntriesP($num,$ip) [list [= Force] [= Compose] --- [= "Force x"] [= "Force y"] \
		                  [= "Force z"]]

    set MenuCommandsP($num,$ip) { \
	    {-np- DisplayVectors Reactions |Reactions|} \
	{-np- AddReactionsWindow} \
	    {} {-np- DisplayVectors Reactions Px} \
	{-np- DisplayVectors Reactions Py} \
	    {-np- DisplayVectors Reactions Pz} }
}


proc SetVarsForShellsMain {} {
    global MenuNamesP MenuEntriesP MenuCommandsP

    set num [lsearch $MenuNamesP [_ "View results"]]

    foreach i [array names MenuEntriesP $num,*] {
	unset MenuEntriesP($i)
    }
    foreach i [array names MenuCommandsP $num,*] {
	unset MenuCommandsP($i)
    }

    set MenuEntriesP($num) [list [= Displacements] [= {Main Ax. Force}] [= {Main Momentus}] \
		                --- [= Deformed] [= Reactions] [= {Local axes}] [= {No results}] \
		                --- [= {Integrate/graphs}]]

    set MenuCommandsP($num) { {} {} {} {} {-np- DisplayDeformed} \
	    {-np- DisplayVectors Reactions |Reactions|} \
	    {-np- DisplayLocalAxes "shell"} \
	    {-np- StopResults}  {} {-np- IntegrateWindow} }
   
    set MenuEntriesP($num,0) [list X Y Z [= "|Displacements|"]]
    set res [list X Y Z "|Displacements|"]
    foreach j $$res {
	lappend MenuCommandsP($num,0) "-np- DisplayContourFill Displacements $j"
    }

    set MenuEntriesP($num,1) [list [= Both] --- N11 N22 --- [= "N11 vector"] [= "N22 vector"]]
    set MenuCommandsP($num,1) { \
	    {-np- DisplayVectors Mat_Ax._Force All} {} \
	    {-np- DisplayContourFill Main_Ax._Force N11} \
	    {-np- DisplayContourFill Main_Ax._Force N22} {} \
	    {-np- DisplayVectors Mat_Ax._Force Si} \
	    {-np- DisplayVectors Mat_Ax._Force Sii} }

    set MenuEntriesP($num,2) [list M11 M22 --- [= "Local axes"] --- Qm1 Qm2]
    set MenuCommandsP($num,2) { \
	    {-np- DisplayContourFill Main_Momentus M11}  \
	    {-np- DisplayContourFill Main_Momentus M22} {} \
	    {-np- DisplayVectors L_Axes_Momentus All } {} \
	    {-np- DisplayContourFill Shear_in_Main Qm1}  \
	    {-np- DisplayContourFill Shear_in_Main Qm2}}

    set MenuEntriesP($num,5) [list [= Force] [= Momentus] [= Compose] --- [= "Force x"] \
		                  [= "Force y"] [= "Force z"]]

    set MenuCommandsP($num,5) { \
	    {-np- DisplayVectors Reactions |Reactions|} \
	    {-np- DisplayVectors M_Reactions "|M_Reactions|"} \
	    {-np- AddReactionsWindow}  \
	    {} {-np- DisplayVectors Reactions Px} \
	    {-np- DisplayVectors Reactions Py} \
	    {-np- DisplayVectors Reactions Pz} } 

}

proc SetVarsForShellsBoth {} {
    global MenuNamesP MenuEntriesP MenuCommandsP

    set num [lsearch $MenuNamesP [_ "View results"]]

    foreach i [array names MenuEntriesP $num,*] {
	unset MenuEntriesP($i)
    }
    foreach i [array names MenuCommandsP $num,*] {
	unset MenuCommandsP($i)
    }

    set MenuEntriesP($num) [list [= Displacements] [= {Axial Force}] [= Momentus] [= Shear] --- \
		                [= {Main Ax. Force}] [= {Main Momentus}] \
		                --- [= Deformed] [= Reactions] [= {Local axes}] [= {No results}] \
		                --- [= {Integrate/graphs}]]

    set MenuCommandsP($num) { {} {} {} {} {} {} {} {} {-np- DisplayDeformed} \
	    {} {-np- DisplayLocalAxes "shell" } \
	    {-np- StopResults}  {} {-np- IntegrateWindow} }
   
    set names(0) [list X Y Z [= |Displacements|]]
    set res1(0) [list X Y Z |Displacements|]
    set names(1) { Nx' Ny' Nxy' }
    set res1(1) { Nx' Ny' Nxy' }
    set names(2) { Mx' My' Mxy' }
    set res1(2) { Mx' My' Mxy' }
    set names(3) { Qx' Qy' }
    set res1(3) { Qx' Qy' }

    for {set i 0} {$i<4} {incr i} {
	set MenuEntriesP($num,$i) $names($i)
	foreach j $res1($i) {
	    lappend MenuCommandsP($num,$i) "-np- DisplayContourFill [lindex $res0 $i] $j"
	}
    }
    
    set MenuEntriesP($num,5) [list [= Both] --- N11 N22 --- [= "N11 vector"] [= "N22 vector"]]
    set MenuCommandsP($num,5) { \
	    {-np- DisplayVectors Mat_Ax._Force All} {} \
	    {-np- DisplayContourFill Main_Ax._Force N11} \
	    {-np- DisplayContourFill Main_Ax._Force N22} {} \
	    {-np- DisplayVectors Mat_Ax._Force Si} \
	    {-np- DisplayVectors Mat_Ax._Force Sii} }

    set MenuEntriesP($num,6) [list M11 M22 --- [= "Local axes"] --- Qm1 Qm2]
    set MenuCommandsP($num,6) { \
	    {-np- DisplayContourFill Main_Momentus M11}  \
	    {-np- DisplayContourFill Main_Momentus M22} {} \
	    {-np- DisplayVectors L_Axes_Momentus All } {} \
	    {-np- DisplayContourFill Shear_in_Main Qm1}  \
	    {-np- DisplayContourFill Shear_in_Main Qm2}} 
    
    set MenuEntriesP($num,9) [list [= Force] [= Momentus] [= Compose] --- [= "Force x"] \
		                  [= "Force y"] [= "Force z"]]

    set MenuCommandsP($num,9) { \
	    {-np- DisplayVectors Reactions |Reactions|} \
	    {-np- DisplayVectors M_Reactions "|M_Reactions|"} \
	    {-np- AddReactionsWindow}  \
	    {} {-np- DisplayVectors Reactions Px} \
	    {-np- DisplayVectors Reactions Py} \
	    {-np- DisplayVectors Reactions Pz} } 
}

proc SetVarsForShells {} {
    global MenuNamesP MenuEntriesP MenuCommandsP

    set curr [.central.s info postprocess get cur_analisis]
    set cstep [.central.s info post get cur_step $curr]

    set restypes [.central.s info postprocess get results_list Contour_Fill $curr $cstep]

    set num [lsearch $MenuNamesP [_ "View results"]]

    foreach i [array names MenuEntriesP $num,*] {
	unset MenuEntriesP($i)
    }
    foreach i [array names MenuCommandsP $num,*] {
	unset MenuCommandsP($i)
    }

    set MenuEntriesP($num) ""
    set MenuCommandsP($num) ""

    set ip 0

    if { [lsearch $restypes Displacements*] != -1 } {
	lappend MenuEntriesP($num) [= "Displacements"]
	lappend MenuCommandsP($num) ""

	set MenuEntriesP($num,$ip) [list [= Disp_X] [= Disp_Y] [= Disp_Z] [= "|Displacements|"]]
	set res [list [= Disp_X] [= Disp_Y] [= Disp_Z] "|Displacements|"]
	foreach j $res {
	    lappend MenuCommandsP($num,$ip) "-np- DisplayContourFill Displacements $j"
	}
	incr ip
    }

    if { [lsearch $restypes Velocities*] != -1 } {
	lappend MenuEntriesP($num) [= "Velocities"]
	lappend MenuCommandsP($num) ""

	set MenuEntriesP($num,$ip) [list Vel_X Vel_Y Vel_Z [= |Velocities|]]
	set res { Vel_X Vel_Y Vel_Z |Velocities|}
	foreach j $res {
	    lappend MenuCommandsP($num,$ip) "-np- DisplayContourFill Velocities $j"
	}
	incr ip
    }

    if { [lsearch $restypes Accelerations*] != -1 } {
	lappend MenuEntriesP($num) [= "Accelerations"]
	lappend MenuCommandsP($num) ""

	set MenuEntriesP($num,$ip) [list [= Accel_X] [= Accel_Y] [= Accel_Z] [= "|Accelerations|"]]
	set res [list Accel_X Accel_Y Accel_Z "|Accelerations|"]
	foreach j $res {
	    lappend MenuCommandsP($num,$ip) "-np- DisplayContourFill Accelerations $j"
	}
	incr ip
    }

    if { [lsearch $restypes Axial_Force*] != -1 } {
	lappend MenuEntriesP($num) [= "Axial Force"] [= Momentus] [= Shear] ---
	set res [list "Axial_Force" Momentus Shear ---]
	lappend MenuCommandsP($num) "" "" "" ""
	set MenuEntriesP($num,$ip) [list Nx' Ny' Nxy']
	set MenuEntriesP($num,[expr $ip+1]) [list Mx' My' Mxy']
	set MenuEntriesP($num,[expr $ip+2]) [list Qx' Qy']

	set idx 0
	for {set i $ip} {$i<$ip+3} {incr i} {
	    set MenuCommandsP($num,$i) ""
	    foreach j $MenuEntriesP($num,$i) {
		lappend MenuCommandsP($num,$i) "-np- DisplayContourFill [lindex $res $idx] $j"
	    }
	    incr idx
	}
	incr ip 4
    }

    if { [lsearch $restypes Main_Ax._Force*] != -1 } {
	lappend MenuEntriesP($num) [= "Main Ax. Force"] [= "Main Momentus"] --- 
	lappend MenuCommandsP($num) "" "" ""

	set MenuEntriesP($num,$ip) [list [= Both] --- N11 N22 --- [= "N11 vector"] [= "N22 vector"]]
	set MenuCommandsP($num,$ip) { \
		{-np- DisplayVectors Mat_Ax._Force All} {} \
		{-np- DisplayContourFill Main_Ax._Force N11} \
		{-np- DisplayContourFill Main_Ax._Force N22} {} \
		{-np- DisplayVectors Mat_Ax._Force Si} \
		{-np- DisplayVectors Mat_Ax._Force Sii} }
	incr ip
	set MenuEntriesP($num,$ip) [list M11 M22 --- [= "Local axes"] --- Qm1 Qm2]
	set MenuCommandsP($num,$ip) { \
		{-np- DisplayContourFill Main_Momentus M11}  \
		{-np- DisplayContourFill Main_Momentus M22} {} \
		{-np- DisplayVectors L_Axes_Momentus All } {} \
		{-np- DisplayContourFill Shear_in_Main Qm1}  \
		{-np- DisplayContourFill Shear_in_Main Qm2}} 
	incr ip 2
    }

    if { [lsearch $restypes Stresses_Up*] != -1 } {
	lappend MenuEntriesP($num) [= "Stresses Up"] [= "Stresses Down"] [= "Von Misses Up"] \
	    [= "Von Misses Down"] ---
	lappend MenuCommandsP($num)  "" "" \
		{-np- DisplayContourFill Von_Misses_Up Von_Misses_Up} \
		{-np- DisplayContourFill Von_Misses_Down Von_Misses_Down} ""
	set MenuEntriesP($num,$ip) {Sx Sy Sz Txy Txz Tyz Si-Stresses Sii-Stresses Siii-Stresses}
	foreach j $MenuEntriesP($num,$ip) {
	    lappend MenuCommandsP($num,$ip) "-np- DisplayContourFill Stresses_Up $j"
	}
	incr ip

	set MenuEntriesP($num,$ip) [list Sx Sy Sz Txy Txz Tyz [= Si-Stresses] [= Sii-Stresses] \
		                        [= Siii-Stresses]]

	foreach j $MenuEntriesP($num,$ip) {
	    lappend MenuCommandsP($num,$ip) "-np- DisplayContourFill Stresses_Down $j"
	}
	incr ip 4
    }

    if { [lsearch $restypes Blast_Pressure*] != -1 }   {
	lappend MenuEntriesP($num) [= "Blast Pressure"] ---
	lappend MenuCommandsP($num) {-np- DisplayContourFill Blast_Pressure} {}
	incr ip 2
    }

    if { [lsearch $restypes Elemental_Damage] != -1  && [lsearch $restypes Comparison_Stress*] != -1}   {
	lappend MenuEntriesP($num) [= "Elemental Damage"]  [= "Comparison Stress"] ---
	lappend MenuCommandsP($num) {-np- DisplayContourFill Elemental_Damage} \
		                    {-np- DisplayContourFill Comparison_Stress} {}
	incr ip 3
    }


    if { [lsearch $restypes Laminate*] != -1 } {
	lappend MenuEntriesP($num) [= "Laminates"] ---
	lappend MenuCommandsP($num)  "" ""
	set MenuEntriesP($num,$ip) ""
	set MenuCommandsP($num,$ip) ""
	set jp 0
	foreach i $restypes {
	    if { [string match Laminate* $i] } {
		lappend MenuEntriesP($num,$ip) [string map [list _ " "] $i]
		set comp [.central.s info post get components_list Contour_Fill $i $curr $cstep]
		if { [llength $comp] == 1 } {
		    lappend MenuCommandsP($num,$ip) "-np- DisplayContourFill $i $comp"
		} else {
		    lappend MenuCommandsP($num,$ip) ""
		    foreach j [lrange $comp 0 2] {
		        lappend MenuEntriesP($num,$ip,$jp) $j
		        lappend MenuCommandsP($num,$ip,$jp) "-np- DisplayContourFill $i $j"
		    }
		}
		incr jp
	    }
	}
	lappend MenuEntriesP($num,$ip) [= "More..."]
	lappend MenuCommandsP($num,$ip) "-np- RamSeriesLaminateResults::LoadNewResult"
	incr ip 2
    }

    if { [lsearch $restypes Displacements*] != -1 } {
	lappend MenuEntriesP($num) [= Deformed]
	lappend MenuCommandsP($num) {-np- DisplayDeformed}
	incr ip
    }

    if { [lsearch $restypes Reactions*] != -1 } {
	lappend MenuEntriesP($num) [= Reactions] 
	lappend MenuCommandsP($num) {} 

	set MenuEntriesP($num,$ip) [list [= Force] [= Momentus] [= Compose] --- [= "Force x"] \
		                        [= "Force y"] [= "Force z"]]

	set MenuCommandsP($num,$ip) { \
	    {-np- DisplayVectors Reactions |Reactions|} \
	    {-np- DisplayVectors M_Reactions "|M_Reactions|"} \
	    {-np- AddReactionsWindow}  \
	    {} {-np- DisplayVectors Reactions Px} \
	    {-np- DisplayVectors Reactions Py} \
	    {-np- DisplayVectors Reactions Pz} } 
    }


    lappend MenuEntriesP($num) [= {Local axes}] [= {No results}] 
    lappend MenuCommandsP($num) {-np- DisplayLocalAxes "shell"} {-np- StopResults}

    if { [lsearch $restypes Axial_Force*] != -1 } {
	lappend MenuEntriesP($num)  --- [= {Integrate/graphs}]
	lappend MenuCommandsP($num)  {} {-np- IntegrateWindow}
    }
}


proc SetVarsForNoneWin {} {
    WarnWin [= "There are no Results"]
}

proc SetVarsForNone {} {
    global MenuNamesP MenuEntriesP MenuCommandsP

    set num [lsearch $MenuNamesP [_ "View results"]]

    foreach i [array names MenuEntriesP $num,*] {
	unset MenuEntriesP($i)
    }
    foreach i [array names MenuCommandsP $num,*] {
	unset MenuCommandsP($i)
    }

    set MenuEntriesP($num) [list [= {No Results}]]
    set MenuCommandsP($num) { {-np- SetVarsForNoneWin} }

}

proc AddStepToLoadCasePostMenu { iana w_step} {
 global stupidval
 set stupidval 1
 set step_list [.gid.central.s info post get all_steps $iana]
 set curr_step [.gid.central.s info post get cur_step $iana]
 set curr_ana [.central.s info postprocess get cur_analisis]
 foreach istep $step_list {
    if { $istep == $curr_step && $iana == $curr_ana } {
       $w_step add checkbutton -label $istep -variable stupidval -command \
	   "ChangeToAnalysis $iana $istep"
    } else {
       $w_step add command -label $istep -command "ChangeToAnalysis $iana $istep" 
    }
 }
 return $w_step
}

proc AddloadcasesToPostMenu { w alla } {
    global GidPriv
    global stupidval

    set stupidval 1
    set curr [.central.s info postprocess get cur_analisis]

    $w del 0 end
    set inum 0

    set req_acc 0
    set num_step_total 0
    foreach i $alla {
      set all_step [.gid.central.s info post get all_steps $i]
      set num_step [llength $all_step]
      set num_step_total [expr $num_step_total+$num_step]             
    }
    if {$num_step_total == [llength $alla]} {
      set req_acc 1
    }
    
    foreach i $alla {
	set w_step $w.loadcase$inum
	catch {menu $w_step -tearoff 0}
	$w_step del 0 end
	set all_step [.gid.central.s info post get all_steps $i]
	set num_step [llength $all_step]

	if { $i == $curr } {
	    set img $GidPriv(VerifImage)
	    if {$num_step == 1} {
	      set cur_step [lindex $all_step 0]
	      incr inum
	      if {$req_acc == 0} {
		$w add checkbutton -label $i -variable stupidval \
		    -command "ChangeToAnalysis $i $cur_step"
	} else {
		$w add checkbutton -label $i -variable stupidval -command "ChangeToAnalysis $i $cur_step" \
		    -acc "Ctrl-$inum"
	}

	    } else {
	      incr inum
	      $w add cascade -label $i -menu [AddStepToLoadCasePostMenu $i $w_step] \
		     -image $img -compound left
	    }
	} else {
	    if {$num_step == 1} {
		set cur_step [lindex $all_step 0]
		incr inum
		if {$req_acc == 0} {
		    $w add command -label $i -command "ChangeToAnalysis $i $cur_step"
		} else {
		    $w add command -label $i -command "ChangeToAnalysis $i $cur_step" -acc \
		        "Ctrl-$inum"
		}
	    } else {
		set img $GidPriv(VerifNoImage)
		incr inum
		$w add cascade -label $i -menu [AddStepToLoadCasePostMenu $i $w_step] \
		    -image $img -compound left
	    }
	}
	
	if {$req_acc == 1 } {
	    catch { bind all <Control-KeyPress-$inum> "$w invoke $i" }
	}
       
    }
}

proc AddLoadCasesToMenu { alla } {
    global MenuNamesP MenuEntriesP MenuCommandsP

    set num [lsearch $MenuNamesP [_ "View results"]]

    set MenuEntriesP($num) [linsert $MenuEntriesP($num) 0 [= Loadcase] ---]
    set MenuCommandsP($num) [linsert $MenuCommandsP($num) 0 \
	    [list -np- AddloadcasesToPostMenu %W $alla] {}]

    set names [array names MenuEntriesP $num,*]
    foreach i [lsort -decreasing $names] {
	regexp {^([0-9]+),([0-9]+)(.*)$} $i {} n1 n2 r
	incr n2 2
	set ni $n1,$n2$r
	set MenuEntriesP($ni) $MenuEntriesP($i)
	unset MenuEntriesP($i)
	set MenuCommandsP($ni) $MenuCommandsP($i)
	unset MenuCommandsP($i)
    }
    set MenuEntriesP($num,0) ""
    set MenuCommandsP($num,0) ""
    foreach i $alla {
	lappend MenuEntriesP($num,0) $i
	lappend MenuCommandsP($num,0) ""
    }
}

proc CreatePostProcessMenu { w } {
    global BarresPriv MenuNamesP

    set num [lsearch $MenuNamesP [_ "View results"]]

    set infoProj [lindex [.gid.central.s info Project] 4]
    if { $infoProj != "POSTUSE" && $infoProj != "GRAFUSE" } { return }

    set alla [.central.s info postprocess get all_analisis]
    set ipos [lsearch $alla _Vibration_modes]
    if { $ipos != -1 } {
	set alla [lreplace $alla $ipos $ipos]
    }

  
    set curr [.central.s info postprocess get cur_analisis]
    set cstep [.central.s info post get cur_step $curr]

    if { $BarresPriv(EnteringPost) == 1 } {
	set BarresPriv(EnteringPost) 0
	if { $curr == "Max_Min" } {
	    set newa [lindex $alla end-1]
	    if { $newa != "" } {
		.central.s process escape escape escape escape Results AnalysisSel $newa \
		escape escape
		set curr [.central.s info postprocess get cur_analisis]
		set cstep [.central.s info post get cur_step $curr]
	    }
	}
    }

    if { [llength $alla] > 0 } {
	set all_step [.gid.central.s info post get all_steps $curr]
	set cstep [lindex $all_step 0]
	set restype [.central.s info postprocess get results_list Contour_Fill $curr $cstep]
    } else { set restype "" }
    
    if { [llength $alla] == 0 } {
	set type none
    } elseif { [lsearch $restype Local_Axes] == -1 && [lsearch $restype Local_Axes_Beam] == -1 } {
	set type solid
    } elseif { [lsearch $restype Local_Axes] != -1 && [lsearch $restype Local_Axes_Beam] != -1 } {
	set type both
    } elseif { [lsearch $restype Local_Axes] != -1 && [lsearch $restype Local_Axes_Beam] == -1 } {
	set type xy
    } elseif { [lsearch $restype Local_Axes] == -1 && [lsearch $restype Local_Axes_Beam] != -1 } {
	set type beams
    } else { set type none }

    if { $type != "beams" && [lsearch $restype Local_Axes_Beam] != -1 } {
	set type2 beams
    } else { set type2  "" }

    if { ![info exists BarresPriv(problemtype)] || \
	    $BarresPriv(problemtype) != $type || \
	    $BarresPriv(problemtype2) != $type2 || [$w index end] == "none" } {
	switch $type {
	    solid SetVarsForSolids
	    beams SetVarsForBeams
	    both - xy  SetVarsForShells
	    none SetVarsForNone
	}
	if { $type2 == "beams" } {
	    AddVarsForBeams
	}
	AddVibrationModes

	set all_step [.gid.central.s info post get all_steps $curr]
	set num_step 0
	foreach i_step $all_step {
	  incr num_step
	}

	if { [llength $alla] > 1 && $type != "none"} {
	    AddLoadCasesToMenu $alla
	} elseif { [llength $alla] == 1 && $type != "none" && ($curr =="Dynamic" || $num_step > 1) } {
	    AddLoadCasesToMenu $alla
	}

	$w del 0 end
	CreateCascadedMenu $w MenuEntriesP MenuCommandsP MenuAcceler $num
    }
    set BarresPriv(problemtype) $type
    set BarresPriv(problemtype2) $type2
}


proc StopResults {} {
    .central.s process escape escape escape escape Results Geometry \
	    NoResults escape
    .central.s process escape escape escape escape Results Geometry \
	    Original escape
    .central.s process escape escape escape escape Results Geometry HideTheShow \
	    escape
}

# proc DisplayScalarLineDiagram { args } {
    
#     .central.s process escape escape escape escape Results LineDiagram \
#             ScalarDiagram $args

# }

proc RamSeriesSetCommentsForLineDiagram { result } {

    set aa [.central.s info post get comments]
    if { [lindex $aa 1] != "yes" } { return -1 }

    set DisableWarnLine [.central.s disable warnline]
    .central.s disable warnline 1

    set req_step 0
    set num_step_total 0
    set alla [.central.s info postprocess get all_analisis]
    foreach i $alla {    
      set all_step [.gid.central.s info post get all_steps $i]
      set num_step [llength $all_step]
      set num_step_total [expr $num_step_total+$num_step]             
    }
    if {$num_step_total == [llength $alla]} {
      set req_step 0
    } else { 
	set req_step 1 
    }
    

    if {$req_step == 0 } {
    .central.s process escape escape escape escape utilities comments Line1 %an
    } else {
	set text  "\"%an, step %sv\""
	.central.s process escape escape escape escape utilities comments Line1 $text
    }
    set t "\"Line diagram of $result, factor %vf\""
    .central.s process Line2 $t
    .central.s process escape escape utilities comments automatic no
    .central.s process escape escape utilities comments comments yes

    if { !$DisableWarnLine } { .central.s disable warnline 0 }
    return 0
}

proc RamSeriesSetCommentsToAutomatic { result } {

    set DisableWarnLine [.central.s disable warnline]
    .central.s disable warnline 1

    .central.s process escape escape escape escape utilities comments automatic yes escape

    .central.s process escape escape escape escape Results ContOptions ChangeTitleLeg "\"$result\""

    if { !$DisableWarnLine } { .central.s disable warnline 0 }
}

proc DisplayVectorLineDiagram { result args } {
#      .central.s process escape escape escape escape Results LineDiagram \
#              Options ShowElevations NodesOnly LineDiagram VectorDiagram $args

    set anal [.central.s info postprocess get cur_analisis]
    set cstep [.central.s info post get cur_step cur_analisis]

    set reslist [.central.s info postprocess get results_list Vector_Line_Diagram \
		 $anal $cstep]

    set ipos1 -1
    set ipos2 -1
    set i 0
    foreach res $reslist {
	if { [string match $result* $res] } {
	    if { $ipos1 == -1 } {
		set ipos1 $i
		set resultname $res
	    } else {
		set ipos2 $i
		set resultname $res
	    }
	}
	incr i
    }
    if { $ipos1 == -1 } {
	WarnWin [= "The results '%s' does not exist in loadcase '%s'" $result $anal]
    } elseif { $ipos2 == -1 } {
	regsub -all _ $resultname { } resultname
	set DisableGraphics [.central.s disable graphics]
	.central.s disable graphics 1
	set fail [RamSeriesSetCommentsForLineDiagram $resultname]
	.central.s process escape escape escape escape Results Geometry NoResults Geometry Original
	.central.s process escape escape escape escape Results LineDiagram \
	    VectorDiagram $result $args
	if { !$fail } { RamSeriesSetCommentsToAutomatic $resultname }
	if { !$DisableGraphics } { .central.s disable graphics 0 }
	.central.s process redraw
    } else {
	regsub -all _ $resultname { } resultname
	regsub {min\s+} $resultname {} resultname
	set DisableGraphics [.central.s disable graphics]
	.central.s disable graphics 1
	set fail [RamSeriesSetCommentsForLineDiagram "$resultname Min Max"]
	set DisableWarnLine [.central.s disable warnline]
	.central.s disable warnline 1

	.central.s process escape escape escape escape utilities variables postresoverres yes
	.central.s process escape escape escape escape Results Geometry NoResults Geometry Original
	if { !$DisableWarnLine } { .central.s disable warnline 0 }
	.central.s process escape escape escape escape Results LineDiagram \
	    VectorDiagram [lindex $reslist $ipos1] $args
	.central.s process escape escape escape escape Results LineDiagram \
	    VectorDiagram [lindex $reslist $ipos2] $args
	set DisableWarnLine [.central.s disable warnline]
	.central.s disable warnline 1
	.central.s process escape escape escape escape utilities variables \
	    postresoverres no escape
	if { !$DisableWarnLine } { .central.s disable warnline 0 }
	if { !$fail } { RamSeriesSetCommentsToAutomatic "$resultname MM" }
	if { !$DisableGraphics } { .central.s disable graphics 0 }
	.central.s process redraw
    }
}

# proc DisplayVectorLineDiagram2 { result1 result2 args } {
# #      .central.s process escape escape escape escape Results LineDiagram \
# #              Options ShowElevations NodesOnly LineDiagram VectorDiagram $args

#     set anal [.central.s info postprocess get cur_analisis]

#     set reslist [.central.s info postprocess get results_list Vector_Line_Diagram \
#                  $anal 1]

#     set ipos1 [lsearch $reslist $result1]
#     set ipos2 [lsearch $reslist $result2]

#     .central.s process escape escape escape escape utilities variables postresoverres yes
#     .central.s process escape escape escape escape Results Geometry NoResults Geometry Original
#     .central.s process escape escape escape escape Results LineDiagram \
#             VectorDiagram [lindex $reslist $ipos1] $args
#     .central.s process escape escape escape escape Results LineDiagram \
#             VectorDiagram [lindex $reslist $ipos2] $args
#     .central.s process escape escape escape escape utilities variables \
#             postresoverres no escape
# }

proc DisplayDeformedSD { args } {

    set DisableGraphics [.central.s disable graphics]
    .central.s disable graphics 1
    .central.s process escape escape escape escape Results Geometry NoResults Geometry Original
    set cur_anal [.gid.central.s info post get cur_analisis]
    set cstep [.central.s info post get cur_step cur_analisis]
    .central.s process escape escape escape escape Results Geometry ShowDeformed \
	    $cur_anal $cstep $args escape escape
    if { !$DisableGraphics } { .central.s disable graphics 0 }
    .central.s process redraw
}

proc DisplayDeformedVibrationModes { args } {

    set DisableGraphics [.central.s disable graphics]
    .central.s disable graphics 1
     StopResults
     set curr_ana [.central.s info postprocess get cur_analisis]
     set cstep [.central.s info post get cur_step $curr_ana]

    .central.s process escape escape escape escape Results AnalysisSel \
		"_Vibration_modes" 0 escape

    .central.s process escape escape escape escape Results Geometry Deformation $args

    .central.s process escape escape escape escape Results AnalysisSel \
		$curr_ana $cstep escape

    if { !$DisableGraphics } { .central.s disable graphics 0 }
    .central.s process redraw

}



proc DisplayContourFill { args } {
    set DisableGraphics [.central.s disable graphics]
    .central.s disable graphics 1
    .central.s process escape escape escape escape Results Geometry NoResults Geometry Original
    .central.s process escape escape escape escape Results ContourFill $args \
	    escape
    if { !$DisableGraphics } { .central.s disable graphics 0 }
    .central.s process redraw
}

proc DisplayContourRanges { args } {

    set DisableGraphics [.central.s disable graphics]
    .central.s disable graphics 1
    .central.s process escape escape escape escape Results Geometry NoResults Geometry Original
    .central.s process escape escape escape escape Results ContourRanges $args \
	escape
    if { !$DisableGraphics } { .central.s disable graphics 0 }
    .central.s process redraw
}

proc DisplayVectors { args } {

    set DisableGraphics [.central.s disable graphics]
    .central.s disable graphics 1
    .central.s process escape escape escape escape Results Geometry NoResults Geometry Original
    .central.s process escape escape escape escape DisplayStyle Boundaries
    .central.s process escape escape escape escape Results DisplayVectors $args
    if { !$DisableGraphics } { .central.s disable graphics 0 }
    .central.s process redraw
}

# proc DisplayGraphs { args } {

#     .central.s process escape escape escape escape Results Geometry NoResults Geometry Original
#     .central.s process escape escape escape escape Results Graphs BorderGraph \
#             LineVariation $args
# }

proc DisplayDeformed {} {

    set DisableGraphics [.central.s disable graphics]
    .central.s disable graphics 1
    set cur_anal [.gid.central.s info post get cur_analisis]

    set cstep [.central.s info post get cur_step cur_analisis]

    set restype [.central.s info postprocess get results_list Contour_Fill \
		$cur_anal $cstep]

    if { [lsearch $restype Displacements*] != -1 } {
	DisplayDeformedSD Displacements
    } else {
	DisplayVectorLineDiagram BDisplacements
    }
    if { !$DisableGraphics } { .central.s disable graphics 0 }
    .central.s process redraw
}
proc ChangeToAnalysis { newa news} {
    
    set cur_anal [.gid.central.s info post get cur_analisis]
    set cur_step [.gid.central.s info post get cur_step $cur_anal] 
    set cur_res [.gid.central.s info post get cur_result]
    set cur_res_view  [.gid.central.s info post get cur_results_view]
    set cur_comp [.gid.central.s info post get cur_component]

    set new_step $news
 
    # Determino la lista de resultados disponibles para el nuevo analisis y el nuevo step
    set result_types [.central.s info postprocess get results_list $cur_res_view $newa $news]
    
    # Determino la lista de steps disponibles para el nuevo analisis
    set all_step [.gid.central.s info post get all_steps $newa]

    # Verifico si para el nuevo step del nuevo analisis existe el resultado actual
    if { [lsearch $result_types $cur_res] == -1} {
       # Si no existe el resultado sino tomo el primer step como nuevo step
       set new_step [lindex $all_step 0]
    }

    # Verifico si para el step y analisis actual existe el resultado actual (Caso de los Local_axes)
    set result_types_actual [.central.s info postprocess get results_list $cur_res_view $cur_anal $cur_step]
    if { [lsearch $result_types_actual $cur_res] == -1} {
       set cur_step "0"
    }

    regsub -all {_} $cur_res_view {} pp
    set restcommand "$pp cur_res $cur_comp"
    switch $cur_res_view {
	"Iso_Surfaces" {
	    set values [.gid.central.s info post get iso_cur_result_values]
	    set restcommand "$pp exact cur_res $cur_comp [lindex $values 0] \
		    [lindex $values 1]"
	}
	"Stream_Lines" {
	    set restcommand ""
	}
	"No_Result" {
	    set restcommand ""
	}
	"Display_Vectors" {
	    set value [.gid.central.s info post get cur_vector_factor $cur_res_view \
		    $cur_res $cur_anal $cur_step ]
	    set restcommand "$restcommand $value escape"
	}
	"Vector_Line_Diagram" {
	    set value [.gid.central.s info post get cur_diagram_factor  \
		    $cur_res $cur_anal $cur_step ]
	    set restcommand "LineDiagram VectorDiagram cur_res $value"
	}
	"Scalar_Line_Diagram" {
	    set value [.gid.central.s info post get cur_diagram_factor \
		    $cur_res $cur_comp $cur_anal $cur_step ]
	    set restcommand "LineDiagram ScalarDiagram cur_res $cur_comp $value"
	}
	default {
	}
    }
    .central.s process escape escape escape escape Results AnalysisSel $newa $new_step \
	    escape escape

    set restypes [.central.s info postprocess get results_list Contour_Fill \
		      $newa $new_step]

    # to recreate the Results menu
    catch { unset ::BarresPriv(problemtype) }

    regsub {_[(].*[)]$} $cur_res {} cur_res_short
    set ipos [lsearch $restypes $cur_res_short*]
    if { $ipos == -1 } {
	regsub {_[^_]*$} $cur_res_short {} cur_res_short2
	set ipos [lsearch $restypes $cur_res_short2*]
	if { $ipos == -1 } {
	    #WarnWin "Result '$cur_res_short' is not contained in load case '$newa'"
	    StopResults
	    return
	} else {
	    set cur_res_short $cur_res_short2
	}
    }
    if { $restcommand != "" } {
	if { $cur_res_view == "Vector_Line_Diagram" } {
	     regsub -all {[[:<:]]cur_res[[:>:]]} $restcommand $cur_res_short restcommand
	    eval DisplayVectorLineDiagram [lrange $restcommand 2 end]
	} else {
	    set cur_res [lindex $restypes $ipos]
	    regsub -all {[[:<:]]cur_res[[:>:]]} $restcommand $cur_res restcommand
	    eval .central.s process escape escape escape escape Results $restcommand \
		escape escape
	}
    }

}

#  proc AssignMaterialsFromLayers {} {

#      if { [lindex [.central.s info Mesh] 0] == 0 } { 
#          WarnWin "error: This function can only be applied after generating the mesh."
#          return
#      }
#      set usingnow [lindex [.central.s info Project] 4]
#      if { $usingnow != "GEOMETRYUSE" && $usingnow != "MESHUSE" } { return }

#      set DisableGraphics [.central.s disable graphics]
#      set DisableWarnLine [.central.s disable warnline]

#      .central.s disable graphics 1
#      .central.s disable warnline 1

#      if { $usingnow == "GEOMETRYUSE" } {
#          .central.s process escape escape escape escape Meshing MeshView
#      }
#      .central.s process escape escape escape escape data materials
#      foreach i [.central.s info materials] {
#          .central.s process DeleteMaterial $i
#      }
#      .central.s process escape escape escape escape data
#      foreach i [.central.s info layers] {
#          .central.s process defaults BaseMaterial $i 1 name 
#          .central.s process $i
#      }
#      .central.s process escape escape escape escape data Materials
#      foreach i [.central.s info layers] {
#          .central.s process AssignMaterial $i layer:$i escape
#      }
#      if { $usingnow == "GEOMETRYUSE" } {
#          .central.s process escape escape escape escape Geometry escape
#      }

#      if { !$DisableGraphics } { .central.s disable graphics 0 }
#      if { !$DisableWarnLine } { .central.s disable warnline 0 }

#      WarnWin "Now on, every layer will have a different set in the postprocessing part."
#  }


# proc VerifyPropertyElements {} {

#     set numelements 0
#     set badelements ""
#     foreach elemtype [list Linear Triangle] {
#         switch $elemtype {
#             Linear {
#                 set conds [list Rectangular_Section Section Concrete_rec_section Steel_section]
#                 set vars [list num n1 n2 mat]
#             }
#             Triangle {
#                 set conds [list Shell Anisotropic_Shell Concrete_Shell Steel_Shell]
#                 set vars [list num n1 n2 n3 mat]
#             }
#         }
#         foreach $vars [.central.s info Mesh Elements $elemtype] {
#             incr numelements
#             set assigned ""
#             foreach j $conds {
#                 set retval [lindex [.central.s info conditions $j mesh $num] 0]
#                 if { [lindex $retval 0] != 0 } {
#                     lappend assigned $j
#                 }
#             }
#             if { [llength $assigned] != 1 } {
#                 if { [llength $assigned] == 0 } {
#                     WarnWinText "Element $num has no properties"
#                 } else {
#                     WarnWinText "Element $num has properties: $assigned"
#                 }
#                 lappend badelements $num
#             }
#         }
#     }
#     if { !$numelements } {
#         WarnWin "There is no mesh to check"
#     }
#     if { [llength $badelements] == 0 } {
#         WarnWin "All elements have properties assigned OK"
#     } else {
#         WarnWinText "List of incorrect elements: $badelements"
#     }
# }


proc VerifyPropertyElements {} {

    .central.s waitstate 1
    update
    set numelements 0
    set badelements ""

    if { [llength [.central.s info Conditions ovvol]] != 0 } {
	set linearconds ""
	set trianglequadconds [list Non_analysis_triangles]
	set solidconds [list Solid]
    } else {
	set linearconds [list Rectangular_Section Section Concrete_rec_section Steel_section \
		             Naval_Stiffeners]
	set trianglequadconds [list Shell Anisotropic_Shell Full_anisotropic_Shell \
		Concrete_Shell Steel_Shell Laminate_Shell]
	set solidconds ""
    }
    set IsQuadratic [lindex [.central.s info Project] 5]

    set inum 0
    foreach elemtype [list Linear Triangle Tetrahedra] {
	switch $elemtype {
	    Linear {
		set conds $linearconds
		set elems ""
		if { !$IsQuadratic } {
		    foreach "num n1 n2 mat" [.central.s info Mesh Elements Linear] {
		        lappend elems $num
		    }
		} else {
		    foreach "num n1 n2 - mat" [.central.s info Mesh Elements Linear] {
		        lappend elems $num
		    }
		}
	    }
	    Triangle - Quadrilateral {
		set conds $trianglequadconds
		set elems ""
		if { !$IsQuadratic } {
		    foreach "num n1 n2 n3 mat" [.central.s info Mesh Elements Triangle] {
		        lappend elems $num
		    }

		    foreach "num n1 n2 n3 n4 mat" [.central.s info Mesh Elements Quadrilateral] {
		        lappend elems $num
		    }
		} elseif { $IsQuadratic == 1 } {
		    foreach "num n1 n2 n3 - - - mat" [.central.s info Mesh Elements Triangle] {
		        lappend elems $num
		    }
		    foreach "num - - - - - - - - mat" [.central.s info Mesh Elements Quadrilateral] {
		        lappend elems $num
		    }
		} else {
		    foreach "num n1 n2 n3 - - - mat" [.central.s info Mesh Elements Triangle] {
		        lappend elems $num
		    }
		    foreach "num - - - - - - - - - mat" [.central.s info Mesh \
		                                             Elements Quadrilateral] {
		        lappend elems $num
		    }
		} 
	    }
	    Tetrahedra - Hexahedra {
		set conds $solidconds
		set elems ""
		if { !$IsQuadratic } {
		    foreach "num n1 n2 n3 n4 mat" [.central.s info Mesh Elements Tetrahedra] {
		        lappend elems $num
		    }
		    foreach "num - - - - - - - - mat" [.central.s info Mesh Elements Hexahedra] {
		        lappend elems $num
		    }
		} elseif { $IsQuadratic == 1 }  {
		    foreach "num n1 n2 n3 n4 - - - - - - mat" [.central.s info Mesh \
		        Elements Tetrahedra] {
		        lappend elems $num
		    }
		    foreach "num - - - - - - - - - - - - - - - - - - - - mat" [.central.s info Mesh \
		        Elements Hexahedra] {
		        lappend elems $num
		    }
		} else {
		    foreach "num n1 n2 n3 n4 - - - - - - mat" [.central.s info Mesh \
		        Elements Tetrahedra] {
		        lappend elems $num
		    }
		    foreach "num - - - - - - - - - - - - - - - - - - - - - - - - - - - mat" \
		        [.central.s info Mesh Elements Hexahedra] {
		        lappend elems $num
		    }
		}
	    }
	}
	foreach cond $conds {
	    set icounter($cond) 0
	    set condelems($cond) ""
	    foreach i [.central.s info conditions $cond mesh] {
		lappend condelems($cond) [lindex $i 1]
	    }
	    set ilen($cond) [llength $condelems($cond)]
	    set condelems($cond) [lsort -integer $condelems($cond)]
	}
	foreach elm $elems {
	    incr numelements
	    set assigned ""
	    foreach cond $conds {
		while { $icounter($cond) < $ilen($cond) } {
		    set cndelm [lindex $condelems($cond) $icounter($cond)]
		    if { $cndelm >= $elm } {
		        if { $cndelm == $elm } {
		            lappend assigned $cond
		        }
		        break
		    }
		    incr icounter($cond)
		}
	    }
	    if { [llength $assigned] != 1 } {
		incr inum
		if { $inum < 20 } {
		    if { [llength $assigned] == 0 } {
		        WarnWinText [= "Element %s has no properties" $elm]
		    } else {
		        WarnWinText [= "Element %s has properties: %s" $elm $assigned]
		    }
		} elseif { $inum == 20 } {
		    WarnWinText [= "More elements not printed..."]
		}
		lappend badelements $elm
	    }
	}
    }
    .central.s waitstate 0
    if { !$numelements } {
	WarnWin [= "There is no mesh to check"]
    } elseif { [llength $badelements] == 0 } {
	WarnWin [= "All elements have properties assigned OK"]
    } else {
	WarnWinText [= "List of incorrect elements: %s" $badelements]
    }
}

proc RamTempDir {} { return [lindex [.central.s info Project] 9] }

proc RamStartFile { file } {
    
    if { $::tcl_platform(platform) == "windows" } {
	eval exec [auto_execok start] [list [file native $file]] &
    } else {
	switch [file ext $file] {
	    .htm - .html {
		if { [auto_execok konqueror] != "" } {
		    exec konqueror $file &
		} elseif { [auto_execok netscape] != "" } {
		    exec netscape $file &
		} else {
		    error "unknown browser for '$file'"
		}
	    }
	    default {
		error "unknown file type for '$file'"
	    }
	}
    }
}

#-------------------------------------------------------------------------------------------------
# 
#     Desactivation assign and draw button for laminate materials, and naval stiffeners
# 
# 
# -------------------------------------------------------------------------------------------------

# proc RamSeriesBase2PostCmdAssignMat { GDN w Menu geomlist } {
#     $Menu del 0 end
#     if { [catch { set whatuse [lindex [.gid.central.s info Project] 4] }] } {
#         set whatuse GEOMETRYUSE
#     }
#     switch $whatuse {
#         GEOMETRYUSE {
#             foreach i $geomlist {
#                 $Menu add command -label $i -command "DWAssignMaterials $GDN $w $i"
#             }
#         }
#         MESHUSE {
#             $Menu add command -label Elements -command "DWAssignMaterials $GDN $w Elements"
#         }
#     }
# }
# proc RamSeriesBasePostCmdAssignMat { GDN w Menu } {
# 
#     if { [::GidUtils::VersionCmp 7.4.1b] >= 0 } { 
#         set _MatName [DWGetCurrentMaterial $GDN] 
#     } else {
#         upvar \#0 $GDN GidData
#         set _MatName [DWSpace2Under $GidData(MAT,matname)] ;#deprecated
#     }
#     #set MatName $GidData(MAT,matname)
#     #set _MatName [DWSpace2Under $MatName]
#     set book [.central.s info Materials $_MatName BOOK]
# 
#     if { $book == "Laminate_shell" || $book == "Naval_Stiffeners"} {
#         $Menu del 0 end
#         $Menu add command -label [= "This material cannot be assigned"]
#     }
# }

# proc RamSeriesBaseDWDrawMaterials { GDN w what } {
# 
#     if { [::GidUtils::VersionCmp 7.4.1b] >= 0 } { 
#         set _MatName [DWGetCurrentMaterial $GDN] 
#     } else {
#         upvar \#0 $GDN GidData
#         set _MatName [DWSpace2Under $GidData(MAT,matname)] ;#deprecated
#     }
#     #set MatName $GidData(MAT,matname)
#     #set _MatName [DWSpace2Under $MatName]
#     set book [.central.s info Materials $_MatName BOOK]
#     
#     WarnWin [= "This material or table cannot be drawn"]
# }
# 
# proc RamSeriesBaseDWUnassignMat { w GDN } {
# 
#     if { [::GidUtils::VersionCmp 7.4.1b] >= 0 } { 
#         set _MatName [DWGetCurrentMaterial $GDN] 
#     } else {
#         upvar \#0 $GDN GidData
#         set _MatName [DWSpace2Under $GidData(MAT,matname)] ;#deprecated
#     }
#     #set MatName $GidData(MAT,matname)
#     #set _MatName [DWSpace2Under $MatName]
#     set book [.central.s info Materials $_MatName BOOK]
#    
#     WarnWin [= "This material cannot be unassign"]
# }

proc RamSeriesCancelResults {} {

    set dir [lindex [.central.s info Project] 1].gid
    set basename [file tail [lindex [.central.s info Project] 1]]

    set file1 [file join $dir $basename.flavia.res]
    if { ![file exists $file1] } {
	WarnWin [= "There are no results"]
	return
    }
    set size [file size $file1]

    foreach i [list .dat .flavia.msh .err .war .info .detailed.xml] {
	if { [file exists [file join $dir $basename$i]] } {
	    incr size [file size [file join $dir $basename$i]]
	}
    }
    set size [expr int($size/1024)]
    
    set txt [= "Do you want to cancel results (size=%s Kb)?" $size]
    set retval [tk_messageBox -default ok -icon question -message $txt -type okcancel]
    if { $retval == "cancel" } { return }
    file delete $file1 [file join $dir password.txt]
    foreach i [list .dat .flavia.msh .err .war .info .detailed.xml] {
	file delete [file join $dir $basename$i]
    }
}

# proc ComunicateWithGiD { op args } {
#     
#     switch $op {
#         "INIT" {
#             set PARENT [lindex $args 0]
#             upvar      [lindex $args 1] ROW
#             set GDN [lindex $args 2]
#               set STRUCT [lindex $args 3]
#             set f [frame $PARENT.f]
#             Function::initwindow $f 
#             grid $f -row $ROW -col 0 -sticky nsew -columnspan 2 -pady 3 -padx 2
#             grid rowconf $PARENT $ROW -weight 1
#             grid columnconf $PARENT 1 -weight 1
#             upvar \#0 $GDN GidData
#              if { $GidData($STRUCT,VALUE,3) != "#N# 1 none" } {
#                   Function::getvalues $GidData($STRUCT,VALUE,3)
#              }
#              return ""
#          }
#          "SYNC" {
#             set GDN [lindex $args 0]
#               set STRUCT [lindex $args 1]
#             set values [Function::dump]
#             
#             DWLocalSetValue $GDN $STRUCT  "Table_Interpolation_Values:" $values
#             return ""
#         }
#     }
# }

namespace eval Full_anisotropic_shell {}

proc Full_anisotropic_shell::ComunicateWithGiD { op args } {
    switch $op {
	"INIT" {
	    set PARENT [lindex $args 0]
	    upvar [lindex $args 1] ROW
	    set GDN [lindex $args 2]
	    set STRUCT [lindex $args 3]
	    set cmd "GidOpenMaterials Full_anisotropic_shell"
	    set b [Button $PARENT.btable -text [= "Create/Edit material"]  -helptext \
		    [= "Open a window to create or to edit the anisotropic material"] \
		    -command $cmd -state normal -bd 1 -padx 5]
	    grid $b -column 1 -row [expr $ROW+1] -sticky nw -pady 5
	    return  ""
	}
	"SYNC" {
	    set GDN [lindex $args 0]
	    set STRUCT [lindex $args 1]
	    upvar \#0 $GDN GidData 
	}
    }
}

namespace eval custom_data {}
proc custom_data::ComunicateWithGiD { op args } {
    variable data

    package require ncgi

    switch $op {
	"INIT" {
	    set PARENT [lindex $args 0]
	    upvar [lindex $args 1] ROW
	    set GDN [lindex $args 2]
	    set STRUCT [lindex $args 3]
	    
	    set lb [labelframe $PARENT.lb -text [= "TCL code"]]
	    ScrolledWindow $lb.sw -auto both -scrollbar both -bd 0
	    text $lb.sw.t -wrap none -bd 1
	    set data(text) $lb.sw.t
	    $lb.sw setwidget $lb.sw.t
	    button $lb.b -text [= "Edit"] -command [list custom_data::Edit $lb.sw.t] -bd 1 \
		-width 10
	    
	    grid $lb.sw -sticky nsew -padx 2 -pady 2
	    grid $lb.b -pady 3
	    grid rowconfigure $lb 0 -weight 1
	    grid columnconfigure $lb 0 -weight 1

	    grid $lb -row $ROW -column 0 -sticky nsew -columnspan 2 -pady 3 -padx 2
	    grid rowconf $PARENT $ROW -weight 1
	    grid columnconf $PARENT 1 -weight 1

	    set tcl_code_enc [DWLocalGetValue $GDN $STRUCT tcl_code]
	    if { $tcl_code_enc ne "+" } {
		$lb.sw.t insert end [::ncgi::decode $tcl_code_enc]
	    }
	    return  ""
	}
	"SYNC" {
	    set GDN [lindex $args 0]
	    set STRUCT [lindex $args 1]
	    upvar \#0 $GDN GidData 
	    set tcl_code [string trim [$data(text) get 1.0 end]]
	    if { $tcl_code eq "" } { set tcl_code " " }
	    set tcl_code_enc [string map [list %0D ""] [::ncgi::encode $tcl_code]]
	    set old_code_enc [DWLocalGetValue $GDN $STRUCT tcl_code]
	    if { $tcl_code_enc ne $old_code_enc } {
		DWLocalSetValue $GDN $STRUCT tcl_code $tcl_code_enc
	    }
	}
    }
}

proc custom_data::Edit { text } {
    if { ![interp exists ramdebugger] } { interp create ramdebugger }
    ramdebugger eval [list set argv [list -noprefs -rgeometry 500x250 -onlytext]]
	
    set err [catch { package require RamDebugger }]
    if { $err } {
	WarnWin [_ "Package RamDebugger is not installed"]
	return
    }
    set data [string trim [$text get 1.0 end]]
    interp alias ramdebugger EditEndInRamDebugger "" custom_data::EditEndInRamDebugger $text
    ramdebugger eval [list RamDebugger::OpenFileSaveHandler "*custom data*" \
	    $data EditEndInRamDebugger]
}

proc custom_data::EditEndInRamDebugger { text name data } {
    
    set name [string trim $name *]
    if { ![winfo exists $text] } {
	WarnWin [= "RamDebugger out of sync. Data not saved"]
	return
    }
    $text delete 1.0 end
    $text insert end [string trim $data]
}

proc custom_data::ComunicateWithGiD_load { op args } {
    switch $op {
	"INIT" {
	    set PARENT [lindex $args 0]
	    upvar [lindex $args 1] ROW
	    set GDN [lindex $args 2]
	    set STRUCT [lindex $args 3]
	    set cmd "GidOpenMaterials Custom_data"
	    set b [Button $PARENT.btable -text [= "Create/Edit custom data"]  -helptext \
		    [= "Open a window to create or to edit the TCL code"] \
		    -command $cmd -state normal -bd 1 -padx 5]
	    grid $b -column 1 -row [expr $ROW+1] -sticky nw -pady 5
	    return  ""
	}
	"SYNC" {
	    set GDN [lindex $args 0]
	    set STRUCT [lindex $args 1]
	    upvar \#0 $GDN GidData 
	}
    }
}

proc DisplayLocalAxes {type} {

    set cur_anal [.gid.central.s info post get cur_analisis]
    set cur_step [.gid.central.s info post get cur_step $cur_anal] 
    set step0 "0"
	
    .central.s process escape escape escape escape Results AnalysisSel $cur_anal $step0 \
	    escape escape

    if {$type=="shell"} {
	.central.s process escape escape escape escape DisplayStyle HiddenBound escape escape
	.central.s process escape escape escape escape Results DisplayVectors Local_Axes "All"     
    } elseif {$type=="beam"} {
	.central.s process escape escape escape escape Results DisplayVectors Local_Axes_Beam "All" 
    }

    .central.s process escape escape escape escape Results AnalysisSel $cur_anal $cur_step \
	    escape escape

}


