*RealFormat "%.6g"
*IntFormat "%7i"
problem type *GenData(Problem_type)
analysis_type *GenData(Analysis_Type)
*if(strcmp(GenData(Analysis_Type),"Linear_Dynamic")==0)
*#****************LINEAR DYNAMIC ANALYSIS
dynamic_analysis_type *GenData(Dynamic_Analysis_Type)
*# Modal Analysis data
*if(strcmp(GenData(Dynamic_Analysis_Type),"Modal_Analysis")==0)
number_of_modes *GenData(Number_of_Modes)
eigen_max_iter *GenData(Eigensolver_max_iterations)
deltat *GenData(DeltaT)
number_of_steps *GenData(Number_of_steps)
matrix_storage *GenData(Matrix_storage)
damping_type *GenData(Damping_Type)
*if(strcmp(GenData(Damping_Type),"Rayleigh_Damping")==0)
alpha_m *GenData(Alpha_M)
*if((strcmp(GenData(Alpha_K),"0")!=0) && (strcmp(GenData(Matrix_storage),"Lumped")==0))
alpha_k 0.0
*else
alpha_k *GenData(Alpha_K)
*endif
*endif
*if(strcmp(GenData(Damping_Type),"Modal_Damping")==0)
damping_ratio *GenData(Damping_ratio)
*endif
output_step *GenData(Output_Step)
intial_conditions *GenData(Initial_Conditions:)
*if((strcmp(GenData(Write_Displacements),"no")==0) && (strcmp(GenData(Write_Velocities),"no")==0) && (strcmp(GenData(Write_Accelerations),"no")==0) )
*if((strcmp(GenData(Write_Strengths),"no")==0)  && (strcmp(GenData(Write_Reactions),"no")==0) )
*MessageBox error: It is necesary to write one dynamic result at least.
*endif
*endif
write_displacements *Gendata(Write_Displacements)
write_rotations no
write_velocities *Gendata(Write_Velocities)
write_accelerations *Gendata(Write_Accelerations)
write_strengths *Gendata(Write_Strengths)
write_reactions *Gendata(Write_Reactions)
*endif
*# Direct integration data
*if(strcmp(GenData(Dynamic_Analysis_Type),"Direct_Integration")==0)
deltat *GenData(DeltaT)
number_of_steps *GenData(Number_of_steps)
gamma *GenData(Gamma)
beta  *GenData(Beta)
matrix_storage *GenData(Matrix_storage)
damping_type *GenData(Damping_Type)
*if(strcmp(GenData(Damping_Type),"Rayleigh_Damping")==0)
alpha_m *GenData(Alpha_M)
*if((strcmp(GenData(Alpha_K),"0")!=0) && (strcmp(GenData(Matrix_storage),"Lumped")==0))
alpha_k 0.0
*else
alpha_k *GenData(Alpha_K)
*endif
*endif
*if(strcmp(GenData(Damping_Type),"Modal_Damping")==0)
*MessageBox error: Only Rayleigh Damping is allowed for Direct Integration.
*endif
output_step *GenData(Output_Step)
intial_conditions *GenData(Initial_Conditions:)
*if((strcmp(GenData(Write_Displacements),"no")==0) && (strcmp(GenData(Write_Velocities),"no")==0) && (strcmp(GenData(Write_Accelerations),"no")==0) )
*if((strcmp(GenData(Write_Strengths),"no")==0)  && (strcmp(GenData(Write_Reactions),"no")==0) )
*MessageBox error: It is necesary to write one dynamic result at least.
*endif
*endif
write_displacements *Gendata(Write_Displacements)
write_rotations no
write_velocities *Gendata(Write_Velocities)
write_accelerations *Gendata(Write_Accelerations)
write_strengths *Gendata(Write_Strengths)
write_reactions *Gendata(Write_Reactions)
*endif
*# Spectrum Analysis data
*if(strcmp(GenData(Dynamic_Analysis_Type),"Spectrum_Analysis")==0)
number_of_modes *GenData(Number_of_Modes)
eigen_max_iter *GenData(Eigensolver_max_iterations)
matrix_storage *GenData(Matrix_storage)
damping_type *GenData(Damping_Type)
damping_ratio *GenData(Damping_ratio)
spectrum_analysis_type *GenData(Spectrum_Analysis_type)
*if(strcmp(GenData(Spectrum_Analysis_type),"User_defined_spectrum")==0)
*set var n=GenData(Spectrum_Table,INT)
*if(*n>2)
begin_spectral_table
*for(i=1;i<=n/2;i=i+1)
*set var col1=(i-1)*2+1
*set var col2=(i-1)*2+2
*set var col1new=i*2+1
*if(i<n/2)
*set var t=GenData(Spectrum_Table,*col1,real)
*set var tnew=GenData(Spectrum_Table,*col1new,real)
*if(t(real)>=tnew(real))
*MessageBox error: The periods in the spectrum table must be give in ascending order.
*endif
*endif
*GenData(Spectrum_Table,*col1) *GenData(Spectrum_Table,*col2)
*endfor
end_table
jx *GenData(Spectrum_direction_nx)
jy *GenData(Spectrum_direction_ny)
jz *GenData(Spectrum_direction_nz)
*else
*MessageBox error: The spectrum table must have two rows at least.
*endif
*elseif(strcmp(GenData(Spectrum_Analysis_type),"Seismic_codes")==0)
*if(strcmp(GenData(Code_type),"NCSE-94_Spain_Code")==0)
code_type NCSE-94
design_acceleration *GenData(Design_Seismic_Acceleration)
jx *GenData(Seismic_direction_nx)
jy *GenData(Seismic_direction_ny)
jz *GenData(Seismic_direction_nz)
c *GenData(Soil_coefficient)
k *GenData(Contribution_coefficient)
ductility *GenData(Ductility)
*else
*MessageBox error: Other codes are not still availables.
*endif
*endif
*endif
*elseif(strcmp(GenData(Analysis_Type),"Non-Linear_Static")==0)
*#****************NON LINEAR STATIC ANALYSIS
factor_incremental *GenData(Delta_Fac)
number_increments *GenData(Num_inc)
automatic_increment *GenData(Automatic_inc)
*if(strcmp(GenData(Automatic_inc),"Yes")==0)
number_iteration_desider  *GenData(Num_Iter_d)
maxim_load_increment  *GenData(DeltaP_max)
minim_load_increment  *GenData(DeltaP_min)
*endif
control_type *GenData(Control)
*if(strcmp(GenData(Control),"Arc-lenght_Control")==0)
desired_length_inc *GenData(DeltaL_d)
max_lenght_inc *GenData(DeltaL_max)
min_length_inc *GenData(DeltaL_min)
*endif
convergence_tolerance_fact *GenData(Conv._tolerance_static)
iteration_type *GenData(Iteration_type)
maximun_iter_number *GenData(Max_iter)
line_search *GenData(Line-Search)
*if(strcmp(GenData(Line-Search),"Yes")==0)
max_num_ls_loops *GenData(LS-loops)
tolerance_ls *GenData(LS-toler)
min_step_length *GenData(LS-min)
max_step_length *GenData(LS-max)
max_amplitude *GenData(Amp-max)
*endif
auto_arc_switch *GenData(Auto-ARC-switch)
*if(strcmp(GenData(Auto-ARC-switch),"Yes")==0)
desired_current_stiffness *GenData(C_Stif)
*endif
*elseif(strcmp(GenData(Analysis_Type),"Non-Linear_Dynamic")==0)
*#****************NON LINEAR DYNAMIC ANALYSIS
*if(strcmp(GenData(Integration_method),"Implicit")==0)
integration_method implicit
t_0 *GenData(T_0)
*set var numfil(int)=GenData(DeltaT_variation:,int)/2
*if(numfil==0)
*MessageBox error: At least must be one datum
*endif
*set var Totnumbstep(int)=0
*for(ifil=1;ifil<=numfil;ifil=ifil+1)
*set var col1=(ifil-1)*2+1
*set var col2=(ifil-1)*2+2
*set var Totnumbstep=Totnumbstep+GenData(DeltaT_variation:,*col1,int)
*end for
deltat_groups *numfil
*for(ifil=1;ifil<=numfil;ifil=ifil+1)
*set var col1=(ifil-1)*2+1
*set var col2=(ifil-1)*2+2
*set var NUMSTEP=GenData(DeltaT_variation:,*col1,int)
*set var DELTAT=GenData(DeltaT_variation:,*col2,real)
   *NUMSTEP *DELTAT  
*end for
number_of_steps *Totnumbstep
gamma *GenData(Gamma:)
beta  *GenData(Beta:)
matrix_storage *GenData(Matrix-storage)
intial_conditions *GenData(Initial_Conditions)
*if(strcmp(GenData(Initial_Conditions),"Comb._Load_1")==0)
Comb_Load_1_data *GenData(Comb._Load_1_data)
*endif
alpha_m *GenData(Alpha_M:)
alpha_k *GenData(Alpha_K:)
convergence_tolerance_fact *GenData(Conv._tolerance_dynamic)
iteration_type *GenData(Iteration-type)
maximun_iter_number *GenData(Max-iter)
output_step *GenData(Output_Step)
*if((strcmp(GenData(Write_Displacements),"no")==0) && (strcmp(GenData(Write_Velocities),"no")==0) && (strcmp(GenData(Write_Accelerations),"no")==0) )
*if((strcmp(GenData(Write_Strengths),"no")==0)  && (strcmp(GenData(Write_Reactions),"no")==0) )
*MessageBox error: It is necesary to write one dynamic result at least.
*endif
*endif
write_displacements *Gendata(Write_Displacements)
write_rotations no
write_velocities *Gendata(Write_Velocities)
write_accelerations *Gendata(Write_Accelerations)
write_strengths *Gendata(Write_Strengths)
write_reactions *Gendata(Write_Reactions)
write_elemdamage *Gendata(Write_ElemDamage)
*elseif(strcmp(GenData(Integration_method),"Explicit")==0)
integration_method explicit
t_0 *GenData(T_0)
deltat *GenData(Delta_T)
number_of_steps *GenData(Number-of-steps)
matrix_storage lumped
intial_conditions *GenData(Initial_Conditions)
*if(strcmp(GenData(Initial_Conditions),"Comb._Load_1")==0)
Comb_Load_1_data *GenData(Comb._Load_1_data)
*endif
alpha_m *GenData(Alpha_M:)
alpha_k 0.0
output_step *GenData(Output_Step)
*if((strcmp(GenData(Write_Displacements),"no")==0) && (strcmp(GenData(Write_Velocities),"no")==0) && (strcmp(GenData(Write_Accelerations),"no")==0) )
*if((strcmp(GenData(Write_Strengths),"no")==0)  && (strcmp(GenData(Write_Reactions),"no")==0) )
*MessageBox error: It is necesary to write one dynamic result at least.
*endif
*endif
write_displacements *Gendata(Write_Displacements)
write_rotations no
write_velocities *Gendata(Write_Velocities)
write_accelerations *Gendata(Write_Accelerations)
write_strengths *Gendata(Write_Strengths)
write_reactions *Gendata(Write_Reactions)
write_elemdamage *Gendata(Write_ElemDamage)
*endif
*endif
yield_criterion *Gendata(Yield_criterion)

*set var dim=3
# meassure(SI) = fac** meassure(User defined)
units_names
N-m-kg        N    m  Pa       Kg     1.0       1.0      1.0      1.0
N-cm-kg       N   cm  N/cm2    Kg     1.0       1.0e-2   1.0e4    1.0
N-dm-kg       N   dm  N/dm2    kg     1.0       1.0e-1   1.0e2    1.0
N-mm-kg       N   mm  N/mm2    Kg     1.0       1.0e-3   1.0e6    1.0
Kp-cm-utm     Kp  cm  Kp/cm2   utm    1.0e1     1.0e-2   1.0e5    1.0e1
kN-m-MPa-ton  kN   m  Mpa      ton    1.0e3     1.0      1.0e6    1.0e3
end units_names
units_mesh *GenData(Mesh_units)
units_res *GenData(Results_units)

combined_load_cases
*if(strcmp(GenData(Activate_Load_Cases),"none")==0)
inactive
*else
active
*endif
*for(i=1;i<=GenData(Combined_load_cases,INT);i=i+3)
*set var im1=i+1
*set var im2=i+2
combined_load *\
name=*GenData(Combined_load_cases,*i) type=*\
*if(GenData(Combined_load_cases,*im1,INT)==1)
strengths
*else
deformation
*endif
*GenData(Combined_load_cases,*im2)
end combined_load
*endfor
end combined_load_cases

GravityDirection=*GenData(Gravity_X) *GenData(Gravity_Y) *GenData(Gravity_Z)
*if(strcmp(Gendata(Solver_type),"Automatic")==0)
solver=Automatic
*elseif(strcmp(Gendata(Solver_type),"SkyLine")==0)
solver=SkyLine
*elseif(strcmp(Gendata(Solver_type),"Sparse")==0)
solver=SparseToni *GenData(Solver_tolerance) *GenData(Solver_tolerance_minimum) *\
*GenData(Solver_max_iterations)
*elseif(strcmp(Gendata(Solver_type),"Sparse_Toni")==0)
solver=SparseToni *GenData(Solver_tolerance) *GenData(Solver_tolerance_minimum) *\
*GenData(Solver_max_iterations)
*endif
*if(GenData(Smooth_per_material,int)==1)
DoSmoothingMaterials
*endif
NewPostProcessFormat 1
*set cond Line-Contacts *elems
*Add cond Surface-Contacts *elems
*Add cond Volume-Contacts *elems
*set var ContactElements=CondNumEntities
*set cond Non_analysis_triangles *elems
*set var NumTriangleElems=CondNumEntities
*set cond Solid *elems
*set var NumSolidElems=CondNumEntities

*if(nelem(All)!=NumTriangleElems+NumSolidElems+ContactElements)
Number of total elements: *nelem(All)
Number of tetrahedra elements: *nelem(Tetrahedra)
Number of hexahedra elements: *nelem(Hexahedra)
Number of elements with condition solid: *CondNumEntities
Number of elements with condition Non_analysis_triangles: *NumTriangleElems
*MessageBox error: Some tetrahedras or hexahedras do not have properties condition assigned. Check file .dat for more information. Use command 'Data->Verify assigned properties'
*endif
*if(nelem(Tetrahedra)==0 && nelem(Hexahedra)==0)
*MessageBox error: There are no tetrahedras to calculate.
*endif
*#--------------------------------------------------------------------------------
*#      tetrahedra mesh
*#--------------------------------------------------------------------------------
*set var AreCoordsWritten(int)=0
*if(nelem(Tetrahedra))
*set elems(Tetrahedra)
mesh dimension = 3 elemtype Tetrahedra nnode = *nnode
coordinates
*loop nodes
*NodesNum *NodesCoord(1) *NodesCoord(2) *NodesCoord(3)
*end
end coordinates
*set var AreCoordsWritten=1
elements
*loop elems *OnlyInCond
*elemsnum *elemsConec *ElemsLayerNum Units=*cond(Units) E=*cond(E) nu=*cond(nu) *\
Weight=*cond(Specific_weight)
*end elems
end elements
*endif
*#--------------------------------------------------------------------------------
*#      hexahedra mesh
*#--------------------------------------------------------------------------------
*if(nelem(Hexahedra))
*set elems(Hexahedra)
mesh dimension = 3 elemtype Hexahedra nnode = *nnode
coordinates
*if(AreCoordsWritten==0)
*loop nodes
*NodesNum *NodesCoord(1) *NodesCoord(2) *NodesCoord(3)
*end
*endif
*set var AreCoordsWritten=1
end coordinates
elements
*loop elems *OnlyInCond
*elemsnum *elemsConec *ElemsLayerNum Units=*cond(Units) E=*cond(E) nu=*cond(nu) *\
Weight=*cond(Specific_weight)
*end elems
end elements
*endif
*#--------------------------------------------------------------------------------
*#      contact elements
*#--------------------------------------------------------------------------------
*if(nelem(linear))
*set elems(linear)
mesh dimension = 3 elemtype Contact nnode = *nnode
coordinates
*if(AreCoordsWritten==0)
*if(IsQuadratic)
*set cond Line-Contacts *elems
*Add cond Surface-Contacts *elems
*Add cond Volume-Contacts *elems
*loop elems *OnlyInCond
*set var nodo(int)=elemsconec(3)
*# nodo *NodesCoord(3,1) *NodesCoord(3,2) *NodesCoord(3,3)
*end elems
*endif
*endif
end coordinates
elements
*set cond Line-Contacts *elems
*Add cond Surface-Contacts *elems
*Add cond Volume-Contacts *elems
*loop elems *OnlyInCond
*elemsnum *elemsConec *ElemsLayerNum penalty=*cond(Penalty)
*end elems
end elements
*endif
*#--------------------------------------------------------------------------------
*#      Non_analysis_triangles mesh
*#--------------------------------------------------------------------------------
*set cond Non_analysis_triangles *elems
*if(nelem(Triangle))
*set elems(Triangle)
*if(IsQuadratic)
*set var nnodetri=6
*else
*set var nnodetri=3
*endif
mesh dimension = 3 elemtype Triangle nnode = *nnodetri
coordinates
end coordinates
elements
*loop elems *OnlyInCond
*elemsnum *elemsConec *ElemsLayerNum noop
*end elems
end elements
*endif
*set elems(All)
*#--------------------------------------------------------------------------------
*#  constraints
*#--------------------------------------------------------------------------------
constraints
*set cond Surface_Constraints
*add Cond Line_Constraints
*add Cond Point_Constraints
*loop nodes *OnlyInCond
*NodesNum *\
*for(ivar=2;ivar<=4;ivar=ivar+1)
*cond(*ivar)*\
*endfor
*format " %g %g %g "
*cond(X_Value,real)*cond(Y_Value,real)*cond(Z_Value,real)*\
 units=*cond(Units) *\
*if(LocalAxesNum)
*format " Euler1=%.15g Euler2=%.15g Euler3=%.15g"
*LocalAxesDef(EulerAngles)
*else

*endif
*end
end constraints
*set Cond Surface_Elastic_Constraints *CanRepeat
*if(CondNumEntities(int)>0)
elem_constraints
*loop elems *OnlyInCond
*# == 5 hexahedra
*if(ElemsType==5)
*if(LocalNodes(1)==1)
*if(LocalNodes(2)==2)
*set var iface=0
*elseif(LocalNodes(2)==4)
*set var iface=1
*else
*set var iface=2
*endif
*elseif(LocalNodes(1)==2)
*set var iface=3
*elseif(LocalNodes(1)==3)
*set var iface=4
*elseif(LocalNodes(1)==5)
*set var iface=5
*endif
*else
*set var iface=LocalNodes(1)-1
*endif
*ElemsNum *iface *\
*for(ivar=2;ivar<=4;ivar=ivar+1)
*if(strcmp(cond(*ivar),"1")==0)
2*\
*else
0*\
*endif
*endfor
*format " %g %g %g"
*cond(X_Value,real)*cond(Y_Value,real)*cond(Z_Value,real)*\
 units=*cond(Units) *\
*if(LocalAxesNum)
*format " Euler1=%.15g Euler2=%.15g Euler3=%.15g"
*LocalAxesDef(EulerAngles)
*else

*endif
*end
end elem_constraints
*endif
*set Cond Surface_NL_Elastic_Constraints
*if(CondNumEntities(int)>0)
elem_nl_elastic_constraints
*loop elems *OnlyInCond
*# == 5 hexahedra
*if(ElemsType==5)
*if(LocalNodes(1)==1)
*if(LocalNodes(2)==2)
*set var iface=0
*elseif(LocalNodes(2)==4)
*set var iface=1
*else
*set var iface=2
*endif
*elseif(LocalNodes(1)==2)
*set var iface=3
*elseif(LocalNodes(1)==3)
*set var iface=4
*elseif(LocalNodes(1)==5)
*set var iface=5
*endif
*else
*set var iface=LocalNodes(1)-1
*endif
*ElemsNum *iface *\
*for(ivar=2;ivar<=4;ivar=ivar+1)
*if(strcmp(cond(*ivar),"None")==0)
0*\
*else
2*\
*endif
*endfor
 *\
*for(ivar=2;ivar<=4;ivar=ivar+1)
*if(strcmp(cond(*ivar),"None")==0)
0*\
*elseif(strcmp(cond(*ivar),"Linear")==0)
1*\
*elseif(strcmp(cond(*ivar),"Comp_only")==0)
2*\
*elseif(strcmp(cond(*ivar),"Tensile_only")==0)
3*\
*elseif(strcmp(cond(*ivar),"Table")==0)
4*\
*endif
*endfor
*if(strcmp(cond(X_Constraint),"None")==0)
 0*\
*elseif(strcmp(cond(X_Constraint),"Table")==0)
*set var matID=matnum(cond(X_Table))
*set var tablenum=0
*loop materials *NotUsed
*if(strcmp(matprop(type),"table")==0)
*set var tablenum=tablenum+1
*if(matnum==matID)
*break
*endif
*endif
*end materials
 *tablenum(real)*\
*else
 *cond(X_Value,real)*\
*endif
*if(strcmp(cond(Y_Constraint),"None")==0)
 0*\
*elseif(strcmp(cond(X_Constraint),"Table")==0)
*set var matID=matnum(cond(Y_Table))
*set var tablenum=0
*loop materials *NotUsed
*if(strcmp(matprop(type),"table")==0)
*set var tablenum=tablenum+1
*if(matnum==matID)
*break
*endif
*endif
*end materials
 *tablenum(real)*\
*else
 *cond(Y_Value,real)*\
*endif
*if(strcmp(cond(Z_Constraint),"None")==0)
 0*\
*elseif(strcmp(cond(Z_Constraint),"Table")==0)
*set var matID=matnum(cond(Z_Table))
*set var tablenum=0
*loop materials *NotUsed
*if(strcmp(matprop(type),"table")==0)
*set var tablenum=tablenum+1
*if(matnum==matID)
*break
*endif
*endif
*end materials
 *tablenum(real)*\
*else
 *cond(Z_Value,real)*\
*endif
 units=*cond(Units) *\
*if(LocalAxesNum)
*format " Euler1=%.15g Euler2=%.15g Euler3=%.15g"
*LocalAxesDef(EulerAngles)
*else

*endif
*end
end elem_nl_elastic_constraints
*endif
*#--------------------------------------------------------------------------------
*#  masses
*#--------------------------------------------------------------------------------
*Set Cond Point-Mass *nodes
*if(CondNumEntities(int)>0)
nodal_point_mass
*loop nodes *OnlyInCond
*NodesNum *cond(Mass_x) *cond(Mass_y) *cond(Mass_z) *\
*cond(Mom_iner_x) *cond(Mom_iner_y) *cond(Mom_iner_x) *\
Units=*cond(Units)
*end
end nodal_point_mass
*endif
*Set Cond Surface-Solid-Mass *elems
*if(CondNumEntities(int)>0)
element_mass
surface_solid_mass
*loop elems *OnlyInCond
*elemsnum *cond(Surface_mass)  *\
Units=*cond(Units)
*end
end surface_solid_mass
end element_mass
*endif
*#--------------------------------------------------------------------------------
*#  static loads
*#--------------------------------------------------------------------------------
*loop intervals
*Set Cond Punctual_Load
*if(CondNumEntities(int)>0)
static_load
nodal_point_loads
*loop nodes *OnlyInCond
*NodesNum *cond(X_Force) *cond(Y_Force) *cond(Z_Force) *\
Units=*cond(Units) name=*IntvData(Interval_name)
*end
end nodal_point_loads
end static_load
*endif
*Set Cond Global_Pressure_Load *elems *CanRepeat
*if(CondNumEntities(int)>0)
static_load
global_pressure_loads
*loop elems *OnlyInCond
*# == 5 hexahedra
*if(ElemsType==5)
*if(LocalNodes(1)==1)
*if(LocalNodes(2)==2)
*set var iface=0
*elseif(LocalNodes(2)==4)
*set var iface=1
*else
*set var iface=2
*endif
*elseif(LocalNodes(1)==2)
*set var iface=3
*elseif(LocalNodes(1)==3)
*set var iface=4
*elseif(LocalNodes(1)==5)
*set var iface=5
*endif
*else
*set var iface=LocalNodes(1)-1
*endif
*ElemsNum *iface *cond(X_Pressure) *cond(Y_Pressure) *cond(Z_Pressure) *\
Units=*cond(Units) name=*IntvData(Interval_name)
*end
end global_pressure_loads
end static_load
*endif
*Set Cond Global_Projected_Pressure_Load *elems *CanRepeat
*if(CondNumEntities(int)>0)
static_load        
global_projected_pressure_loads
*loop elems *OnlyInCond
*# == 5 hexahedra
*if(ElemsType==5)
*if(LocalNodes(1)==1)
*if(LocalNodes(2)==2)
*set var iface=0
*elseif(LocalNodes(2)==4)
*set var iface=1
*else
*set var iface=2
*endif
*elseif(LocalNodes(1)==2)
*set var iface=3
*elseif(LocalNodes(1)==3)
*set var iface=4
*elseif(LocalNodes(1)==5)
*set var iface=5
*endif
*else
*set var iface=LocalNodes(1)-1
*endif
*elemsnum *iface *cond(X_Pressure) *cond(Y_Pressure) *cond(Z_Pressure) *\
Units=*cond(Units) name=*IntvData(Interval_name)
*end
end global_projected_Pressure_loads
end static_load
*endif
*Set Cond Local_Pressure_Load *elems *CanRepeat
*if(CondNumEntities(int)>0)
static_load
local_pressure_loads
*loop elems *OnlyInCond
*# == 5 hexahedra
*if(ElemsType==5)
*if(LocalNodes(1)==1)
*if(LocalNodes(2)==2)
*set var iface=0
*elseif(LocalNodes(2)==4)
*set var iface=1
*else
*set var iface=2
*endif
*elseif(LocalNodes(1)==2)
*set var iface=3
*elseif(LocalNodes(1)==3)
*set var iface=4
*elseif(LocalNodes(1)==5)
*set var iface=5
*endif
*else
*set var iface=LocalNodes(1)-1
*endif
*elemsnum *iface 0.0 0.0 *cond(Normal_inwards) *\
Units=*cond(Units) name=*IntvData(Interval_name)
*end
end local_pressure_loads
end static_load
*endif
*Set Cond Self_weight_solid
*if(CondNumEntities(int)>0)
static_load
self_weight_loads
*loop elems *OnlyInCond
*elemsnum name=*IntvData(Interval_name)
*end
end self_weight_loads
end static_load
*endif
*Set Cond Solid_triangular_Load *elems *CanRepeat
*if(CondNumEntities(int)>0)
static_load
triangular_global_loads
*loop elems *OnlyInCond
*# == 5 hexahedra
*if(ElemsType==5)
*if(LocalNodes(1)==1)
*if(LocalNodes(2)==2)
*set var iface=0
*elseif(LocalNodes(2)==4)
*set var iface=1
*else
*set var iface=2
*endif
*elseif(LocalNodes(1)==2)
*set var iface=3
*elseif(LocalNodes(1)==3)
*set var iface=4
*elseif(LocalNodes(1)==5)
*set var iface=5
*endif
*else
*set var iface=LocalNodes(1)-1
*endif
*elemsnum *iface *cond(X_pressure_1) *cond(Y_pressure_1) *\
*cond(Z_pressure_1) *cond(X_pressure_2) *cond(Y_pressure_2) *cond(Z_pressure_2) *\
p *cond(X_point_1) *cond(Y_point_1) *cond(Z_point_1) *cond(X_point_2) *cond(Y_point_2) *\
*cond(Z_point_2) *\
Units=*cond(Units) name=*IntvData(Interval_name) *\
*if(LocalAxesNum)
*format " Euler1=%.15g Euler2=%.15g Euler3=%.15g"
*LocalAxesDef(EulerAngles)
*else

*endif
*end
end triangular_global_loads
end static_load
*endif
*Set Cond Solid_hydrostatic_Load *elems *CanRepeat
*if(CondNumEntities(int)>0)
static_load
hydrostatic_loads
*loop elems *OnlyInCond
*# == 5 hexahedra
*if(ElemsType==5)
*if(LocalNodes(1)==1)
*if(LocalNodes(2)==2)
*set var iface=0
*elseif(LocalNodes(2)==4)
*set var iface=1
*else
*set var iface=2
*endif
*elseif(LocalNodes(1)==2)
*set var iface=3
*elseif(LocalNodes(1)==3)
*set var iface=4
*elseif(LocalNodes(1)==5)
*set var iface=5
*endif
*else
*set var iface=LocalNodes(1)-1
*endif
*elemsnum *iface *cond(Reference_coordinate) *cond(Self_weight_water) *\
Units=*cond(Units) name=*IntvData(Interval_name)
*end
end hydrostatic_loads
end static_load
*endif
*Set Cond Temperature *elems
*if(CondNumEntities(int)>0)
static_load
temperature_loads
*loop elems *OnlyInCond
*elemsnum *cond(\u03B1) *cond(\u0394T) name=*IntvData(Interval_name)
*end
end temperature_loads
end static_load
*endif
*Set Cond Tdyn_Strain *elems
*if(CondNumEntities(int)>0)
static_load
temperature_loads
*loop elems *OnlyInCond
*elemsnum 1.0 -1.0 name=*IntvData(Interval_name)
*end
end temperature_loads
end static_load
*endif
*end intervals
*#--------------------------------------------------------------------------------
*#  dynamic loads
*#--------------------------------------------------------------------------------
*loop intervals
*Set Cond Dynamic-Point_Load
*if(CondNumEntities(int)>0)
dynamic_loads
dynamic_nodal_point_loads
*loop nodes *OnlyInCond
*NodesNum *cond(X_Force) *cond(Y_Force) *cond(Z_Force) *\
Units=*cond(Units) name=*IntvData(Interval_name) *\
*if(strcmp(cond(Function),"Sine/Cosine_Load")==0 )
function=Armonic *\
freq=*cond(Circular_Freq) *\
phi=*cond(Phase_angle) *\
ti=*cond(Initial_Time) *\
tf=*cond(Final_Time)
*else
function=Table *\
tablename=*cond(Load_Table) *\
*set var tablenum=matnum(cond(Load_Table))-2
*format "%3d"
tablenum=*tablenum
*endif
*end
end dynamic_nodal_point_loads
end dynamic_loads
*endif
*Set Cond Dyn._Global_Pressure_Load *elems *CanRepeat
*if(CondNumEntities(int)>0)
dynamic_loads
dynamic_global_pressure_loads
*loop elems *OnlyInCond
*elemsnum *Operation(LocalNodes(1)-1) *cond(X_Pressure) *cond(Y_Pressure) *cond(Z_Pressure) *\
Units=*cond(Units) name=*IntvData(Interval_name) *\
*if(strcmp(cond(Function),"Sine/Cosine_Load")==0 )
function=Armonic *\
freq=*cond(Circular_Freq) *\
phi=*cond(Phase_angle) *\
ti=*cond(Initial_Time) *\
tf=*cond(Final_Time)
*else
function=Table *\
tablename=*cond(Load_Table) *\
*set var tablenum=matnum(cond(Load_Table))-2
*format "%3d"
tablenum=*tablenum
*endif
*end
end dynamic_global_pressure_loads
end dynamic_loads
*endif
*Set Cond Dyn._Local_Pressure_Load *elems *CanRepeat
*if(CondNumEntities(int)>0)
dynamic_load
dynamic_local_pressure_loads
*loop elems *OnlyInCond
*elemsnum *Operation(LocalNodes(1)-1) 0.0 0.0 *cond(Normal_inwards) *\
Units=*cond(Units) name=*IntvData(Interval_name) *\
*if(strcmp(cond(Function),"Sine/Cosine_Load")==0 )
function=Armonic *\
freq=*cond(Circular_Freq) *\
phi=*cond(Phase_angle) *\
ti=*cond(Initial_Time) *\
tf=*cond(Final_Time)
*else
function=Table *\
tablename=*cond(Load_Table) *\
*set var tablenum=matnum(cond(Load_Table))-2
*format "%3d"
tablenum=*tablenum
*endif
*end
end dynamic_local_pressure_loads
end dynamic_load
*endif
*end intervals
*#--------------------------------------------------------------------------------
*#    Initial Conditions
*#--------------------------------------------------------------------------------
*Set Cond Volumes_Initial_Conditions
*Add Cond Surfaces_Initial_Conditions
*Add Cond Lines_Initial_Conditions
*Add Cond Points_Initial_Conditions
*if(CondNumEntities(int)>0)
*if(strcmp(GenData(Analysis),"Linear_Static")==0  || strcmp(GenData(Analysis),"Non-Linear_Static")==0 )
*MessageBox error: The initial conditions are conditions only for dynamic analysis
*endif
*if(strcmp(GenData(Analysis),"Linear_Dynamic")==0)
*if(strcmp(GenData(Dynamic_Analysis_Type),"Spectrum_Analysis")==0)
*MessageBox error: The initial conditions are conditions only for Modal Analysis or Direct Integration.
*endif
*if(strcmp(GenData(Initial_Conditions:),"None")==0 || strcmp(GenData(Initial_Conditions:),"Comb._Load_1")==0)
*MessageBox error: For assign Initial_conditions to any entities the question Initial_Conditions: in Problem Data must be set to User_Defined.
*endif
*elseif(strcmp(GenData(Analysis),"Non-Linear_Dynamic")==0)
*if(strcmp(GenData(Initial_Conditions),"None")==0 || strcmp(GenData(Initial_Conditions),"Comb._Load_1")==0)
*MessageBox error: For assign Initial_conditions to any entities the question Initial_Conditions in Problem Data must be set to User_Defined.
*endif
*endif
initial_conditions
*loop nodes *OnlyInCond
*NodesNum *cond(Disp_x) *cond(Disp_y) *cond(Disp_z) *cond(Vel_x) *cond(Vel_y) *cond(Vel_z) Units=*cond(Units)
*end
end initial_conditions
*else
*if(strcmp(GenData(Analysis),"Linear_Dynamic")==0 || strcmp(GenData(Analysis),"Non-Linear_Dynamic")==0)
*if(strcmp(GenData(Initial_Conditions:),"User_Defined")==0 || strcmp(GenData(Initial_Conditions:),"User_Defined")==0)
*MessageBox error: Are not assign then Initial_conditions to any entities
*endif
*endif
*endif
*#--------------------------------------------------------------------------------
*#    Detailed results
*#--------------------------------------------------------------------------------
*set cond Detailed_results
*if(CondNumEntities>0)
detailed_results
*loop nodes *OnlyInCond
*NodesNum *cond(Id)
*end
end detailed_results
*endif
*#---------------------------------------------------------------------------------------
*# Tablas
*#---------------------------------------------------------------------------------------
*set var AreThereTables=0
*loop materials *NotUsed
*if(strcmp(matprop(Table),"1")==0)
*set var nreg=matprop(Table_Interpolation_Values,int)/2
*if(nreg!=0)
*set var AreThereTables=AreThereTables+1
*endif
*endif
*end materials
*loop materials *NotUsed
*if(strcmp(matprop(Table),"1")==0 && AreThereTables!=0)
*set var nreg=matprop(Table_Interpolation_Values,int)/2
*if(nreg>0)
table
tablename=*matprop(0) *\
*format "%3d"
nregistros=*nreg
*for(i=1;i<=nreg;i=i+1)
*if(strcmp(matprop(Table_Interpolation_Values,*i),"none")!=0)
*set var regt=(i-1)*2+1
*set var regf=regt+1
*matprop(Table_Interpolation_Values,*regt,real) *matprop(Table_Interpolation_Values,*regf,real)
*endif
*end for
end table
*endif
*endif
*end materials